/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.general;

import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.awt.Frame;
import java.awt.List;

public final class DebugMessages {

    private static PrintWriter LogFile = null;
    private static Frame LogWindow = null;
    private static List LogList = null;

    public static void SetLogFile (String logfilename) throws IOException {
        if (logfilename == null) return;
        if (logfilename.equals("")) return;

        LogFile = new PrintWriter(new FileOutputStream(logfilename),true);
    }
    public static void SetLogWindow (String title,int width, int height) {
        LogWindow = new Frame(title);
        LogList = new List(1,false);
        LogWindow.setSize(width,height);
        LogWindow.add(LogList);
        LogWindow.show();
    }
    public static void WriteMessage(String message) {
        if (message == null) return;
        if (LogFile != null)
            LogFile.println(message);
        if (LogWindow != null)
            LogList.add(message);
    }
}
