/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.rvexception;

/**
 * Title:        RVException
 * Description:  package of exceptions for Radview Java code
 * Copyright:    Copyright (c) 2001
 * Company:      Radview
 * @author Nira Shavitt
 * @version 1.0
 */

public class TestRVException {

  public TestRVException() {
  }

  public static void main(String[] args) {

    TestRVException testRVException = new TestRVException();
		try {
			testRVException.Inner1();
		}
		catch (RVRunTimeException e) {
			RVThrowable rvThrowable = new RVThrowable("Error", ErrorSeverity.ERROR, e);
			//String s = rvThrowable.stackTraceToString(e);
			String s = e.stackTraceToString();
			System.out.println("Result of stackTraceToString():\n"+s);
			s = e.ToString();
			System.out.println("Result of ToString():\n"+s);
		}
  }

	private void Inner1() throws RVRunTimeException
	{
		try {
			Inner2();
		}
		catch (RVRunTimeException e) {
			throw new RVRunTimeException("Inner1 Exception", ErrorSeverity.ERROR, e);
		}
	}

	private void Inner2() throws RVRunTimeException
	{
		throw new RVRunTimeException("Inner2 Exception", ErrorSeverity.ERROR,
															   new Exception("base exception in inner2"));
	}
}
