/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.util.testtalk;

// Constants used in TestTalk
final class TestTalkConstants {

    // Queue type
    protected static final byte DATAQ           = 0;
    protected static final byte CONTROLQ        = 1;
    protected static final byte ACKQ            = 2;

    // type statuses
    protected static final short SEND           = 2;
    protected static final short SEND_SUCCESS   = 102;
    protected static final short SEND_FAIL      = 103;
    protected static final short NEW_CONNECTION = 203;

    protected static final short KILL_YOURSELF  = 1000;

    // for comunication with c
    private static final char C_NULL_TERMINATOR_CHAR[] = {'\u0000'};
    protected static final String C_NULL_TERMINATOR = new String(C_NULL_TERMINATOR_CHAR);

    protected static int TIMEOUT_IN_MILISECONDS = 20000;
    protected static final int DEFAULT_PORT = 9000;

    // Debug switch. The switch is set in the init method of TestTalkC
    protected static boolean DEBUG_MODE = false;

    protected static final short VERSION = 0x7F04;
}
