/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package com.radview.wlutil;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Title:        Calling TVEnv from Java.
 * Copyright:    Copyright (c) 2002
 * Company:      Radview
 * @author Yahali Sherman
 * @version 1.0
 */

public class TVEnv {

	private static Log log = LogFactory.getLog(TVEnv.class);	
	private static TVEnv tvEnv = null;
	
	public native static String getTVEnvVar(String key);

	public static synchronized TVEnv getInstance(String binPath, String dllName){
		
		if (tvEnv == null ) {
						
			tvEnv = new TVEnv();
			dllName = binPath + java.io.File.separator + dllName;
			if (log.isDebugEnabled()) log.debug("TVEnv.getInstance: loading "+dllName + "...");
			System.load(dllName); // v:\bin\wljavautils
			if (log.isDebugEnabled()) log.debug(dllName + " was loaded");
		}
		
		return tvEnv;
	}
	
	public static synchronized TVEnv getInstance(){		
		return tvEnv;
	}
	
	public static void main(String[] args) throws Exception {

		System.out.println("Loading "+args[0]);
   	TVEnv tvEnv = TVEnv.getInstance(args[0], args[1]);				
		System.out.println("Converting "+args[1]);
		String result = tvEnv.getTVEnvVar(args[1]);		
		System.out.println("result = "+result);
	}
}
