/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_HTMLFUNCS__
#define __WL_HTMLFUNCS__


class RVCString;
class CWLDocument;

enum attribute {
	ACTION,
	ALT,
	BACKGROUND,
  CHARSET,
	CHECKED,
	CLASSID,
	CODE,
	CODEBASE,
	CODETYPE,
	COLS,
	COLSPAN,
	CONTENT,
	DATA,
	DYNSRC,
	ENCODING,
	ENCTYPE,
	EVENT,
	HEIGHT,
	HREF,
	HTTP_EQUIV,
	ID,
	LANGUAGE,
	LOWSRC,
	METHOD,
	NAME,
        REL,
	ROWSPAN,
	SRC,
	TARGET,
	TITLE,
	TYPE,
	UNCHECKED,
	USEMAP,
	VALUE,
	WIDTH,
	UNKNOWN
};

enum strVal{
	HTML_STRING_NOT_COMPLETE,
	HTML_STRING_COMPLETE
};

enum attState{
	HTML_READ_MORE_DATA,
	HTML_CURRENT_ATT_COMPLETE,
	HTML_FOUND_DELIMITER
};


enum elementReadState{
	READ_MORE,
	END_OF_ELEMENT,
	PARSE_ERROR
};

enum formElementState{
	FORM_INPUT,
	FORM_SELECT,
	FORM_SELECT_END,
	FORM_TEXTAREA,
	FORM_END,
	FORM_COMMENT,
	FORM_A_ANCHOR,
	FORM_AREA_ANCHOR,
	FORM_IMG,
	FORM_BGSOUND,
	FORM_EMBED,
	FORM_OBJECT,
	FORM_APPLET,
	FORM_SCRIPT,
	FORM_XML,
	FORM_OPTION,
	FORM_END_OPTION,
	FORM_TABLE,
	FORM_IFRAME_TAG,
	FORM_IFRAME_BODY,
	FORM_READ_MORE
};

enum formFlag{
	GET_ACTION_PROPERTIES,
	GET_INSTANCE,
	GET_INPUT,
	GET_TEXTAREA,
	GET_SELECT,
	GET_A_ANCHOR,
	GET_AREA_ANCHOR,
	GET_IMG,
	GET_BGSOUND,
	GET_EMBED,
	GET_OBJECT,
	GET_APPLET,
	GET_SCRIPT,
	GET_XML,
	GET_COMMENT,
	GET_TABLE,
	GET_IFRAME_TAG,
	GET_IFRAME_BODY,
	COMPLETE_ELEMENT
};
enum readStateE{
	START_APPEND,
	IN_BODY_TAG,
	IN_SCRIPT,
	IN_COMMENT,
	IN_TITLE,
	IN_BASE,
	IN_META,
	IN_HREF,
	IN_FORM,
	IN_AREA,
	IN_FRAME,
	IN_IFRAME_TAG,
	IN_IFRAME_BODY,
	IN_NOFRAME,
	IN_NOSCRIPT,
	IN_IMG,
	IN_BGSOUND,
	IN_EMBED,
	IN_OBJECT,
	IN_APPLET,
	IN_LINK,
	IN_STYLE,
	IN_TABLES,
	IN_XML
};

enum anchorType{
	A_ANCHOR,
	AREA_ANCHOR
};

enum tableParseStates{
	START_PARSE,
	IN_PARSE
};

enum tableParseResults{
	TABLE_READ_MORE,
	TABLE_PUSH_TABLE,
	TABLE_POP_TABLE,
	TABLE_START_TABLE
};


enum tableStates{
	NEW_TABLE,
	IN_TABLE,
	IN_TR,
	IN_TD,
	IN_TH
};

enum tableTagType{
	TABLE_START,
	TABLE_END,
	TR_START,
	TR_END,
	TD_START,
	TD_END,
	TH_START,
	TH_END,
	TAG_READ_MORE,
	TAG_CONTINUE
};


#ifdef __TV_UNIX__
#include <stdio.h>
#include <windows.h>
const char* _itoa(int i, char* buf, int size);
#endif
void			removeNewLine(RVCString& str, bool spaceReplace = true);
bool			findSpace(char& c);
size_t		findSpaceIndex(RVCString& buff, int startUrlIndex);
bool			htmlSkipWhiteSpaces(RVCString& buff, size_t buffLength, size_t& beginIndex);
bool			htmlIsWhiteSpace(char c);
strVal		htmlGetStringValue(RVCString& buff, RVCString& str, size_t beginIndex, size_t& startAttributsPtr, size_t& endAttributsPtr, size_t buffLength);
attState  htmlFindNextAttribute(RVCString& buff, RVCString& attributeName, RVCString& attributeValue,size_t& buffPtr, size_t& attValueStart);
bool			isElementOfType(const char* elementStr, size_t elementLength, RVCString& buff, char nextChar, CWLDocument *docPtr, bool CutBuffer = true);
elementReadState skipHtmlBlock(RVCString& tempBuff,const char *closingTag, size_t closingTagLength, CWLDocument *docPtr);
void Html2Text(RVCString &buff,int start_ptr,int end_ptr,RVCString &innerText);
void C_Html2Text(const char *c_data,int start_ptr,int end_ptr,RVCString &innerText);
bool isHttpProtocol(const RVCString &url);
attribute kindOfAttribute(RVCString& attrName);
void crash_func();

#endif

