/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_SCRIPT__
#define __WL_SCRIPT__
#include <collectable.h>
#include "platform.h"
#include "wltransactiondata.h"

class RWSCtring;
class CWLDocument;

class  DllExport CWLScript:public RVCollectable{
public:
	CWLScript(CWLDocument* docPtr);
	virtual ~CWLScript(){}
private:
	RVCString m_Text;
	RVCString m_Id;
	RVCString m_Src;
	RVCString m_Event;
	RVCString m_Language;
	long m_Index;
	CWLDocument* m_DocPtr;
    CWLTransactionsObject m_TransObj ;

public:
	void	SetText(const char* text);
	void	SetId(const char* id);
	void	SetSrc(const char* src);
	void	SetEvent(const char* event);
	void	SetLanguage(const char* language);
	const char* GetText();
	const char* GetInnerHTML();
	size_t GetTextLength();
	const char* GetId();
	const char* GetSrc();
	const char* GetEvent();
	const char* GetLanguage();
	void	printAll();
	CWLTransactionsObject* GetTransactionObj(){return &m_TransObj;}

	RVCString m_OriginalUrl;
	RVCString m_Referrer;

	RVCString& GetReferrer()    { return m_Referrer; }
	RVCString& GetOriginalUrl() { return m_OriginalUrl;  }
	long       GetIndex()       { return m_Index; }

protected:
  int m_iUrlOffset;
public:
  void setUrlOffset(int uo) { m_iUrlOffset = uo; }
  int  getUrlOffset() { return m_iUrlOffset; }

};
#endif
