/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_URL_BASE__
#define __WL_URL_BASE__


#include <RVCString.h>
#include "platform.h"

//===========================URLBASE======================================
class DllExport urlBase
{
private:  
  RVCString m_base;			//! -->full url:http://www.radview.com/subdir1/subdir2/file.html
  RVCString m_protocol;		//! -->http:// https:// ftp://
  RVCString m_host;			//! -->www.radview.com
  //RVCString port;			// -->host:port
  //RVCString uri;			// -->path + file
  RVCString m_path;			//! -->/subdir1/subdir2/
  RVCString m_file;			//! -->file.html
  //RVCString hash;			// -->......#"..."

  int  m_subDirCount ;
  bool m_Parsed;

public:  
  urlBase();//! {host= "";path= "";}
  virtual ~urlBase() {}

  //RVCString returnFile(){return file;}
  RVCString& returnBase(){return m_base;}
  RVCString calcUrl(RVCString& );
  int		setBase(const RVCString& );  //! must be by value.
  int		parse();  //! must be by value.
};
#endif
