/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlregularexpressions.h"
#include <regexp.h>
//#include <iostream.h>
#include "wlheaders.h"

CWLHeaders::CWLHeaders(const char* headersString)
{
	RVCString headers(headersString);
  if((headersString != NULL) && (headers != ""))		
    if(findAndInsertHeaders(headers))
    {
      //!error
    }
		
}

int CWLHeaders::findAndInsertHeaders(RVCString& headers)
{
	RVCRegexp newLine("[\n\r]+");
  RVCString key, value;
  size_t  strPtr=0, spPtr;
  size_t headersLen = headers.length();
  while(headers[strPtr] == ' ' || headers[strPtr] == '\n' || headers[strPtr] == '\r')
    ++strPtr;
  do
  {
  if((spPtr = headers.index(":",strPtr)) != RV_NPOS)
    key = headers(strPtr, spPtr - strPtr);
  else
    return -1; //!error
  strPtr = spPtr + 2;
  if((spPtr = headers.index(newLine, strPtr)) != RV_NPOS)
    value = headers(strPtr, spPtr - strPtr);
  else
    return -2; //!error  
  
  insertKeyAndValue(key.data(), value.data());    
  
  strPtr = spPtr;
  while(strPtr < headersLen && (headers[strPtr] =='\n' || headers[strPtr] == '\r'))
      ++strPtr;
  }   
  
  while(strPtr < headersLen);
  return 0;
}


void CWLHeaders::printAll()
{
	size_t entry = entries();
	if (entry != RV_NPOS)
		for(size_t index=0;index < entry; ++index)		
			cout<<"header("<<index<<"):   "<<Key(index)<<"  value:    "<<Value(index)<<endl;
	else
		cout<<"NO headers, or NULL, or EMPTY or ERROR"<<endl;
}
