/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "domitem.h"
#include <stdio.h>



int main(int argc, char *argv[])
{
  int answer,id,itemId,i;
  int len;
  char newfilename[80],filename[80],key[80],loc[80],frame[800],yn[10];
  const char *data;
  
  CWLExpectedDomRepository *rep = 0,*newrep = 0;
  CWLDomItem *item = 0;
  CWLItemFrame *fi;
  
  while(1)
  {
    cout << "1.  New Repository\n";
    cout << "2.  Open\n";
    cout << "3.  Save\n";
    cout << "4.  Add Item\n";
    cout << "5.  Get Item\n";
    cout << "6.  Print Repository\n";
    cout << "7.  New Item\n";
    cout << "8.  Add to Item\n";
    cout << "9.  Get from Item\n";
    cout << "10. Get Root from Item\n";
    cout << "11. Print Item\n";
		cout << "12. Convert exr to the new version\n";
    cout << "\n0. Exit\n";
    cout << "> ";
    cin >> answer;
    
    switch(answer)
    {
    case 1:
      rep = new CWLExpectedDomRepository();
      break;
      
    case 2:
      if( ! rep )
      {
        cout << "no repository\n";
        break;
      }
      
      cout << "File name: ";
      cin >> filename;
      if( !rep->open(filename) )
        cout << "error openning the file " <<filename << endl;
      break;
      
    case 3:
      if( ! rep )
      {
        cout << "no repository\n";
        break;
      }
      
      cout << "File name: ";
      cin >> filename;
      if( !rep->save(filename) )
        cout << "error Saving the file " <<filename << endl;
      break;
      
    case 4:
      if( ! item )
      {
        cout << "no item\n";
        break;
      }
      if( ! rep )
      {
        cout << "no repository\n";
        break;
      }
      cout<<"Item id:";
			cin>>itemId;
      id = rep->add(item,itemId);
      cout << "id = " << id <<endl;
      item = NULL;
      break;
      
    case 5:
      if( ! rep )
      {
        cout << "no repository\n";
        break;
      }
      
      cout << "Id: ";
      cin >> id;
      if( (item = rep->get(id)) == NULL )
        cout << "no item found\n";
      break;
      
    case 6:
      if( ! rep )
      {
        cout << "no repository\n";
        break;
      }
      rep->printAll();
      break;
      
    case 7:
      if( item )
        delete item;
      item = new CWLDomItem();
      break;
      
    case 8:
      if( ! item )
      {
        cout << "no item\n";
        break;
      }
      printf ("Url: ");
      gets(key);
      printf ("Loc: ");
      gets(loc);
      printf("Contents: ");
      gets(frame);
      printf("Root? (y/n) ");
      gets(yn);
/*
      cout << "Key: ";
      cin >> key;
      cout << "Frame content: ";
//      cin >> frame;
      gets(frame);
      cout << "Root? (y/n) ";
      gets( yn);
*/
      item->add(key,loc,frame,(*yn == 'y')?true:false);
      break;
      
    case 9:
      if( ! item )
      {
        cout << "no item\n";
        break;
      }
      cout << "Url: ";
      cin >> key;
      cout << "Loc: ";
      cin >> loc;
      if( (fi = item->get(key,loc)) == NULL )
      {
        cout << "nothing found\n";
        break;
      }
      else
        cout << fi->getSource() << endl;
      break;
      
    case 10:
      if( ! item )
      {
        cout << "no item\n";
        break;
      }
      if( (data = item->getRootUrl()) == NULL )
      {
        cout << "nothing found\n";
        break;
      }
      else
        cout << data << endl;
      break;
      
    case 11:
      if( ! item )
      {
        cout << "no item\n";
        break;
      }
      item->printAll();
      break;
    
		case 12:
			cout << "Old exr's file name: ";
      cin >> filename;
			cout << "New exr's file name: ";
      cin >> newfilename;
			if(!rep)
				rep = new CWLExpectedDomRepository();
			if( !rep->open(filename) )
        cout << "error openning the file " <<filename << endl;
			newrep = new CWLExpectedDomRepository();
      len = rep->length();
			for(i=1;i<=len;i++)
			{
				if( (item = rep->get(i)) == NULL )
					cout << "item "<<i<<" not found\n";
				else
					id = newrep->add(item,i);
			}
			if( !rep->save(newfilename) )
        cout << "error Saving the file " <<newfilename << endl;
			break;
    default:
      exit(0);
    }
  }
  return 0;
}


