/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "wlurl.h"
#include <stdio.h>



int main(int argc, char *argv[])
{
	RVOrdered *list = new RVOrdered();
	CWLUrl  *u,*v;
	char urlstring[200];
	char filename[80],c;
	FILE *fp;
	int ans,i;
	bool result;
	CWLUrlCmp *res;

	while( 1 )
	{
		cout << endl <<endl;
		cout << "1. Read, Analyeze & Print URL" << endl;
		cout << "2. Read a URL and compare it against original URL" << endl;
		cout << "3. Read a list of URL from file" << endl;
		cout << "4. Read a URL and compare it against the List" << endl;
		cout << endl << "9. Exit" << endl << endl << "> ";

		cin >> ans;

		switch(ans)
		{
		case 1:
			cout << "url: ";
			cin >> urlstring;
			u = new CWLUrl();
			u->setHref(urlstring);
			list->insert(u);
			u->printAll();

			break;

		case 2:
			cout << "url: ";
			cin >> urlstring;
			v = new CWLUrl();
			v->setHref(urlstring);
			v->printAll();
			cout << endl << "check?";
			cin >> c;
			res = new CWLUrlCmp();
			result = u->urlCompare( *v, *res );
			cout << "Expected URL: " << u->Href() <<endl;
			cout << "Actual URL:   " << v->Href() <<endl;
			cout << "Result is  :" << result << endl;
			cout << "exactMatch :" << res->exactMatch << endl;
			cout << "hostMatch  :" << res->hostMatch << endl;
			cout << "uriMatch   :" << res->uriMatch << endl;
			cout << "extMatch   :" << res->extMatch << endl;
			cout << "searchMatch:" << res->searchMatch << endl;
			if( res->searchDiffs )
				cout << "Search Diffs:" << res->numDiffs << endl;
			cout << "RANK = " << res->rank() << endl;
			delete res;
			cout << endl << "continue?";
			cin >> c;
			delete v;

			break;

		case 3:
			cout << "insert file name : ";
			cin >> filename;
			if( (fp = fopen(filename,"r")) == NULL )
			{
				cout << "error openning " << filename << endl;
				break;
			}
			while ( fgets(urlstring,200,fp) != NULL )
			{
				int l = strlen(urlstring);
				if(urlstring[l-1] == '\n')
					urlstring[l-1] = '\0';
				u = new CWLUrl();
				u->setHref(urlstring);
				list->insert(u);
			}
			fclose(fp);
			for(i = 0 ; i < int(list->entries()) ; i++)
				cout << i+1 << ". " << ((CWLUrl *)(*list)[i])->Href() << endl;
			break;

		case 4:
			cout << "url: ";
			cin >> urlstring;
			u = new CWLUrl();
			u->setHref(urlstring);
			for(i = 0 ; i < int(list->entries()) ; i++)
			{
				res = new CWLUrlCmp();
				result = u->urlCompare( *((CWLUrl *)(*list)[i]), *res );
				cout << "Expected URL: " << u->Href() <<endl;
				cout << "Actual URL:   " << ((CWLUrl *)(*list)[i])->Href() <<endl;
				cout << "Result is  :" << result << endl;
				cout << "exactMatch :" << res->exactMatch << endl;
				cout << "hostMatch  :" << res->hostMatch << endl;
				cout << "uriMatch   :" << res->uriMatch << endl;
				cout << "extMatch   :" << res->extMatch << endl;
				cout << "searchMatch:" << res->searchMatch << endl;
				if( res->searchDiffs )
					cout << "Search Diffs:" << res->numDiffs << endl;
				cout << "RANK = " << res->rank() << endl;
				delete res;
				cout << endl << "continue?";
				cin >> c;
			}
			delete u;
			break;

		case 9:
			exit(0);
		}
	}
	return 0;
}


