/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/******************************************************************\
 *	File name : jsHttpNames.h
 *
 *	Author : Zion Menahem
 *
 *	Description : 
 *
 *	History : 
 *
 *	Modifications : 
 *		Who				When				What
 *		---				----				----
 *
\******************************************************************/

#ifndef _jshttpnames_h_
#define _jshttpnames_h_

/** include files **/

/** local definitions **/
// classes names
#define WLJSNAME_HTTP_CLASS			"WLHttp"
#define WLJSNAME_COOKIE_CLASS		"WLCookie"
#define WLJSNAME_CALLBACK_CLASS		"WLCallback"
#define WLJSNAME_HTML_CLASS			"WLHtml"
#define WLJSNAME_SSL_CLASS			"WLSSL"

// objects names (instances)
#define WLJSNAME_HTTP_OBJECT		"wlHttp"
#define WLJSNAME_LOCALS_OBJECT	"wlLocals"
#define WLJSNAME_GLOBAL_OBJECT	"wlGlobals"
#define WLJSNAME_HTML_OBJECT		"wlHtml"
#define WLJSNAME_SSL_OBJECT			"wlSsl"
#define WLJSNAME_COOKIE_OBJECT	"wlCookie"

// methods names
// WLHttp class
#define WLJSNAME_HTTP_HEAD					"Head"
#define WLJSNAME_HTTP_GET						"Get"
#define WLJSNAME_HTTP_POST					"Post"
#define WLJSNAME_HTTP_CONNECT 			"Connect"
#define WLJSNAME_HTTP_CLOSE_CONN		"CloseConnection"
#define WLJSNAME_DNS_CLEAR_CACHE		"ClearDNSCache"

enum HttpFuncs{
  HTTP_FUNCS_NONE,
  HTTP_FUNCS_HEAD,
  HTTP_FUNCS_GET,
  HTTP_FUNCS_POST
};

//Transactions
#define WLJSNAME_HTTP_INSERT_TRANSACTIONS  "InsertTransactions"
#define WLJSNAME_HTTP_ADD_EVENT            "AddEvent"
#define WLJSNAME_HTTP_SET_SEVERITY         "SetSeverity"
#define WLJSNAME_HTTP_SET_FAILURE_REASON   "SetFailureReason"
#define WLJSNAME_HTTP_FOLD_TRANSACTIONS_TREE "FoldTransactionsTree"
#define WLJSNAME_HTTP_SAVE_TRANSACTION     "SaveTransaction"

// methods names
// WLArray classes (i.e FormData, Headers, Data, DataFile)
#define WLJSNAME_HTTP_ARRAY_CLEAR					"wlClear"
#define WLJSNAME_HTTP_ARRAY_SET				  	"wlSet"
#define WLJSNAME_HTTP_ARRAY_GET				  	"wlGet"

// WLCookie class
#define WLJSNAME_COOKIE_SET					"Set"
#define WLJSNAME_COOKIE_DELETE			"Delete"
#define WLJSNAME_COOKIE_CLEAR				"ClearAll"

// WLCallback class
#define WLJSNAME_CALLBACK_PAGE_START_DOWNLOAD			"PageStartDownload"
#define WLJSNAME_CALLBACK_PAGE_END_DOWNLOAD				"PageEndDownload"
#define WLJSNAME_CALLBACK_PAGE_ABORT_DOWNLOAD			"PageAbortDownload"
#define WLJSNAME_CALLBACK_OBJECT_START_DOWNLOAD			"ObjectStartDownload"
#define WLJSNAME_CALLBACK_OBJECT_END_DOWNLOAD			"ObjectEndDownload"
#define WLJSNAME_CALLBACK_OBJECT_ABORT_DOWNLOAD			"ObjectAbortDownload"
#define WLJSNAME_CALLBACK_OBJECT_ADD_REQUEST_HEADER		"AddRequestHeader"
#define WLJSNAME_CALLBACK_OBJECT_ADD_RESPONSE_HEADER	"AddResponseHeader"
#define WLJSNAME_CALLBACK_OBJECT_ADD_LOCATION			"AddLocation"
#define WLJSNAME_CALLBACK_OBJECT_SET_URL				"SetUrl"
#define WLJSNAME_CALLBACK_OBJECT_SET_CONTENT			"SetContent"
#define WLJSNAME_CALLBACK_OBJECT_RESET					"Reset"

// WLHtml class
#define WLJSNAME_HTML_GET_FRAME_BY_INDEX				"GetFrameByIndex"
#define WLJSNAME_HTML_GET_FRAME_BY_URL					"GetFrameByUrl"
#define WLJSNAME_HTML_GET_FRAME_BY_LOCATION			"GetFrameByLocation"
#define WLJSNAME_GET_IDENT_LOCATION							"GetIdentLocation"
#define WLJSNAME_HTML_GET_FRAME_URL							"GetFrameUrl"
#define WLJSNAME_HTML_GET_LINK_BY_INDEX					"GetLinkByIndex"
#define WLJSNAME_HTML_GET_LINK_BY_NAME					"GetLinkByName"
#define WLJSNAME_HTML_GET_LINK_BY_URL						"GetLinkByUrl"
#define WLJSNAME_HTML_GET_FIELD_VALUE						"GetFieldValue"
#define WLJSNAME_HTML_GET_FIELD_VALUE_IN_FORM		"GetFieldValueInForm"
#define WLJSNAME_HTML_GET_QS_FIELD_VALUE				"GetQSFieldValue"
#define WLJSNAME_HTML_GET_FORM_ACTION						"GetFormAction"
#define WLJSNAME_HTML_GET_HEADER_VALUE					"GetHeaderValue"
#define WLJSNAME_HTML_GET_STATUS_NUMBER					"GetStatusNumber"
#define WLJSNAME_HTML_GET_STATUS_LINE						"GetStatusLine"
#define WLJSNAME_HTML_GET_HOST									"GetHost"
#define WLJSNAME_HTML_GET_HOST_NAME							"GetHostName"
#define WLJSNAME_HTML_GET_PORT_NUM							"GetPortNum"
#define WLJSNAME_HTML_GET_URI										"GetUri"
// WLSSL class
#define WLJSNAME_SSL_CLEAR_CACHE		"ClearSSLCache"

// structures names (of WLHttp)
#define WLJSNAME_HTTP_FORMDATA_STRUCT	"FormData"
#define WLJSNAME_HTTP_HEADER_STRUCT		"Header"
#define WLJSNAME_HTTP_DATA_STRUCT			"Data"
#define WLJSNAME_HTTP_DATAFILE_STRUCT	"DataFile"

// variable & properties names

// WLHttp properties
#define WLJSNAME_HTTP_USER_NAME					"UserName"
#define WLJSNAME_HTTP_PASSWORD					"PassWord"
#define WLJSNAME_HTTP_NT_USERNAME				"NTUserName"
#define WLJSNAME_HTTP_NT_PASSWORD				"NTPassWord"
#define WLJSNAME_HTTP_PROXY							"Proxy"
#define WLJSNAME_HTTP_HTTPSPROXY				"HttpsProxy"
#define WLJSNAME_HTTP_PROXY_USER_NAME		"ProxyUserName"
#define WLJSNAME_HTTP_PROXY_PASSWORD		"ProxyPassWord"
#define WLJSNAME_HTTP_PROXY_NT_USER_NAME "ProxyNTUserName"
#define WLJSNAME_HTTP_PROXY_NT_PASSWORD	"ProxyNTPassWord"

#define WLJSNAME_HTTP_USE_SAME_PROXY4SSL	   "UseSameProxyForSSL"

#define WLJSNAME_HTTP_HTTPSPROXY_USER_NAME		"HttpsProxyUserName"
#define WLJSNAME_HTTP_HTTPSPROXY_PASSWORD		  "HttpsProxyPassWord"
#define WLJSNAME_HTTP_HTTPSPROXY_NT_USER_NAME "HttpsProxyNTUserName"
#define WLJSNAME_HTTP_HTTPSPROXY_NT_PASSWORD	"HttpsProxyNTPassWord"

#define WLJSNAME_HTTP_PARSE							"Parse"
#define WLJSNAME_HTTP_PARSE_FORMS				"ParseForms"
#define WLJSNAME_HTTP_PARSE_LINKS				"ParseLinks"
#define WLJSNAME_HTTP_PARSE_SCRIPTS			"ParseScripts"
#define WLJSNAME_HTTP_PARSE_TABLES			"ParseTables"
#define WLJSNAME_HTTP_PARSE_XML					"ParseXML"
#define WLJSNAME_HTTP_PARSE_METAS				"ParseMetas"
#define WLJSNAME_HTTP_PARSE_IMAGES			"ParseImages"
#define WLJSNAME_HTTP_PARSE_EMBEDS			"ParseEmbeds"
#define WLJSNAME_HTTP_PARSE_APPLETS			"ParseApplets"
#define WLJSNAME_HTTP_PARSE_CSS					"ParseCss"
#define WLJSNAME_HTTP_PARSE_OTHERS			"ParseOthers"
#define WLJSNAME_HTTP_PARSE_ONCE				"ParseOnce" // Chaim - ParseOnce
#define WLJSNAME_HTTP_PARSE_FULL_BUFFER	"ParseFullBuffer"
#define WLJSNAME_HTTP_GET_FRAMES        "GetFrames"
#define WLJSNAME_HTTP_GET_IMAGES        "GetImages"
#define WLJSNAME_HTTP_GET_EMBEDS        "GetEmbeds"
#define WLJSNAME_HTTP_GET_APPLETS       "GetApplets"
#define WLJSNAME_HTTP_GET_SCRIPTS       "GetScripts"
#define WLJSNAME_HTTP_GET_CSS           "GetCss"
#define WLJSNAME_HTTP_GET_XML           "GetXML"
#define WLJSNAME_HTTP_GET_OTHERS        "GetOthers"
#define WLJSNAME_HTTP_CLIENT_TYPE       "ClientType"
#define WLJSNAME_HTTP_SAVE_SOURCE       "SaveSource"
#define WLJSNAME_HTTP_CONVERT_TO_UTF8   "ConvertToUTF8ForParse"
#define WLJSNAME_HTTP_XML_STANDALONE		"XMLStandAlone"
#define WLJSNAME_HTTP_VERIFY_XML				"VerifyXML"
#define WLJSNAME_HTTP_KEEP_ALIVE        "KeepAlive"
// Checkpoint request - allow user intervention in Keep-Alive
#define WLJSNAME_HTTP_PERSISTANCY       "Persistency"
#define WLJSNAME_HTTP_CACHE_DNS					"DNSUseCache"
#define WLJSNAME_HTTP_MULTI_IP_SUPPORT	"MultiIPSupport"
#define WLJSNAME_HTTP_MULTI_IP_SUPPORT_TYPE	"MultiIPSupportType"
#define	WLJSNAME_HTTP_MULTI_IP_SUPPORT_PER_CLIENT	"PerClient"
#define	WLJSNAME_HTTP_MULTI_IP_SUPPORT_PER_ROUND	"PerRound"
#define WLJSNAME_HTTP_VERSION						"Version"
#define WLJSNAME_HTTP_URL								"Url"
#define WLJSNAME_HTTP_OUTFILE						"Outfile"
#define WLJSNAME_HTTP_ERASE							"Erase"
#define WLJSNAME_HTTP_TIMER_NAME				"UsingTimer"
#define WLJSNAME_HTTP_PROBING_CLIENT_THREADS	"ProbingClientThreads"
#define WLJSNAME_HTTP_LOAD_GENERATOR_THREADS	"LoadGeneratorThreads"
#define WLJSNAME_HTTP_RTAM_THREADS						"RTAMThreads"
#define WLJSNAME_HTTP_SLOW_CONN_RATE					"ConnectionSpeed"

//Galtech
#ifndef _ANSI_ONLY
// @@Chaim - remove these (CharEncoding)
//#define WLJSNAME_HTTP_CHARSET					"CharSet"
//#define WLJSNAME_HTTP_DOM_CHARSET		"DomCharset"
#define WLJSNAME_HTTP_ENFORCE_CHAR_ENCODING					"EnforceCharEncoding"
#endif

#define WLJSNAME_HTTP_USER_AGENT							  "UserAgent"
#define WLJSNAME_HTTP_ACCEPT_LANGUAGE						"AcceptLanguage"
#define WLJSNAME_HTTP_REDIRECTION_LIMIT				  "RedirectionLimit"
#define WLJSNAME_HTTP_REDIRECTION_ENABLED				"RedirectionEnabled"
#define WLJSNAME_HTTP_BROWSER_CACHE						  "BrowserCache"
#define WLJSNAME_HTTP_HTTP_CACHE_TYPE				    "HttpCacheType"
#define WLJSNAME_HTTP_HTTP_CACHE_SCOPE			    "HttpCacheScope"
#define WLJSNAME_HTTP_HTTP_CACHE_CACHED_TYPES   "HttpCacheCachedTypes"
#define WLJSNAME_HTTP_HTTP_CACHE_UNCACHED_TYPES "HttpCacheUncachedTypes"
#define WLJSNAME_HTTP_TARGET                    "wlTarget"
#define WLJSNAME_HTTP_REFERER                   "Referer"
#define WLJSNAME_HTTP_CONTENT_TYPE              "ContentType"

#define WLJSNAME_HTTP_EXPECTED_URL            "ExpectedUrl"

#define WLJSNAME_HTTP_SUB_TRANSACTIONS        "SubTransactions"
#define WLJSNAME_HTTP_TIMER_TRANSACTIONS      "TimerTransactions"
#define WLJSNAME_HTTP_TRANSACTION_TIME        "TransactionTime"
#define WLJSNAME_HTTP_TIMEOUT_SEVERITY        "TimeoutSeverity"

#define WLJSNAME_HTTP_VERIFICATION            "Verification"
#define WLJSNAME_HTTP_VER_SET_MAX_THREADS     "VerSetMaxThreads"
#define WLJSNAME_HTTP_VER_SET_MAX_ROUNDS      "VerSetMaxRounds"
#define WLJSNAME_HTTP_VER_SET_ROUNDS          "VerSetRounds"
#define WLJSNAME_HTTP_GET_IP_ADDRESS          "GetIPAddress"
#define WLJSNAME_HTTP_CHECK_FILE_CONTENT      "CheckFileContent"

#define WLJSNAME_HTTP_RVPRODUCT               "RVProduct"
#define WLJSNAME_HTTP_ACCEPT_ENCODING_GZIP    "AcceptEncodingGzip"


#define WLJSNAME_HTTP_DOC_COOKIE_EXPIRATION				"CookieExpiration"
#define WLJSNAME_HTTP_DOC_COOKIE_DOMAIN				    "CookieDomain"
#define WLJSNAME_HTTP_DOC_COOKIE_PATH				      "CookiePath"

// UnDocumented Http variables
#define WLJSNAME_HTTP_COOKIE_EXPIRATION				"UNDOC_CookieExpiration"
#define WLJSNAME_HTTP_COOKIE_DOMAIN				    "UNDOC_CookieDomain"
#define WLJSNAME_HTTP_COOKIE_PATH				      "UNDOC_CookiePath"
#define WLJSNAME_HTTP_AUTO_NAMED_TRANS        "AutomaticNamedTransaction"
#define WLJSNAME_HTTP_ASM_DIAGNOSTICS         "AsmDiagnostics"
#define WLJSNAME_HTTP_ASM_ON                  "AsmOn"
#define WLJSNAME_HTTP_REQUEST_RETRIES         "RequestRetries"
#define WLJSNAME_HTTP_RECEIVE_TIMEOUT         "ReceiveTimeout"
#define WLJSNAME_HTTP_ENCODE_FORMDATA         "EncodeFormdata"
#define WLJSNAME_HTTP_ESCAPE_CHAR			  "EscapeChar"
#define WLJSNAME_HTTP_LOW_LEVEL_UNESCAPE	  "EncodeBinary"
#define WLJSNAME_HTTP_DECODE_BINARY_NULL_AS   "DecodeBinaryNullAs"
#define WLJSNAME_HTTP_DECODE_BINARY_START	  "DecodeBinaryStart"
#define WLJSNAME_HTTP_DECODE_BINARY_END       "DecodeBinaryEnd"
#define WLJSNAME_HTTP_DELETE_EMPTY_COOKIES    "DeleteEmptyCookies"
#define WLJSNAME_HTTP_ENCODE_DATA             "EncodeData"
#define WLJSNAME_HTTP_REPORT_HTTP_ERRORS      "ReportHttpErrors"

#define WLJSNAME_HTTP_BUFFER_SIZE							"RecvBufferSize"
#define WLJSNAME_HTTP_SEND_BUFFER_SIZE			  "SendBufferSize"
#define WLJSNAME_HTTP_REQUEST_MULTI_PART_BUFFER_SIZE	"RequestMultiPartBufferSize"


#define WLJSNAME_HTTP_CONNECT_TIMEOUT               "ConnectTimeout"
#define WLJSNAME_HTTP_SELECT_WRITE_TIMEOUT          "SelectWriteTimeout"
#define WLJSNAME_HTTP_SELECT_WRITE_SECOND_TIMEOUT   "SelectWriteSecondTimeout"
#define WLJSNAME_HTTP_SELECT_WRITE_SWITCH_NUM       "SelectWriteSwitchNum"

#define	WLJSNAME_HTTP_SELECT_TIMEOUT					"SelectTimeout"
#define	WLJSNAME_HTTP_SELECT_SECOND_TIMEOUT		"SelectSecondTimeout"
#define WLJSNAME_HTTP_SELECT_SWITCH_NUM       "SelectSwitchNum"

// For overriding WebLOAD defaults

#define WLJSNAME_HTTP_OVERRIDE_HOST_DEFAULT								"OverrideHostDefault"
#define WLJSNAME_HTTP_OVERRIDE_COOKIE_DEFAULT							"OverrideCookieDefault"
#define WLJSNAME_HTTP_OVERRIDE_IF_MODIFIED_SINCE_DEFAULT  "OverrideIfModifiedSinceDefault"


// WLSSL properties
#define WLJSNAME_SSL_VERSION				  "SSLVersion"
#define WLJSNAME_SSL_USE_CACHE			  "SSLUseCache"
#define WLJSNAME_CERTIFICATE_FILE			"SSLClientCertificateFile"
#define WLJSNAME_CERTIFICATE_PASSWORD	"SSLClientCertificatePassword"
#define WLJSNAME_SSL_BIT_LIMIT				"SSLBitLimit"
#define WLJSNAME_SSL_CRYPTO_STRENGH   "SSLCryptoStrength"
// WLHtml properties
#define WLJSNAME_HTML_SAVE_SOURCE		"SaveSource"
#define WLJSNAME_HTML_SAVE_HEADERS		"SaveHeaders"

// Data & Datafile block names
#define WLJSNAME_TYPE								"Type"
#define WLJSNAME_VALUE							"Value"
#define WLJSNAME_FILENAME						"Filename"

//content types
#define WLJSNAME_HTML_CONTENT_TYPES   "HtmlContentTypes"
#define WLJSNAME_XML_CONTENT_TYPES    "XmlContentTypes"
#define WLJSNAME_RESPONSE_CONTENT_TYPES    "ResponseContentType"
#define WLJSNAME_REQUEST_CONTENT_MULTI_PART_BOUNDARY		 "RequestContentMultiPartBoundary"

// other properties
#define WLJSNAME_HTTP_FILTER_URL      "FilterUrl"

// global functions
#define WLJSNAME_CREATE_DOM			"CreateDOM"
#define WLJSNAME_CREATE_TABLE		"CreateTable"
#define WLJSNAME_CREATE_EXPECTED_DOM			"CreateExpectedDOM"
#define WLJSNAME_ENCODE_STRING	"EncodeString"

#define WLJSNAME_SSL_CIPHER_SUITE_COMMAND	"SSLCipherSuiteCommand"
#define WLJSNAME_SSL_ENABLE_CIPHER_NAME		"SSLEnableCipherName"
#define WLJSNAME_SSL_DISABLE_CIPHER_NAME	"SSLDisableCipherName"
#define WLJSNAME_SSL_ENABLE_CIPHER_ID			"SSLEnableCipherID"
#define WLJSNAME_SSL_DISABLE_CIPHER_ID		"SSLDisableCipherID"
#define WLJSNAME_SSL_ENABLE_STRENGTH      "SSLEnableStrength"
#define WLJSNAME_SSL_GET_CIPHER_COUNT     "SSLGetCipherCount"
#define WLJSNAME_SSL_GET_CIPHER_INFO      "SSLGetCipherInfo"
#define WLJSNAME_SSL_GET_CIPHER_STRENGTH  "SSLGetCipherStrength"
#define WLJSNAME_SSL_GET_CIPHER_NAME      "SSLGetCipherName"
#define WLJSNAME_SSL_GET_CIPHER_ID        "SSLGetCipherID"

// Client types
#define WL_CLIENT_TYPE_THIN   "Thin"
#define WL_CLIENT_TYPE_THICK  "Thick"
#define WL_CLIENT_TYPE_NORMAL "Normal"
#define WL_CLIENT_TYPE_CUSTOM "Custom"

#define ENUM_CLIENT_TYPE_THIN   1
#define ENUM_CLIENT_TYPE_THICK  2
#define ENUM_CLIENT_TYPE_NORMAL 3
#define ENUM_CLIENT_TYPE_CUSTOM 4

#define WLGLOBALS_GET_IMAGES_IN_THIN_CLIENT "GetImagesInThinClient"

//  timers/counters names
#define TOTAL_PAGES           "Pages"
#define PAGE_TIME             "Page Time"


#endif _jshttpnames_h_
