/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// OutputBuf.h: interface for the OutputBuf class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OUTPUTBUF_H__37528126_56F3_11D4_BB16_0004AC1543E6__INCLUDED_)
#define AFX_OUTPUTBUF_H__37528126_56F3_11D4_BB16_0004AC1543E6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <RVCString.h>
#include <RVFile.h>


#define FILE_NAME_SIZE 256

class OutputBuf  
{
public:
	explicit OutputBuf(const char* cFileName=NULL);

	virtual ~OutputBuf();

public:
	const char* GetData();
  void        Write(const char* pch, int nCount);
	int         GetLength();
	bool        ResetOutput();
	bool        SetOutput(const char* cFileName=NULL);
  void        SetOutputData( RVCString& p_sData ) { m_Output = p_sData; }
  void        SetOutputData( const char* p_sData, unsigned p_uSize ) { m_Output.remove( 0 ); m_Output.append( p_sData, p_uSize ); }
  bool        IsOpen() {return m_bOpen;}


protected:
  RVCString m_Output ;

  bool      m_bOpen   ;
};


#endif // !defined(AFX_OUTPUTBUF_H__37528126_56F3_11D4_BB16_0004AC1543E6__INCLUDED_)


