/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*                         
 * File name : replyprops.h
 */                        

#ifndef REPLYPROPS_H
#define REPLYPROPS_H


// general functions
#define wl_valueOf_str			"valueOf"
#define wl_toString_str			"toString"
#define wl_Clone_str				"Clone"
#define wl_open_str					"Open"
#define wl_urlCompare_str		"UrlCompare"
#define wl_Click_str    "Click"
#define wl_Submit_str   "Submit"

// general properties
#define WLJSNAME_PROP_DOM_SCOPE	"WLHiddenPropertyDomScope"
#define WLJSNAME_PROP_WL_SOURCE_INDEX "wlSourceIndex"
// class WLKvp
#define WLJSNAME_PROP_KEY       "key"
#define WLJSNAME_PROP_VALUE     "value"

// class WLLink/WLLocation
#define WLJSNAME_PROP_PROTOCOL  "protocol"
#define WLJSNAME_PROP_HOSTNAME  "hostname"
#define WLJSNAME_PROP_PORT      "port"
#define WLJSNAME_PROP_HOST      "host"
#define WLJSNAME_PROP_URI       "uri"
#define WLJSNAME_PROP_PATHNAME  "pathname"
#define WLJSNAME_PROP_COMMANDS	"commands"
#define WLJSNAME_PROP_SEARCH    "search"
#define WLJSNAME_PROP_KVP       "kvp"
#define WLJSNAME_PROP_HASH      "hash"
#define WLJSNAME_PROP_HREF      "href"
#define WLJSNAME_PROP_WL_ORIG_URL "wlOrigUrl"
#define WLJSNAME_PROP_TARGET		"target"
//for images
#define WLJSNAME_PROP_SRC		"src"
#define WLJSNAME_PROP_LOWSRC		"lowsrc"
#define WLJSNAME_PROP_ALT		    "alt"
#define WLJSNAME_PROP_WIDTH		  "width"
#define WLJSNAME_PROP_HEIGHT    "height"
#define WLJSNAME_PROP_FILE_SIZE "FileSize"
#define WLJSNAME_PROP_CHECKSUM  "CheckSum"

// class WLForm
#define WLJSNAME_PROP_ELEMENTS  "elements"
#define WLJSNAME_PROP_ACTION    "action"
#define WLJSNAME_PROP_METHOD    "method"
#define WLJSNAME_PROP_NAME      "name"
#define WLJSNAME_PROP_ENCODING	"encoding"

// class WLFrame/WLDocument/WLWindow
#define WLJSNAME_PROP_DOCUMENT  "document"
#define WLJSNAME_PROP_FRAMES    "frames"
#define WLJSNAME_PROP_IMAGES    "images"
#define WLJSNAME_PROP_EMBEDS    "embeds"
#define WLJSNAME_PROP_CSS    "stylesheets"
#define WLJSNAME_PROP_LINKS     "links"
#define WLJSNAME_PROP_FORMS     "forms"
#define WLJSNAME_PROP_LOCATION  "location"
#define WLJSNAME_PROP_URL				"URL"
#define WLJSNAME_PROP_TITLE				"title"
#define WLJSNAME_PROP_REFERRER  "referrer"
#define WLJSNAME_PROP_REPLY     "reply"
#define WLJSNAME_PROP_SOURCE		"source"
#define WLJSNAME_PROP_SCRIPTS		"scripts"
#define WLJSNAME_PROP_APPLETS		"applets"
#define WLJSNAME_PROP_XMLS			"wlXmls"

//Galtech
#ifndef _ANSI_ONLY
#define WLJSNAME_PROP_DEFAULT_CHARSET "defaultCharset"
#define WLJSNAME_PROP_WL_CHARSET "wlCharset"
#endif

// class WLElement
#define WLJSNAME_PROP_TYPE				"type"
#define WLJSNAME_PROP_OPTIONS			"options"
#define WLJSNAME_PROP_DEAFAULT_VALUE	"defaultvalue"
#define WLJSNAME_PROP_SELECTED_INDEX	"selectedindex"
#define WLJSNAME_PROP_DEFAULT_CHECKED	"defaultchecked"
#define WLJSNAME_PROP_CHECKED			"checked"

//class WLOption
#define WLJSNAME_PROP_TEXT					"text"
#define WLJSNAME_PROP_SELECTED			"selected"
#define WLJSNAME_PROP_DEFAULT_SELECTED			"defaultselected"

//class WLScript
#define WLJSNAME_PROP_LANGUAGE		"language"
#define WLJSNAME_PROP_EVENT				"event"
#define WLJSNAME_PROP_SRC					"src"
#define WLJSNAME_PROP_ID					"id"
#define WLJSNAME_PROP_INNERHTML		"innerHTML"
#define WLJSNAME_PROP_TAGNAME			"tagName"

// class WLReply
#define WLJSNAME_PROP_PROTOCOL_VERSION  "version"
#define WLJSNAME_PROP_HEADER            "headers"
#define WLJSNAME_PROP_STATUS_NUMBER     "statusNumber"
#define WLJSNAME_PROP_STATUS_LINE       "statusLine"
#define WLJSNAME_PROP_DOCUMENT          "document"

// class WLTable
#define WLJSNAME_PROP_ID				"id"
#define WLJSNAME_PROP_COLS			"cols"
#define WLJSNAME_PROP_ROWS			"rows"
#define WLJSNAME_PROP_CELLS			"cells"
#define WLJSNAME_PROP_OUTERHTML "outerHTML"

// class WLRow
#define WLJSNAME_PROP_ROW_INDEX  "rowIndex"

// class WLCell
#define WLJSNAME_PROP_TAG_NAME    "tagName"
#define WLJSNAME_PROP_CELL_INDEX  "cellIndex"
#define WLJSNAME_PROP_INNER_HTML  "innerHTML"
#define WLJSNAME_PROP_INNER_TEXT  "innerText"

// class WLMeta
#define WLJSNAME_PROP_HTTP_EQUIV  "httpEquiv"
#define WLJSNAME_PROP_CONTENT     "content"

//properties that can be called from the browser dom
#define WLJSNAME_PROP_BROWSER_SOURCE						"wlSource"
#define WLJSNAME_PROP_BROWSER_PROTOCOL_VERSION	"wlVersion"
#define WLJSNAME_PROP_BROWSER_STATUS_NUMBER			"wlStatusNumber"
#define WLJSNAME_PROP_BROWSER_STATUS_LINE				"wlStatusLine"
#define WLJSNAME_PROP_BROWSER_HEADER						"wlHeaders"
#define WLJSNAME_PROP_BROWSER_SEARCH_PAIRS			"wlSearchPairs"
#define WLJSNAME_PROP_BROWSER_PROTOCOL					"wlProtocol"
#define WLJSNAME_PROP_BROWSER_HOSTNAME					"wlHostName"
#define WLJSNAME_PROP_BROWSER_PORT							"wlPost"
#define WLJSNAME_PROP_BROWSER_HOST							"wlHost"
#define WLJSNAME_PROP_BROWSER_PATHNAME					"wlPathName"
#define WLJSNAME_PROP_BROWSER_HASH							"wlHash"
#define WLJSNAME_PROP_BROWSER_SEARCH						"wlSearch"
#define WLJSNAME_PROP_BROWSER_HREF							"wlHref"
#define WLJSNAME_PROP_TABLES                    "wlTables"
#define WLJSNAME_PROP_METAS                     "wlMetas"

// class WLArray
#define WLJSNAME_PROP_CLASS_NAME     "WLHiddenPropertyClassName"
#define WLJSNAME_PROP_LENGTH         "length"


// class WLLink/WLForm
#define WLJSNAME_PROP_SPIDERSESSION  "SPIDERSESSION"

#define WLJSNAME_PROP_OUTER_TEXT  "outerText"


#endif // REPLYPROPS_H
