/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/****************************************************************
 * File name : wlMultiPart.h
 * Author    : Yossi Nakash  
 * Created   : 2/1/01    
 * ==========:             
 * Abstract  : CWLMultipart class declaration
 *                         
****************************************************************/

#ifndef WLMULTIPART_H
#define WLMULTIPART_H

#define MULTIPART_HEADER          "Content-Disposition: form-data;"
#define MULTIPART_NAME            " name=\""
#define MULTIPART_FILE_NAME       " filename=\""
#define CONTENT_TYPE    "Content-Type: "
#define MULTIPART_END_BOUNDARY    "--"

#define WL_FILE_NAME              ".wlFile-Name"
#define WL_CONTENT_TYPE           ".wlContent-Type"

#include <RVCString.h>
#include "htmlvalues.h"
#include "workspace.h"

class CWLHttpRequest;

class CWLMultiPart 
{
public:
  CWLMultiPart(CWLHttpRequest* p_Request);
  virtual ~CWLMultiPart();
  
  const char* GetData();
//  char*       GetFileName(){return m_pcFileName;}
  const char*       GetFileName(){return m_pcFileName.data();}
  int GetDataLength();
  int CreateMultiPartData(CWLDataBlock* pFormDataBlock, int nThread, int nRound, RVCString sinBoundery, int CharSet);
  RVCString& GetBoundary();

protected:
  RVCString m_sMultiPartData ;
  RVCString m_sBoundary ;
//  char      m_pcFileName[32];
  RVCString      m_pcFileName;

private:
  // avoid copy ctor & asignment operator
  CWLMultiPart( const CWLMultiPart& src );
  operator=( const CWLMultiPart& src );

  CWLHttpRequest* m_Request ;

};

#endif // WLMULTIPART_H
