// Spider Session id constants
function DefineSpiderSessionConst(){ 
	ND_NULL_HREF           	 = " "
	ND_NULL_HREF_ONLY      	 = " "
	ND_NULL_SESSION_ID       = " "
	ND_NULL_UNIQUEVALUE_NAME = " "
	K_SPIDERSESSION_NAME     = "SPIDERSESSION"
	K_UNIQUEVALUE_NAME       = "^uniqueValue"
	SPIDERSESSION_RI1        = new RegExp ("(;\\$SESSIONID\\$\\S*)","i")
	SPIDERSESSION_RI2        = new RegExp ("(;SPIDERSESSION=\\S*)","i")

	// This object porpuse is to help us construct a link with Net-Dynamics 
	// Session id.
	// The object contain the following properties :
	// 		HrefFull 	- Full Link value
	// 		SessionId 	- The current session id as exist in link
	//		HrefOnly 	- The Href value of link without the session id
	}		
	function NDLinkObj(link) {

		// Set the href ans session id according to the link value
		// we check if the link contain some session activating
		// 2 regular expressions.
		// if we didn't find any session id then we take only
		// the part of the url before the question mark ("?")
		// in order that the compare href will not include
		// the query string values
		function Set (ByLink) {
			this.HrefFull 	= ByLink
			var riArray = SPIDERSESSION_RI1.exec(ByLink)

			if (riArray == null) {
				riArray = SPIDERSESSION_RI2.exec(ByLink)
				}

			if (riArray != null) {
				this.SessionId = RegExp.$1
				this.HrefOnly  = RegExp.leftContext
			}
			else {
				this.SessionId 	= ND_NULL_SESSION_ID
				var str   = new String(ByLink)
				var index = str.indexOf("?")
				if (index == -1)
					this.HrefOnly = ByLink
				else
					this.HrefOnly = str.substr(0,index)
			}
		}
		function SetSessionId (SessionId) {
			this.SessionId = SessionId
			var riArray = SPIDERSESSION_RI1.exec(this.HrefFull)

			if (riArray == null) {
				riArray = SPIDERSESSION_RI2.exec(this.HrefFull)
				}

			if (riArray != null) {
				this.HrefFull  = this.HrefOnly + this.SessionId 
			}
		}

		function GetSessionId () {
			return this.SessionId
		}
		
		function SetUniqueValue(uniqueValue)
		{
			this.UniqueValue = uniqueValue
		}

		function GetUniqueValue()
		{
			return this.UniqueValue
		}

		function GetHrefOnly () {
			return this.HrefOnly
		}
		function GetHrefFull () {
			return this.HrefFull
		}

		function Clear () {
			this.HrefFull    = ND_NULL_HREF 
			this.HrefOnly    = ND_NULL_HREF_ONLY
			this.SessionId   = ND_NULL_SESSION_ID
			this.UniqueValue = ND_NULL_UNIQUEVALUE_NAME
		}

		function IsEmpty () {
			return (this.HrefFull == ND_NULL_HREF)
		}

		function ContainSessionId () {
			return ((this.SessionId != ND_NULL_SESSION_ID) || 
			        (this.UniqueValue  != ND_NULL_UNIQUEVALUE_NAME))
		}

		// Init the NDLink object methods
		this.Set 				= Set
		this.SetSessionId 		= SetSessionId
		this.GetSessionId 		= GetSessionId
		this.SetUniqueValue		= SetUniqueValue
		this.GetUniqueValue		= GetUniqueValue
		this.Clear 				= Clear
		this.IsEmpty 			= IsEmpty
		this.ContainSessionId 	= ContainSessionId
		this.GetHrefOnly 		= GetHrefOnly
		this.GetHrefFull 		= GetHrefFull

		// Init object with default values 			
		// at start we assume that the link doesn't 	 
		// contain any session id in it				
		this.Clear()
		if (link != undefined) {
			this.Set (link)
		}
}

// an object for holding both SessionId and UniqueValue
function SessionData(SpiderSession,UniqueValue)
{
  this.SpiderSession = SpiderSession
  this.UniqueValue   = UniqueValue
}
