/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "tracedll.h"
#include "workspace.h"
#include "authorization.h"
#include "httpdefines.h"
#include "connpool.h"
#include "httprequest.h"


//Aviad
//CLEVariablesData* WLInitVariablesDataFunc(CLEVariablesData *parent)
//{
//  return new CLEVariablesData(parent, CLEPropertyValue::PL_HTTP);
//}

int DllExport WLHttpInit(bool bCallback)
{
WlTraceMsg( "WLHttpInit");
  static bool bFirstTime = true;
  if (bFirstTime)
    CWLWorkspace::RegisterHttpProperties () ;

#ifdef __TV_WINDOWS__
  if (bFirstTime)
    CWLClientAuthentication::GlobalInit();
  WORD wVersionRequested;
  WSADATA wsaData;
  int err;
  wVersionRequested = MAKEWORD(1, 1);

  err = WSAStartup(wVersionRequested, &wsaData);

  if (err != 0)
    /* Tell the user that we couldn't find a useable */
    /* winsock.dll.     */
    return 0;

	if (LOBYTE(wsaData.wVersion) != 1 || HIBYTE(wsaData.wVersion) != 1) {
		int err = GetLastError();
		WSACleanup();
		return 0;
	}

#endif

  if (bFirstTime)
  {
    // @@Migration - not needed?
    /*
    if (bCallback)
      RegisterWLENewThreadDataFunc(JSNewWebThreadCallback);
    else
      RegisterWLENewThreadDataFunc(JSNewWebThread);
    RegisterWLInitGeneratorScript(WLInitHttpGeneratorScript);
    RegisterWLInitGeneratorThread(WLInitHttpGeneratorThread);
    */

    ParseCharForHttp();

    if (CWLConnectionsPool::GetLocalHosts() == RET_ERROR)
    {
      WlTraceMsg( "CWLConnectionsPool::GetLocalHosts() failed");
		  return RET_ERROR;
    }
  }
#ifdef __TV_UNIX__
  signal (SIGPIPE, SIG_IGN);
#if !defined (__TV_aix__)
  // raise the number of file descriptor.
  struct rlimit rlp;
  getrlimit(RLIMIT_NOFILE, &rlp);
  rlp.rlim_cur = rlp.rlim_max;
  setrlimit(RLIMIT_NOFILE, &rlp);
#endif
#endif

  bFirstTime = false;
  return RET_OK;
}

int DllExport WLHttpTerminate()
{
#ifdef __TV_WINDOWS__
	CWLClientAuthentication::GlobalTerminate();
	WSACleanup();
#endif
	return 1;
}
