/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _jsxmlwrappers_h_
#define _jsxmlwrappers_h_

#include "wlxmlcom.h"

enum WLInterfaceType{
	wlInterfaceNodeType,
	wlInterfaceDocumentType,
	wlInterfaceNodeListType,
	wlInterfaceNodeMapType,
	wlInterfaceParseErrorType,
	wlInterfaceImplementationType
};


class CWLXmlInterfaceParent {
public:
	WLInterfaceType GetType(){return m_type;}
	CWLXmlInterfaceParent() {}
	virtual ~ CWLXmlInterfaceParent(){
//		WlTraceMsg("In  ~ CWLXmlInterfaceParent() deleting 0x%x",this );
	}
protected:
	WLInterfaceType m_type;
};

class CWLXmlDocumentWrapper : public CWLXmlInterfaceParent {
private:
	IXMLDOMDocumentPtr* m_pXMLDOMDocumentPtr;

public:
	CWLXmlDocumentWrapper(IXMLDOMDocumentPtr* pXMLDOMDocumentPtr);
	CWLXmlDocumentWrapper(CWLXmlDocumentWrapper* pWrapper);
	virtual ~CWLXmlDocumentWrapper();	
	IXMLDOMDocumentPtr* GetInterfacePtr();
};

class CWLXmlElementWrapper : public CWLXmlInterfaceParent {
private:
	IXMLDOMElementPtr* m_pXMLDOMElementPtr;

public:
	CWLXmlElementWrapper(IXMLDOMElementPtr* pDOMElementPtr);
	virtual ~CWLXmlElementWrapper();
	IXMLDOMElementPtr* GetInterfacePtr();
};

class CWLXmlDocumentTypeWrapper : public CWLXmlInterfaceParent {
private:
	IXMLDOMDocumentTypePtr* m_pXMLDocumentTypePtr;

public:
	CWLXmlDocumentTypeWrapper(IXMLDOMDocumentTypePtr* pXMLDocumentTypePtr);
	virtual ~CWLXmlDocumentTypeWrapper();
	IXMLDOMDocumentTypePtr* GetInterfacePtr();
};

class CWLXmlImplementationWrapper : public CWLXmlInterfaceParent {
private:
	IXMLDOMImplementationPtr* m_pXMLImplementationPtr;
	
public:
	CWLXmlImplementationWrapper(IXMLDOMImplementationPtr* pImplementationPtr);
	virtual ~CWLXmlImplementationWrapper();
	IXMLDOMImplementationPtr* GetInterfacePtr();
};

class CWLXmlParseErrorWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMParseErrorPtr* m_pXMLParseError;

public:
	CWLXmlParseErrorWrapper(IXMLDOMParseErrorPtr* pParseErrorPtr);
	virtual ~CWLXmlParseErrorWrapper();
	IXMLDOMParseErrorPtr* GetInterfacePtr();
};

class CWLXmlNamedNodeMapWrapper : public CWLXmlInterfaceParent{
private: 
	IXMLDOMNamedNodeMapPtr* m_pXMLNamedNodeMap;

public:
	CWLXmlNamedNodeMapWrapper(IXMLDOMNamedNodeMapPtr* pNamedNodeMap);
	virtual ~CWLXmlNamedNodeMapWrapper();
	IXMLDOMNamedNodeMapPtr* GetInterfacePtr();
};

class CWLXmlNodeWrapper : public CWLXmlInterfaceParent{
private: 
	IXMLDOMNodePtr* m_pXMLNode;

public:
	CWLXmlNodeWrapper(IXMLDOMNodePtr* pNode);
	virtual ~CWLXmlNodeWrapper();
	IXMLDOMNodePtr* GetInterfacePtr();
};

class CWLXmlAttributeWrapper : public CWLXmlInterfaceParent{
private: 
	IXMLDOMAttributePtr* m_pXMLAttribute;

public:
	CWLXmlAttributeWrapper(IXMLDOMAttributePtr* pAtrribute);
	virtual ~CWLXmlAttributeWrapper();
	IXMLDOMAttributePtr* GetInterfacePtr();
};

class CWLXmlCommentWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMCommentPtr* m_pXMLComment;

public:
	CWLXmlCommentWrapper(IXMLDOMCommentPtr* pComment);
	virtual ~CWLXmlCommentWrapper();
	IXMLDOMCommentPtr* GetInterfacePtr();
};

class CWLXmlCDATAWrapper : public CWLXmlInterfaceParent{
private: 
	IXMLDOMCDATASectionPtr* m_pXMLCDATA;
public:
	CWLXmlCDATAWrapper(IXMLDOMCDATASectionPtr* pCDATA);
	virtual ~CWLXmlCDATAWrapper();
	IXMLDOMCDATASectionPtr* GetInterfacePtr();
};

class CWLXmlDocumentFragmentWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMDocumentFragmentPtr* m_pDocumentFragment;
public:
	CWLXmlDocumentFragmentWrapper(IXMLDOMDocumentFragmentPtr* pDocumentFragment);
	virtual ~CWLXmlDocumentFragmentWrapper();
	IXMLDOMDocumentFragmentPtr* GetInterfacePtr();
};

class CWLXmlEntityReferenceWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMEntityReferencePtr* m_pEntityReference;
public:
	CWLXmlEntityReferenceWrapper(IXMLDOMEntityReferencePtr* pDocumentFragment);
	virtual ~CWLXmlEntityReferenceWrapper();
	IXMLDOMEntityReferencePtr* GetInterfacePtr();
};

class CWLXmlPIWrapper : public CWLXmlInterfaceParent{
private:
	MSXML::IXMLDOMProcessingInstruction* m_pPI;
public:
	CWLXmlPIWrapper(MSXML::IXMLDOMProcessingInstructionPtr* pPi);
	virtual ~CWLXmlPIWrapper();
	MSXML::IXMLDOMProcessingInstruction* GetInterfacePtr();
};

class CWLXmlTextNodeWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMTextPtr* m_pTextNode;
public:
	CWLXmlTextNodeWrapper(IXMLDOMTextPtr* pTextNode);
	virtual ~CWLXmlTextNodeWrapper();
	IXMLDOMTextPtr* GetInterfacePtr();
};

class CWLXmlNodeListWrapper : public CWLXmlInterfaceParent{
private:
	IXMLDOMNodeListPtr* m_pNodeListPtr;
public:
	CWLXmlNodeListWrapper(IXMLDOMNodeListPtr* pNodeListPtr);
	virtual ~CWLXmlNodeListWrapper();
	IXMLDOMNodeListPtr* GetInterfacePtr();
};

#endif
