/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _wlxmlfuncs_h_
#define _wlxmlfuncs_h_
#include "rvjsapi.h"
//	extern "C" {
//#include "jsapi.h"
//}
#include "jsxmlwrappers.h"
#include "wlxml.h"
#include "platform.h"
#include <RVCString.h>
#define  XML_ERROR_FILE "xmlerrors.frm"
#define	 TRY_COM        try
#define  CATCH_COM_RETURN_NULL 		catch (_com_error e){\
	return JS_TRUE;}


#include <comdef.h>
#include <atlbase.h>
#include "xmlerrorreporter.h"
#include "tracedll.h"


#define  CATCH_COM(ctxt)			catch (_com_error e){ \
	return COMReportError( ctxt, e );}

#define  CATCH_COM_RETURN(ctxt, ret)			catch (_com_error e){\
	COMReportError( ctxt, e );\
	return ret;}


#define  CATCH_COM_METHOD(ctxt, method)			catch (_com_error e){ \
                                WlAssert(piHLErrorReporter); \
																return piHLErrorReporter->ReportXMLError(ctxt, XML_ERROR_FILE, 21, COMErrorDescription(e).data(), method );}
													

	
#define SCOPE_EACH_ROUND  0
#define SCOPE_OBJ_CLONED -1
#define SCOPE_PARSE_ONCE -2


class CWLXmlDocument;
class CWLDocument;




class wlXmlError{
public:
	wlXmlError(RVCString& err);
	~wlXmlError(){}
	const char* ErrorMessage();
private:
	RVCString errorRef;
};




class CWLXmlInterfacePtr : public CWLXmlParseInterfacePointer{
public:
	CWLXmlInterfacePtr(IXMLDOMDocumentPtr* newDocPtr);
	virtual ~CWLXmlInterfacePtr();
	IXMLDOMDocumentPtr* GetInterfacePtr();
private:
	IXMLDOMDocumentPtr* m_pDocPtr;
};



JSBool xmlnode_appendChild(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_cloneNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_hasChildNodes(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_insertBefore(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_removeChild(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_replaceChild(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_selectNodes(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_selectSingleNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_transformNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
JSBool xmlnode_transformNodeToObject(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);
//JSBool (JSContext *cx, JSObject *obj, jsval id, jsval *vp);

JSBool xmlnode_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp);
JSBool xmlelement_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlattribute_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmltext_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcdata_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlentityref_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlentity_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlprocessinginstruction_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcomment_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp);
JSBool xmldocumenttype_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocumentfragment_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlnotation_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_getProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);

JSBool xmlnode_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp);
JSBool xmlelement_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlattribute_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmltext_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcdata_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlentityref_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlentity_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlprocessinginstruction_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcomment_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp);
JSBool xmldocumenttype_setProperty	(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocumentfragment_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlnotation_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_setProperty(JSContext *cx, JSObject *obj, jsval id, jsval *vp, IXMLDOMNodePtr& pNodePtr);

JSBool xmldocument_abort(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createAttribute(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createComment(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createCDATASection(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createDocumentFragment(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createElement(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createEntityReference(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createProcessingInstruction(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_createTextNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_getElementsByTagName(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_load(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_loadXML(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_nodeFromID(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmldocument_save(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmltext_splitText(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_appendData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_deleteData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_insertData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_replaceData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlcharacterdata_substringData(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_getAttribute(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_setAttribute(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_removeAttribute(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_getAttributeNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_setAttributeNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_removeAttributeNode(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_getElementsByTagName(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);
JSBool xmlelement_normalize(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval, IXMLDOMNodePtr& pNodePtr);



bool DllExport WLAddXmlDocumentClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlDocumentTypeClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlElementClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlImplementationClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlParseErrorClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlNamedNodeMapClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlNodeClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlAttributeClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlCommentClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlCDATAClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlDocumentFragmentClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlPIClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlTextNodeClass(JSContext *cx, JSObject *obj);
bool DllExport WLAddXmlNodeListClass(JSContext *cx, JSObject *obj);


JSObject* WLNewXmlObject(JSContext* cx, JSClass* cls, JSObject* proto, JSObject* parent);
void WLSetNewXmlObject(JSContext* cx, JSObject* obj, JSObject* newObj, const char* name, void* value, bool toDelete = false);
bool WLXmlDeleteProperty(JSContext* cx, JSObject* obj, const char* name);
void WLXmlFinalize(JSContext*, JSObject*);

bool DllExport WLXmlIsObjectOfClass(JSContext* cx, jsval v, const char* name);
void DllExport XmlSetScopeProperty(JSContext* cx, JSObject* obj, int setScope = SCOPE_EACH_ROUND);


JSBool					 WLXmlSetVariantValue(JSContext *cx, JSObject *obj, _variant_t& var, jsval* vp);
JSBool DllExport WLXmlSetIntValue(JSContext* cx, JSObject* obj, const char* name, unsigned value, jsval* rval);
JSBool DllExport WLXmlSetBoolValue(JSContext* cx, JSObject* obj, const char* name, bool value, jsval* rval);
JSBool DllExport WLXmlSetDoubleValue(JSContext* cx, JSObject* obj, const char* name, double value, jsval* rval);
JSBool DllExport WLXmlSetStringValue(JSContext* cx, JSObject* obj, const char* name, const char* value, jsval* rval, size_t length = 0);

JSBool DllExport WLXmlSetNodeInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlNodeWrapper* value,jsval*  rval);
JSBool DllExport WLXmlSetNodeListInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlNodeListWrapper* value,jsval*  rval);
JSBool DllExport WLXmlSetParseErrorInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlParseErrorWrapper* value, jsval* rval);
JSBool DllExport WLXmlSetImplementationInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlImplementationWrapper* value, jsval* rval);
JSBool DllExport WLXmlSetNamedNodeMapInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlNamedNodeMapWrapper* value,jsval*  rval);
JSBool DllExport WLXmlSetDocumentInterfaceValue(JSContext* cx, JSObject* obj,CWLXmlDocumentWrapper* value, jsval*  rval);					
JSBool DllExport WLXmlSetDocumentInterfaceValue(JSContext *cx, JSObject *obj, CWLDocument* parent, CWLXmlDocument* xml, bool htmlProps, jsval*  rval);					
bool				 WLXmlJsvalToVariant(jsval& vp, _variant_t& var);
unsigned     WLXmlIntValue(jsval val);
double       WLXmlDoubleValue(jsval val);
const char*  WLXmlStringValue(jsval val);

JSBool		WLXmlInitProperty(JSContext* cx, JSObject* obj, const char* prop);
JSBool		WLXmlInitHiddenProperty(JSContext* cx, JSObject* obj, const char* name);
JSBool		succeeded(JSContext* cx,HRESULT hr);

bool checkNodeTypeByString(char* type, ...);
int	 checkNodeTypeByInt(int type,...);
char* ConvertNodeTypeToString(int type);

void COMErrorDescription( _com_error err, RVCString& description );
RVCString COMErrorDescription(_com_error err );
JSBool COMReportError( JSContext* cx, _com_error& err );


#endif