/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <ace/OS.h>
#include <string.h>
#include "xmlreplyprops.h"
#include "jsxmlreplynames.h"
#include "wlxmlfuncs.h"
#include "jsxmlprivate.h"
#include "wlxml.h"


//ptr is an interface wrapper
CWLXmlPrivate::CWLXmlPrivate(void* ptr)
{
	m_CPP_RealObject      = ptr;
  m_Parent              = NULL;
	m_pXml								= NULL;
	m_bHtmlProps					= false;
}

CWLXmlPrivate::CWLXmlPrivate(void* ptr, CWLDocument* parent, CWLXmlDocument* xmlDoc, bool bHtmlProps )
{
	m_CPP_RealObject			= ptr;
	m_Parent							= parent;
	m_pXml								= xmlDoc;
	m_bHtmlProps					= bHtmlProps;
}

CWLXmlPrivate::CWLXmlPrivate(CWLXmlDocument* xml, CWLDocument* parent)
{
	IXMLDOMDocumentPtr* docPtr			=	new IXMLDOMDocumentPtr( *( ((CWLXmlInterfacePtr*)(xml->GetPrivateInterface()))->GetInterfacePtr() ) );	
	CWLXmlDocumentWrapper* wrapper	= new CWLXmlDocumentWrapper(docPtr);
	m_CPP_RealObject								= (void*)wrapper;	
	m_pXml				                  = xml;
	m_Parent			                  = parent;
	m_bHtmlProps	                  = true;
}

CWLXmlPrivate::~CWLXmlPrivate()
{
	delete (CWLXmlInterfaceParent*)m_CPP_RealObject;
}

void* CWLXmlPrivate::GetObj()
{
	return m_CPP_RealObject;
}

CWLDocument* CWLXmlPrivate::GetParent()
{
	return m_Parent;
}

CWLXmlDocument* CWLXmlPrivate::GetXmlObj()
{
	return m_pXml;
}

bool	CWLXmlPrivate::enableHtmlProps()
{
	return m_bHtmlProps;
}
