/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADENGINE_GLOBALS_H_
#define __WL_LOADENGINE_GLOBALS_H_
#include "loadengineexternaldecs.h"

#include "platform.h"
#include "wlerrorlib.h"
#include "loadjsshell.h"

#include "rvjsapi.h"
#include "loadgeneratorscript.h"
#include "loadreportinfo.h"
#include "jsjavacore.h"

class IThreadsManager;
//class CLoadThreadsManager;
//class CLoadThreadsManagerScript;
class IGeneralManagerScriptData;
class CLoadThreadInstanceScript;
class CLoadThreadInstance;
class CLoadThreadInstance;
//#define WLE_NO_ERROR 0
//#define WLE_LOG_ERROR 1
//#define WLE_SEVERE_ERROR 2


#if (defined _cplusplus) || (defined __cplusplus)
extern "C" {
#endif


DllExport int LoadGeneratorMain(int argc, char *argv[], int ExtraProtocol);
DllExport int LoadGeneratorSlave(int argc, char *argv[], int ExtraProtocol);
DllExport int LoadGeneratorTest(int argc, char *argv[], int ExtraProtocol);

#define WLE_ADDPROTOCOL_NONE        0
#define WLE_ADDPROTOCOL_HTTP        1
DllExport void SetExtraProtocol(int p_iAddProtocol);

void setCurrentThreadInstanceScript(CLoadGeneralThreadInstanceScript *thread, JSContext *cx);
DllExport CLoadGeneralThreadInstanceScript *getCurrentThreadInstanceScript(JSContext *cx);

void setCurrentThreadsManager(IThreadsManager *pTM);
IThreadsManager *getCurrentThreadsManager();

void setCurrentManagerScriptData(IGeneralManagerScriptData*, JSContext*);
IGeneralManagerScriptData* getCurrentManagerScriptData( JSContext* );

// user defined routines

//typedef bool WLInitGeneratorShell(CWLJSShell*);
//DllExport void RegisterWLInitGeneratorShell(WLInitGeneratorShell *f);
//DllExport extern WLInitGeneratorShell *pWLInitGeneratorShell;

//
// for testing:
DllExport int WLLoadSingleTestMain(const char* script);
DllExport int WLProbingClientTest(const char* script);
DllExport WLLogMessage::Severity WLProbingClientMain(const char* script, RVCString& stat, RVCString& log);

void SetMaxThreadsPerSlave(long);
long GetMaxThreadsPerSlave();

//GALTECH: Get\SetMonitorCharset functions
#ifndef _ANSI_ONLY
DllExport int GetMonitorCharSet();
DllExport void SetMonitorCharSet(int charset);
#endif


#if (defined _cplusplus) || (defined __cplusplus)
}
#endif

class DllExport CArrangeMachineTempFiles {
public:

	static RVCString GetWlTempPath(int masterPid);
	static RVCString GetWlTempFullPath(JSContext* cx,TypeOfTheUserFile typeOfTheUserFile, const char* fileName);
	static RVCString GetWlTempFullPath(int masterPID, int numScriptInMix);

	static RVCString GetTempDirectory();
	static void LECreateDirectory(const char* path);

};

#endif //__WL_LOADENGINE_GLOBALS_H_

