/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _LOADENGINEINIFILEPROPERTIES_H
#define _LOADENGINEINIFILEPROPERTIES_H
#include "platform.h"
#include <RVCString.h>
#include "tvenv.h"
#include "tvtables.h"

//####### The declaration of the class CLEIniFileProperties   #########

class DllExport CLEIniFileProperties {
public:
	static long      LoadGeneratorSlaveTimeOut;
	static int       MaxItemsPerChunk;
	static long      RuntimeSize;
	static long      ContextSize;
	static long      StatGarbageTerminateTimeout;
	static long      StatPackTerminateTimeout;
	static long      JSGCTerminateTimeout;		
	static long      LogMessagesMax;
	static int       TransactionMax;
	static int       GlobalsHandlerWaitTime;
	static int       WaitForThreadtoTerminate;
  static RVCString Protocols;
  static RVCString ProtocolsNames;
  static bool      GCThreadOnly;
  static bool      UseWLJVMIni;
  static RVCString WebLOADJVMPath;
  static RVCString LibJVMPath;
  static RVCString OptionsBuf[100];
  static RVCString WebLOADClasspath;
  static RVCString UserClasspath;
  static RVCString ProtocolExtensionsPath;
  static RVCString JavaExtensionsPath;
  static RVCString JVMExtensionsPath;
  static bool      DestroyJVM;
  static RVCString LGDefaultInitializationScript;
  static bool      EnableStopgeneratorOnNetErrors;
  static bool      IgnoreInitScript;
  static bool      ThreadPoolOn;
  static int       InitialThreadPoolSize;
	static long      LoadGeneratorMaxThreadsPerSlave;
	static bool			 ErrorCountersOn;
	static bool			 TranslateSystemExceptions;
	static bool			 ListThreadInfo;
	static int			 JSGCInterval;
	static int       JSGCSleep;
	static int       JSGCInitialSleep;
	static bool			 DisplayUserAgendaPositionInErrors;
  static RVCString WebLOADDefaultIncludePath;
	static int			 JVMCreateWaitTime;
	static bool			 ScriptCacheOn;
	static long			 ScriptCacheWarmupLoadRounds;
	static long			 ScriptCacheWarmupAnalysisRounds;
	static long			 UseCountThreshold;
	static bool			 ErrorTraceAll;
	static bool			 ErrorTraceCSJSCompileErrors;
	static bool			 ErrorTraceScriptCache;
	static bool			 UseNewJSGCGuardStyle;
  static bool      UseAtomClip;
  static bool      CompilerIntervention;
  static int       CompilerInterventionCount;
  static bool      StandardReferenceErrorBehavior;
  static bool      EnforceReservedKeywords;
  static bool      initPerformed; 

public:
  static void Init();
  static void AppendProtocol(const char* pProtocol, const char* pProtocolName);
  static const char*  GetAppendProtocolRealName(const char* pProtocol);
  static void	   resetJVMPath(const char* JVMType);
private:

  // Chaim 18/7/02
  // The additional protocols stuff is to allow httpload.exe and webft.exe to
  // specify different protocols. The addProtocols method accepts names of entry 
  // points in loadengine.ini which specify additional protocols to use.
  // The  method should be called only once but it is designed so that it can
  // be used either before or after the Init method and will still work
  // correctly.
  //
  static RVCString additionalProtocols;
  static RVCString additionalProtocolsNames;
  static bool      tablesInited;
  static bool      additionalProtocolsSet; 
  static TableHandle
                   LETableHandle;
  static TableHandle
                   WLTableHandle;
  static TVEnvContainerClass
                   tvpc;
  static bool      optionToBool(const char*);
  static void      addProtocols();
  static void      initTable(TableHandle&, const char*);
  static void			 initTables();
};


#endif
