/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TV_EXCEPTION_H
#define __TV_EXCEPTION_H

#include "platform.h"
#include "wlerrorlib.h"

#define LoadExceptionFrmFile "loadengine.frm"
#define JSErrorsFrmFile "jserrors.frm"
#define JSSyntaxChecks "jssyntaxchecks.frm"

class CLoadException : public WLErrorException
{
public:
  // @@ofer: the format of copy ctor should be X(const X&) but since WebRM 4.6 uses the same dlls we cannot modify the interface
  // in 6.0 we should use X(const X&) for ALL platforms
#ifdef __TV_UNIX__
	CLoadException(const WLErrorException& error) : WLErrorException(error) {}
#else
	CLoadException(WLErrorException& error) : WLErrorException(error) {}
#endif // __TV_UNIX__
  virtual ~CLoadException() RV_EXCEPTION_THROW {}
};

class CThreadsManagerDoesNotExistException : public CLoadException
{
public:
	CThreadsManagerDoesNotExistException( const char* ThreadsManagerName) : 
    CLoadException( WLErrorException(LoadExceptionFrmFile, 20, ThreadsManagerName) )	{}
  virtual ~CThreadsManagerDoesNotExistException() RV_EXCEPTION_THROW {}
};

class CThreadsManagerAlreadyExistsException : public CLoadException
{
public:
	CThreadsManagerAlreadyExistsException( const char* ThreadsManagerName) : 
    CLoadException( WLErrorException(LoadExceptionFrmFile, 21, ThreadsManagerName) )	{}
  virtual ~CThreadsManagerAlreadyExistsException() RV_EXCEPTION_THROW {}
};

class CThreadsManagerNetInitFailedException : public CLoadException
{
public:
	CThreadsManagerNetInitFailedException( const char* name ) : 
    CLoadException( WLErrorException(LoadExceptionFrmFile, 32, name) )	{}
  virtual ~CThreadsManagerNetInitFailedException() RV_EXCEPTION_THROW {}
};

class CWLGeneratorTerminatedException
{
 public:
  CWLGeneratorTerminatedException() {}
  ~CWLGeneratorTerminatedException() {}
};

#endif

