/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADGENERATORSLAVEPROXY_H
#define __WL_LOADGENERATORSLAVEPROXY_H

#include <collint.h>
//#include <collstr.h>

#include "platform.h"
#include "associativearray.h"
#include "netkernelmessagehandler.h"

class CLoadGeneratorSlave;
class CLoadAgendaManager;

class CLoadGeneratorSlaveProxy : public CNetMessageHandler, public RVCollectableInt
{
private:
  CLoadGeneratorSlave *m_pMyLoadGeneratorSlave;
  CLoadAgendaManager  *m_pMyLoadAgendaManager;

  int                  m_NumRunningRequested;
  int                  m_NumRunning;
  int                  m_SlaveId;
  long                 m_CreateRequestId;
  long                 m_TerminateRequestId;
  RVCString            m_SlaveName;
  RVCString            m_SlaveAddress;
  bool                 m_InProcess;
  bool                 m_SlaveOK;
  double               m_SlaveStartTime;
  int                  m_SlaveBaseThreadId;
  bool                 m_Terminated;
  bool                 m_StopSlaveCalled;
	bool								 m_TimeoutOccurred;
	int									 m_StatisticsFrequency;
	bool								 m_StatusCreateSlave;
	TVPManualEvent			 m_CreateSlaveDoneEvent;

public:
	CLoadGeneratorSlaveProxy(CLoadAgendaManager *pLAM, int slaveId, bool inProcess);
	~CLoadGeneratorSlaveProxy();

  bool CreateSlave(long requestId, int slaveBaseThreadId, int numRunning=0);
  void StartSession(long requestId, CAssociativeArray* paramsArray);
  bool SetSlaveNumRunning(long requestId, int numRunning);
  void StopSlave(long requestId);
	bool StopSendingTransactions();
	bool StopSendingLogMessages();
  void SendMessageToSlave(CAssociativeArray* paramsArray, int priority = 1);
  bool CLoadGeneratorSlaveProxy::CreateLoadGenerator();
	CLoadAgendaManager *GetAgendaManager()    {return m_pMyLoadAgendaManager;}

  virtual void SendMessageErrorHandler( CAssociativeArray& Message , const char* SendTo, const char* ErrorMsg, bool status);
	virtual void MessageHandler( CAssociativeArray& AssoArrayCommand );
	virtual CNetHandlerMessage* SenderWaitMessage();
};


#endif

