/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_LOADJSDEFS_H
#define __WL_LOADJSDEFS_H

#include "loadenginevariablesdata.h"

// global objects functions
#define WLJSNAME_TO_STRING                "toString"
#define WLJSNAME_VALUE_OF                 "valueOf"

// wlGlobals
#define WLJSNAME_GLOBAL_CLASS             "WLGlobalClass"
#define WLJSNAME_GLOBAL_PER_THREAD_CLASS  "WLGlobalPerThreadClass"
//  This object name is used for both former class names
#define WLJSNAME_GLOBAL_OBJECT	          "wlGlobals"

// WL Super Global Varaibles
#define WLJSNAME_SUPER_GLOBALS_CLASS		    "WLSuperGlobalsClass"
#define WLJSNAME_GENERATOR_GLOBAL_OBJECT	    "wlGeneratorGlobal"
#define WLJSNAME_META_GLOBAL_OBJECT             "wlSystemGlobal"
#define WLJSNAME_SUPER_GLOBALS_ADD				"Add"
#define WLJSNAME_SUPER_GLOBALS_ADDEX			"AddEx"
#define WLJSNAME_SUPER_GLOBALS_SET				"Set"
#define WLJSNAME_SUPER_GLOBALS_GET				"Get"
#define WLJSNAME_SUPER_GLOBALS_ALL_AGENDAS		"WLAllAgendas"    // flag
#define WLJSNAME_SUPER_GLOBALS_CURRENT_AGENDA	"WLCurrentAgenda" // flag


// file treatment
#define WLJSNAME_FILE_GET_LINE			      "GetLine"
#define WLJSNAME_FILE_OPEN    			      "Open"
#define WLJSNAME_FILE_ITEM_LINE_NUM			  "LineNum"
#define WLJSNAME_FILE_ITEM_ROUND_NUM		  "RoundNum"
#define WLJSNAME_FILE_DEFAULT_DELIMITER   ","

// wlRand
#define WLJSNAME_RAND_CLASS			          "WLRand"
#define WLJSNAME_RAND_OBJECT		          "wlRand"
#define WLJSNAME_RAND_SEED					      "Seed"
#define WLJSNAME_RAND_NUM						      "Num"
#define WLJSNAME_RAND_RANGE					      "Range"
#define WLJSNAME_RAND_SELECT				      "Select"

//  functions names
#define WLJSNAME_SLEEP_FUNC					      "Sleep"
#define WLJSNAME_SLEEP_ALWAYS_FUNC	      "SleepAlways"
#define WLJSNAME_SET_TIMER_FUNC			      "SetTimer"
#define WLJSNAME_DISABLE_JAVA_DEFAULT_STATISTICS_FUNC			"DisableJavaDefaultStatistics"
#define WLJSNAME_ENABLE_JAVA_DEFAULT_STATISTICS_FUNC			"EnableJavaDefaultStatistics"
#define WLJSNAME_IS_ABORT									"IsAbort"			
#define WLJSNAME_SEND_TIMER_FUNC		      "SendTimer"
#define WLJSNAME_SEND_COUNTER_FUNC	      "SendCounter"
#define WLJSNAME_SEND_MEASUREMENT_FUNC	  "SendMeasurement"

#define WLJSNAME_REPORT "Report"

#define WLJSNAME_TRACE_MESSAGE				    "TraceMessage"
#define WLJSNAME_INFO_MESSAGE				      "InfoMessage"
#define WLJSNAME_WARNING_MESSAGE				  "WarningMessage"
#define WLJSNAME_ERROR_MESSAGE			      "ErrorMessage"
#define WLJSNAME_SEVERE_ERROR_MESSAGE			"SevereErrorMessage"

#define WLJSNAME_LOCK											"Lock"
#define WLJSNAME_UNLOCK										"Unlock"

#define WLJSNAME_STOPTEST                 "StopGenerator"

#define WLJSNAME_VERIFICATION_SET_FAILURE_REASON_EX						"SetFailureReasonEx"
#define WLJSNAME_VERIFICATION_RECORD_EVENT_EX									"ReportEventEx"
#define WLJSNAME_VERIFICATION_BEGIN_TRANSACTION_EX						"BeginTransactionEx"
#define WLJSNAME_VERIFICATION_END_TRANSACTION_EX							"EndTransactionEx"
#define WLJSNAME_VERIFICATION_END_TRANSACTION_FAILURE_EX			"EndTransactionFailureEx"
#define WLJSNAME_VERIFICATION_GET_TRANSACTION_DEPTH_EX				"GetTransactionDepthEx"
#define WLJSNAME_VERIFICATION_GET_CURRENT_TRANSACTION_EX			"GetCurrentTransactionEx"

#define WLJSNAME_VERIFICATION_BEGIN_TRANSACTION "BeginTransaction"
#define WLJSNAME_VERIFICATION_END_TRANSACTION "EndTransaction"
#define WLJSNAME_VERIFICATION_RECORD_EVENT  "ReportEvent"
#define WLJSNAME_VERIFICATION_SET_FAILURE_REASON  "SetFailureReason"
#define WLJSNAME_VERIFICATION_GET_CURRENT_TRANSACTION  "GetCurrentTransaction"
#define WLJSNAME_VERIFICATION_GET_TRANSACTION_DEPTH  "GetTransactionDepth"
#define WLJSNAME_VERIFICATION_SUCCESS       "WLSuccess"
#define WLJSNAME_VERIFICATION_NOTE		      "WLNote"
#define WLJSNAME_VERIFICATION_WARNING       "WLMinorError"
#define WLJSNAME_VERIFICATION_ERROR         "WLError"
#define WLJSNAME_VERIFICATION_SEVERE_ERROR  "WLSevereError"
#define WLJSNAME_VERIFICATION_GENERAL_REASON "General Failure"
#define WLJSNAME_VERIFICATION_NOT_COMPLETED "Not Completed"


#define WLJSNAME_GETLINE_RANDOM "WLRandom"
#define WLJSNAME_GETLINE_SEQUENTIAL "WLSequential"

#define WLJSNAME_SYNCHRONIZATION_POINT    "SynchronizationPoint"
//#define WLJSNAME_SYNCHRONIZATION_POINT_STATUS_ERROR "WLError"  : same as WLJSNAME_VERIFICATION_ERROR
#define WLJSNAME_SYNCHRONIZATION_POINT_STATUS_RESCHEDULE "WLLoadChanged"
#define WLJSNAME_SYNCHRONIZATION_POINT_STATUS_TIMEOUT "WLTimeout"
#define WLJSNAME_SYNCHRONIZATION_POINT_STATUS_NORMAL "WLOK"
#define WLJSNAME_INCLUDE                      "IncludeFile"
#define WLJSNAME_INCLUDE_EXECUTE_SCRIPT       "WLExecuteScript"
#define WLJSNAME_INCLUDE_DONT_EXECUTE_SCRIPT  "WLDontExecuteScript"
#define WLJSNAME_CREATE_JAVA_THREAD_WRAPPER		"CreateJavaThreadWrapper"
#define WLJSNAME_EVALUATE_SCRIPT              "EvaluateScript"
#define WLJSNAME_EVALUATE_SCRIPT_BEFORE_INIT_CLIENT				"WLBeforeInitClient"
#define WLJSNAME_EVALUATE_SCRIPT_AFTER_INIT_AGENDA				"WLAfterInitAgenda"
#define WLJSNAME_EVALUATE_SCRIPT_ON_THREAD_TERMINATION		"WLOnThreadTermination"//still not in use
#define WLJSNAME_EVALUATE_SCRIPT_BEFORE_THREAD_ACTIVATION	"WLBeforeThreadActivation"
#define WLJSNAME_EVALUATE_SCRIPT_ON_THREAD_ACTIVATION			"WLOnThreadActivation"
#define	WLJSNAME_EVALUATE_SCRIPT_AFTER_TERMINATE_CLIENT		"WLAfterTerminateClient"
#define	WLJSNAME_EVALUATE_SCRIPT_BEFORE_ROUND							"WLBeforeRound"
#define	WLJSNAME_EVALUATE_SCRIPT_AFTER_TERMINATE_AGENDA		"WLAfterTerminateAgenda"
#define	WLJSNAME_EVALUATE_SCRIPT_AFTER_ROUND							"WLAfterRound"
#define WLJSNAME_COPY_MONITOR_FILE            "CopyFile"
#define WLJSNAME_COPY_MONITOR_JAVA_FILE       "CopyJavaFile" // @@@@ new code
#define WLJSNAME_GC_YIELD                 "UNDOC_GCYield"
#define WLJSNAME_LOAD_SIZE                "LoadSize"
#define WLJSNAME_UNDOC_LOAD_SIZE          "UNDOC_LoadSize"
#define WLJSNAME_LOAD_GENERATOR_NO        "UNDOC_LoadGeneratorNo"
#define WLJSNAME_ERROR_COUNTER		        "UNDOC_ErrorCounter"
#define WLJSNAME_WARNING_COUNTER		      "UNDOC_WarningCounter"
#define WLJSNAME_WLJS_ATOMIC_INT_COUNTER  "UNDOC_WLJSAtomicIntCounter"
#define WLJSNAME_SPAWNING_FACTOR					"UNDOC_SpawningFactor"
#define WLJSNAME_AGENDA_NAME              "GeneratorName"
#define WLJSNAME_AGENDA_FILE_NAME					"AgendaFileName"

#define WLJSNAME_SYNTAX_CHECK_MODE        "EnableSyntaxCheck"
#define WLJSNAME_TRACE_MODE               "EnableTrace"

#define WLJSNAME_OUTPUT_FILE_CLASS        "wlOutputFile"
#define WLJSNAME_OUTPUT_FILE_WRITE        "Write"
#define WLJSNAME_OUTPUT_FILE_WRITELN      "Writeln"
#define WLJSNAME_OUTPUT_FILE_RESET        "Reset"
#define WLJSNAME_OUTPUT_FILE_CLOSE        "Close"
#define WLJSNAME_OUTPUT_FILE_OPEN         "Open"
#define WLJSNAME_OUTPUT_FILE_REMOVE       "Remove"

#define WLJSNAME_UNIQUE_ID								"VCUniqueID"

#define WLJSNAME_READ_FILE                "ReadFile"

// Local variables
#define WLJSNAME_ROUND_NUM					      "RoundNum"
#define WLJSNAME_ROUND_NUM_SCRIPT_IN_SLAVE "GetRoundNumForScriptInSlave"
#define WLJSNAME_ROUND_NUM_MIX_IN_SLAVE "GetRoundNumForMixInSlave"
#define WLJSNAME_THREAD_NUM					      "ThreadNum"
#define WLJSNAME_CLIENT_NUM					      "ClientNum"
#define WLJSNAME_THREAD_NUM_IN_SLAVE      "GetThreadNumInSlave"

// Init/Terminate function
#define WLJSNAME_INIT_AGENDA_FUNC                 "InitAgenda"
#define WLJSNAME_TERMINATE_AGENDA_FUNC            "TerminateAgenda"
#define WLJSNAME_ON_ERROR_TERMINATE_AGENDA_FUNC   "OnErrorTerminateAgenda"
#define WLJSNAME_INIT_CLIENT_FUNC                 "InitClient"
#define WLJSNAME_TERMINATE_CLIENT_FUNC            "TerminateClient"
#define WLJSNAME_ON_ERROR_TERMINATE_CLIENT_FUNC   "OnErrorTerminateClient"
#define WLJSNAME_ON_SCRIPT_ABORT_FUNC             "OnScriptAbort"

//IO Functions
#define WLJSNAME_FILE_EXIST_FUNC                 "UNDOC_WLFileExist"
#define WLJSNAME_MKDIR_FUNC                      "UNDOC_WLMkdir"
#define WLJSNAME_GET_ENV_FUNC                    "UNDOC_WLGetEnv"
#define WLJSNAME_GET_CWD_FUNC                    "UNDOC_WLGetCwd"
// end IO Functions

#define WLJSNAME_MESSAGE_REPORTER_CLASS          "MessageReporter"
#define WLJSNAME_MESSAGE_REPORTER_NAME           "Name"
#define WLJSNAME_MESSAGE_REPORTER_DESCRIPTION    "Description"
#define WLJSNAME_MESSAGE_REPORTER_ADD_MESSAGE    "AddMessage"
#define WLJSNAME_MESSAGE_REPORTER_CLEAR          "Clear"
#define WLJSNAME_MESSAGE_REPORTER_REPORT         "Report"

#define WLJSNAME_GET_SCOPE												"getScope"
#define WLJSNAME_GET_OPERATING_SYSTEM							"GetOperatingSystem"
#define WLJSNAME_GET_WORKINGSETSIZE     					"UNDOC_GetWorkingSetSize"

#define WLJSNAME_GET_TEMP_PATH                    "GetWLTempPath"

#define WLJSNAME_GET_PROTOCOL_NAMES               "GetProtocolNames"

// UNDOC stats
#define WLJSNAME_GET_STATISTIC										"UNDOC_GetStatistic"

#define WLJSNAME_SESSION_AVERAGE									"_WLSessionAverage"
#define WLJSNAME_SESSION_MINIMUM									"_WLSessionMinimum"
#define WLJSNAME_SESSION_MAXIMUM									"_WLSessionMaximum"
#define WLJSNAME_SESSION_COUNT  									"_WLSessionCount"
#define WLJSNAME_LAST_SLICE_AVERAGE								"_WLLastSliceAverage"
#define WLJSNAME_LAST_SLICE_MINIMUM								"_WLLastSliceMinimum"
#define WLJSNAME_LAST_SLICE_MAXIMUM								"_WLLastSliceMaximum"
#define WLJSNAME_LAST_SLICE_COUNT  								"_WLLastSliceCount"

#define WLJSNAME_SESSION_AVERAGE_VALUE						0
#define WLJSNAME_SESSION_MINIMUM_VALUE						1
#define WLJSNAME_SESSION_MAXIMUM_VALUE						2
#define WLJSNAME_SESSION_COUNT_VALUE  						3
#define WLJSNAME_LAST_SLICE_AVERAGE_VALUE					4
#define WLJSNAME_LAST_SLICE_MINIMUM_VALUE					5
#define WLJSNAME_LAST_SLICE_MAXIMUM_VALUE					6
#define WLJSNAME_LAST_SLICE_COUNT_VALUE						7
// end UNDOC stats

//Galtech
#ifndef _ANSI_ONLY
#define WLJSNAME_CHARSET_ARABIC_ISO			"WLArabicISO"
#define WLJSNAME_CHARSET_BALTIC_ISO			"WLBalticISO"
#define WLJSNAME_CHARSET_CENTRAL_EUROPEAN_DOS	"WLCentralEuropeanDOS"
#define WLJSNAME_CHARSET_CENTRAL_EUROPEAN_ISO	"WLCentralEuropeanISO"
#define WLJSNAME_CHARSET_CHINESE_SIMPLIFIED	"WLChineseSimplified"
#define WLJSNAME_CHARSET_CHINESE_TRADITIONAL	"WLChineseTraditional"
#define WLJSNAME_CHARSET_CYRILLIC_DOS			"WLCyrillicDOS"
#define WLJSNAME_CHARSET_CYRILLIC_ISO			"WLCyrillicISO"
#define WLJSNAME_CHARSET_CYRILLIC_KOI8R		"WLCyrillicKOI8R"
#define WLJSNAME_CHARSET_GREEK_ISO				"WLGreekISO"
#define WLJSNAME_CHARSET_GREEK_DOS				"WLGreekDOS"
#define WLJSNAME_CHARSET_HEBREW_DOS			"WLHebrewDOS"
#define WLJSNAME_CHARSET_HEBREW_ISO			"WLHebrewISO"
#define WLJSNAME_CHARSET_HEBREW_VISUAL			"WLHebrewVisual"
#define WLJSNAME_CHARSET_HEBREW_LOGICAL		"WLHebrewLogical"
#define WLJSNAME_CHARSET_HEBREW_MAC			"WLHebrewMac"
#define WLJSNAME_CHARSET_ICELANDIC_DOS			"WLIcelandicDOS"
#define WLJSNAME_CHARSET_JAPANESE_SHIFT_JIS	"WLJapaneseShiftJIS"
#define WLJSNAME_CHARSET_JAPANESE_JIS			"WLJapaneseJIS"
#define WLJSNAME_CHARSET_JAPANESE_EUC			"WLJapaneseEUC"
#define WLJSNAME_CHARSET_KOREAN_ISO			"WLKoreanISO"
#define WLJSNAME_CHARSET_LATIN_1_ISO			"WLLatin1ISO"
#define WLJSNAME_CHARSET_LATIN_3_ISO			"WLLatin3ISO"
#define WLJSNAME_CHARSET_TURKISH_ISO			"WLTurkishISO"
#define WLJSNAME_CHARSET_UNICODE				"WLUnicode"
#define WLJSNAME_CHARSET_UTF7					"WLUTF7"
#define WLJSNAME_CHARSET_UTF8					"WLUTF8"
#define WLJSNAME_CHARSET_US_ASCII				"WLUSASCII"
#define WLJSNAME_CHARSET_WESTERN_EUROPEAN_DOS	"WLWesternEuropeanDOS"
#define WLJSNAME_CHARSET_WESTERN_EUROPEAN_MAC	"WLWesternEuropeanMac"
#define WLJSNAME_CHARSET_WESTERN_EUROPEAN_ISO	"WLWesternEuropeanISO"
#endif

#define YES_STR_VALUE								"Yes"
#define NO_STR_VALUE								"No"
#define TRUE_STR_VALUE							"true"
#define FALSE_STR_VALUE							"false"


#define WLJSNAME_GET_THREAD_TYPE "GetThreadType"
#define WLJSNAME_THREAD_LE "WLThreadTypeLoad"
#define WLJSNAME_THREAD_PC "WLThreadTypeProbingClient"
#define WLJSNAME_THREAD_BP "WLThreadTypeBrowserPlayback"

// wlShell
#define WLJSNAME_SYSTEM_SHELL_CLASS "WLShell"
#define WLJSNAME_SYSTEM_SHELL_OBJECT "wlShell" 
#define WLJSNAME_SYSTEM_SHELL_SYSTEM "System"
// end wlShell

// wlJsException
#define WLJSNAME_EXCEPTION_CLASS "wlException"
#define WLJSNAME_EXCEPTION_GET_SEVERITY "GetSeverity"
#define WLJSNAME_EXCEPTION_TO_STRING "toString"
#define WLJSNAME_EXCEPTION_GET_MESSAGE "GetMessage"
// end wlJsException

// CriticalSection
#define WLJSNAME_ENTER_CRITICAL_SECTION "EnterCriticalSection"
#define WLJSNAME_EXIT_CRITICAL_SECTION "ExitCriticalSection"
// end CriticalSection

bool WLJSAddGlobalFunctions(JSContext* cx, JSObject* obj, JSObject* proto);
bool WLJSAddLocalProperties(JSContext* cx, JSObject* obj, int nThread);
//bool WLJSAddGlobalObject(JSContext* cx, JSObject* obj, CLoadEngineVariablesData* pVariablesData);
JSObject* WLJSAddGlobalObject(JSContext* cx, JSObject* obj, CLEVariablesData* pVariablesData);
bool WLJSIsGlobalPerThreadObject( JSContext* cx, JSObject* obj );
JSObject* WLJSAddGlobalPerThreadObject(JSContext* cx, JSObject* obj, CLEVariablesData* pVariablesData);
bool WLJSAddLocalObject(JSContext* cx, JSObject* obj, CLEVariablesData* pVariablesData);
bool AddGlobalsClass( JSContext* cx, JSObject* glob );

#endif __WL_LOADJSDEFS_H

