/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _LOADJSPROPERTOBJ_H
#define _LOADJSPROPERTOBJ_H

#include <collint.h>
#include <RVCString.h>
#include "rvjsapi.h"

class CLEVariablesData;
struct JSContext;
struct JSObject;

JSObject* NewPropertyObject( JSContext* cx, RVCString& propName, CLEVariablesData* pVariablesData);
void PropertyObjectFinalize(JSContext *cx, JSObject *obj);
JSClass* GetPropertyObjectJSClass();


/////////////////////////////////////////////////////////////////////////////////////////
//
//						The declaration of the class CPropertyObjectPrivateData
//
/////////////////////////////////////////////////////////////////////////////////////////

class CPropertyObjectPrivateData {
private:
	RVCString m_Name;
	CLEVariablesData* m_pVariablesData;
public:
	explicit CPropertyObjectPrivateData(RVCString& name, CLEVariablesData* pVariablesData);
	~CPropertyObjectPrivateData() {} ;
	RVCString GetName() { return m_Name; }
	CLEVariablesData* GetVariablesData() { return  m_pVariablesData; }
};

#endif
