/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WL_OUTPUT_FILE_H_
#define __WL_OUTPUT_FILE_H_


#include "rvjsapi.h"

#include <RVCString.h>
#include <stdio.h>
#include <thr.h>
#ifdef __TV_UNIX__
#include <windows.h>
#endif

#include "tvpeventqueue.h"
#include "associativearray.h"
#include <hashdict.h>

class CLoadAgendaManager;
class IGeneralManagerScriptData;

class CWLOutputFileHandler {
private:
  CLoadAgendaManager* m_LoadAgendaManager;
	RVThread          m_OutputFileThread;
	TVPEventQueue	    m_Messages;
  TVPManualEvent    m_TerminateEvent;
  RVHashDictionary  m_OutputFileList;
  bool              m_ThreadStarted;
	void run();
public:
  CWLOutputFileHandler();
	~CWLOutputFileHandler();
  void SetLoadAgendaManager(CLoadAgendaManager* lam);
	void Start();
	void Terminate();
	void PutMessage(CAssociativeArray* Message);
};

class CWLOutputFile : public RVCollectable {
private:
  RVCString           m_FileName;
  FILE*               m_File;
  RVCriticalSection*  m_WriteMutex;
  bool                m_Global;
	IGeneralManagerScriptData* m_ThreadsManagerScript;
public:
  CWLOutputFile(const char* filename,bool global, IGeneralManagerScriptData*);
  ~CWLOutputFile();
  bool Open(const char* mode = "w");
  bool Write(const char* data);
  bool Writeln(const char* data);
  bool Reset();
  bool Close();
  bool Remove();
  const RVCString& FileName() {return m_FileName;};
};

bool AddOutputFileClass(JSContext *cx, JSObject *obj);
#endif //__WL_OUTPUT_FILE_H_

