/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// SlaveLoadSizeManager.h: interface for the CSlaveLoadSizeManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(__LOADENGINE_SlaveLoadSizeManager_H__)
#define __LOADENGINE_SlaveLoadSizeManager_H__

#include <ordered.h>
#include <thr.h>

class CSlaveLoadSizeManager 
{
private:
  RVOrdered         m_LoadSizeList;
  RVMutexLock       m_ListLock;
  double            m_BeginTime;
  double            m_SliceSize;
  double            m_NextSliceEnd;
  long              m_CurrentLoadSize;

  void NewLoadSize( long delta, double now );

public:
	CSlaveLoadSizeManager();
	virtual ~CSlaveLoadSizeManager();

	void Start( double beginTime, double sliceSize );
  void AddThread(double now);
  void RemoveThread(double now);
  void GetLoadSize( double endTime, double& averageLoadSize, double& sliceLoadSize );
};

#endif // !defined(__LOADENGINE_SlaveLoadSizeManager_H__)

