/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _WLGLOBALS_H
#define _WLGLOBALS_H

#include <collstr.h>
#include <hashdict.h>

#include "globalvariableproperties.h"

///////////////////////////////////////////////////////////////////////////////
//
// Interface for CWLGlobalsDictionary class
///////////////////////////////////////////////////////////////////////////////

class CWLGlobalsDictionary: public RVHashDictionary
{
public:
	CWLGlobalsDictionary(size_t n);
	~CWLGlobalsDictionary();

	CGlobalVariableProperties* GetVariableProperties(const char* variableName);
	CGlobalVariableProperties* ReplaceVariableProperties(const char* variableName, CGlobalVariableProperties *variableProperties);
	bool AddVariableAndProperties(const char* variableName, CGlobalVariableProperties *variableProperties);
};


///////////////////////////////////////////////////////////////////////////////
//
// Interface for CWLGlobalsObject class
///////////////////////////////////////////////////////////////////////////////
class DllExport CWLGlobalsObject: public RVCollectable
{
private:
	CWLGlobalsDictionary m_VariablesDictionary;

public:
	CWLGlobalsObject(const char* name);
	~CWLGlobalsObject(void);

	void Set(const char* variableName, CGlobalVariableProperties *newProperties);
	CGlobalVariableProperties* Get(const char* variableName);

	void Add(const char* variableName, CGlobalVariableProperties *newProperties);
};

#endif

