/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __WLLEProtocolBaseTypes_H
#define __WLLEProtocolBaseTypes_H

#include "platform.h"

typedef int WLProtocolIndex;
typedef unsigned short WLProtocolThreadType;

class iLEProtocolProcess;
class iLEJSMachineThread;
class iLEVCJSThread;

class DllExport iLEProtocolMachineThread;
class DllExport iLEProtocolVCJSThread;


// Basic thread types
#define THREAD_TYPE_NONE 0
#define THREAD_TYPE_JS 1
#define THREAD_TYPE_VC 2
#define THREAD_TYPE_GC 4
#define THREAD_TYPE_CLIENT 5

// Complex thread types
#define THREAD_TYPE_SINGLE_CLIENT (THREAD_TYPE_VC | THREAD_TYPE_GC)


//####### The declaration of the class iLEProtocolMachineThread  #########

class iLEProtocolMachineThread {
public:
	iLEProtocolProcess&   m_iLEProtocolProcess;
  WLProtocolThreadType  m_ProtocolThreadType;

public:
  explicit iLEProtocolMachineThread(iLEProtocolProcess& piLEProtocolProcess, WLProtocolThreadType pProtocolThreadType):
    m_iLEProtocolProcess(piLEProtocolProcess),
    m_ProtocolThreadType(pProtocolThreadType)
  {};

  virtual ~iLEProtocolMachineThread() {};

  virtual iLEJSMachineThread& GetJSMachineThread() = 0;  
};



//####### The declaration of the class iLEProtocolVCJSThread  #########

class iLEProtocolVCJSThread {
public:
	explicit iLEProtocolVCJSThread() {};
	virtual ~iLEProtocolVCJSThread() {};
	virtual iLEVCJSThread& vGetVCJSThread() = 0;
		iLEVCJSThread& fGetVCJSThread() { return vGetVCJSThread(); }
};

#endif

