/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// File: WLLoadGeneratorGlobalsHandler.h
//
// Containes:
// Interface for CWLLoadGeneratorGlobalsHandler class.
//////////////////////////////////////////////////////////////////////

#if !defined(_WLLOADGENERATORGLOBALHANDLER_H__)
#define _WLLOADGENERATORGLOBALHANDLER_H__

#include <thr.h> 
#include <collectable.h>

#include "netkernelmessagehandler.h"
#include "loadgeneratorslaveproxy.h"
#include "tvpeventqueue.h"
#include "wlglobalstable.h"



/**
 * Class CWLLoadGeneratorGlobalsHandler
 *
 * This class has one instance per LoadGenerator
 * and will keep and handle global variables for Agenda(mix/no mix)
 * and current script in mixed Agenda levels shared between LG
 * and all his spawns and threads.
 **/

class CLoadAgendaManager;

class CWLLoadGeneratorGlobalsHandler
{
private:
	CWLGlobalsTable    m_GlobalsTable;
	TVPEventQueue      m_MessagesQueue;
	RVThreadFunction   m_MessagesHandlingThread;
	CLoadAgendaManager *m_AgendaManager;

private:
	struct Request: public RVCollectable
	{
		CAssociativeArray *m_Request;
		CLoadGeneratorSlaveProxy *m_SlaveProxy;
	};
	void MainLoop(void);
	
public:
	CWLLoadGeneratorGlobalsHandler(void);
	virtual ~CWLLoadGeneratorGlobalsHandler(void);

	void SetLoadAgendaManager(CLoadAgendaManager *agendaManager);
	virtual void MessageHandler(CAssociativeArray& request, CLoadGeneratorSlaveProxy *slaveProxy);
	void Terminate(void);
};


#endif // _WLLOADGENERATORGLOBALHANDLER_H__

