/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
package regression;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import netscape.javascript.JSObject;

/**
 * Title:        Applet Load regression Applet
 * Description:  An applet for the Applet Load regression.
 * Copyright:    Copyright (c) 2002
 * Company:      Radview Software
 * @author Yahali Sherman
 * @version 1.0
 */

public class Regression1 extends Applet {
  boolean isStandalone = false;
  String showDocHref;
  String showDocTarget;
  String showDocInit;
	String getWindow;
  String messageAddr;
  String message;
	URL showDocUrl;
  String getImageHref;
	URL getImageUrl;
	Image image;
  String paramList;
  String var2;
  String var3;
  TextArea textArea1 = new TextArea();
  Button button1 = new Button();
  Button button2 = new Button();
  Label label2 = new Label();

  /**Get a parameter value*/
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

	public int getIntParameter(String key, int defValue)
	{
		String value = getParameter(key, null);
		int ret = defValue;
		if (value != null) {
			try {
				ret = Integer.parseInt(value);
			} catch (NumberFormatException e) {}
		}

		return ret;
	}

  /**Construct the applet*/
  public Regression1() {
  }

  /**Get parameter info*/
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"showDoc", "String", "Contains the value of the document to show"},
      {"showDocTarget", "String", "Target frame for the showDocument"},
      {"showDocInit", "String", "If exists, will call showDocument in init"},
      {"getImage", "String", "The href for the getImage"},
      {"getWindow", "String", "Will activate the JSObject.getWindow function to access the DOM"},
      {"paramList", "String", "List of params to display"},
      {"MessageAddr", "String", "Name of the applet to dend message to"},
      {"Message", "String", "The message"}
      };
    return pinfo;
  }
  /**Initialize the applet*/
  public void init() {
    try {
      messageAddr = this.getParameter("messageAddr", null);
      message = this.getParameter("message", null);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      showDocHref = this.getParameter("showDoc", "");
      showDocTarget = this.getParameter("showDocTarget", null);
			showDocUrl = new URL(getCodeBase(), showDocHref);
      showDocInit = this.getParameter("showDocInit", null);
			if (showDocInit != null)
				showDocument();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      getImageHref = this.getParameter("getImage", "");
			getImageUrl = new URL(getCodeBase(), getImageHref);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      paramList = this.getParameter("paramList", "");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      getWindow = this.getParameter("getWindow", null);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

		if (messageAddr != null) {
			sendMessage(messageAddr, message);
		}

		if (getWindow != null) {
      try
			{
				JSObject jsobject = JSObject.getWindow(this);
				JSObject jsobject1 = (JSObject)jsobject.getMember("document");
				JSObject jsobject2 = (JSObject)jsobject1.getMember("location");
				String s = (String)jsobject2.getMember("host");
				textArea1.setText("Hostname = " + s);
			} catch (Throwable e) {
			//} catch (Exception e) {
				e.printStackTrace();
			}
		}
  }
  /**Component initialization*/
  private void jbInit() throws Exception {
    textArea1.setText("Hello World");
    button1.setLabel("Show Document");
		label2.setText("Messages label");
    button1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        button1_mouseClicked(e);
      }
    });
    button2.setLabel("Show Params");
    button2.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        button2_mouseClicked(e);
      }
    });
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(ComponentEvent e) {
        this_componentShown(e);
      }
      public void componentResized(ComponentEvent e) {
        this_componentResized(e);
      }
    });
    this.add(textArea1, null);
    this.add(button1, null);
    this.add(label2, null);
    this.add(button2, null);
  }
  /**Start the applet*/
  public void start() {
  }
  /**Stop the applet*/
  public void stop() {
  }
  /**Destroy the applet*/
  public void destroy() {
  }
  /**Get Applet information*/
  public String getAppletInfo() {
    return "Applet Information";
  }

	public String showDocument()
	{
		if (showDocUrl != null) {
			if (showDocTarget == null) {
				getAppletContext().showDocument(showDocUrl);
			} else {
				getAppletContext().showDocument(showDocUrl, showDocTarget);
			}
			return showDocUrl.toString();
		}
		return null;
	}

	public void displayDocument(String href, String target)
		throws MalformedURLException
	{
		URL url = new URL(href);
		getAppletContext().showDocument(url, target);
	}

	public String showParams() {
		if (paramList.length()==0)
			return null;

		textArea1.setText("");
		StringTokenizer st = new StringTokenizer(paramList, ";");
		while (st.hasMoreTokens())
		{
			String key = st.nextToken();
			String value = getParameter(key,null);
		  textArea1.append(key+"="+value+"\n");
		}
		return textArea1.getText();
	}

	public void showImage()
	{
		image = getAppletContext().getImage(getImageUrl);
		repaint();
	}

	public void displayMessage(String message)
	{
		System.out.println("displayMessage("+message+")");
		label2.setText("Message: " + message);
	}

	public void sendMessage(String appletName, String message)
	{
		System.out.println("sendMessage("+appletName+","+message+")");
		Regression1 a = (Regression1)getAppletContext().getApplet(appletName);
		a.displayMessage(message + " from:" + getParameter("name","Unknown"));
	}

  public void paint(Graphics g)
  {
		int width = getIntParameter("width", 400);
		int height = getIntParameter("height", 400);

		if (image != null) {
			g.drawImage(image, 0, height-150, this);
			displayMessage("Image URL = " + getImageUrl.toString());
		}
		textArea1.setLocation(10,10);
		textArea1.setSize(width-20,height-200);
		button1.setLocation(10,height-180);
		button2.setLocation(150,height-180);
		label2.setSize(width-20,20);
		label2.setLocation(10, height-20);

  }

	public void setBGColor(int r, int g, int b)
	{
		Color c = new Color(r,g,b);
		setBackground(c);
	}

  void button2_mouseClicked(MouseEvent e) {
		Regression1 a = (Regression1)e.getComponent().getParent();
		a.showParams();
		a.showImage();
  }

  void button1_mouseClicked(MouseEvent e) {
		Regression1 a = (Regression1)e.getComponent().getParent();
		a.showDocument();
  }

  void this_componentShown(ComponentEvent e) {
		repaint();
  }

  void this_componentResized(ComponentEvent e)
	{
		repaint();
  }
}
