/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <RVCString.h>

#include "rvjsapi.h"
#include "rvjs.h"

#include "loadengineglobals.h"
#include "loadexceptions.h"
#include "loadjserrorfuncs.h"

#include "loadthreadsmanager.h"

#include "rvjsclient.h"

cLoadReportCommit::cLoadReportCommit(
	JSContext* rCx,
	const char* rMessage,
	JSErrorReport* rErrorReport )
:
	iJSExecReportCommit(rCx,rMessage,rErrorReport) 
{}



void cLoadReportCommit::fsSignContext(
	JSContext* Context ) 
{
	JS_SetErrorReporter( Context, fsCallbackErrorReporter );
	}

/*
void cLoadReportCommit::vReporter_iEvalReportCommit(
	JSContext* Context,
	iReportThreadState& ThreadState,
	iReportInfo& Info_ ) 
{

	if( iLoadReportInfo* Info = dynamic_cast<iLoadReportInfo*>(&Info_) ) {
		
		cLoadReport aReport( ThreadState, *Info );

		iLEJSEmbedContext* aEmbedContext = iLEJSEmbedContext::fsGet( Context );
		WlAssert(aEmbedContext);
		aEmbedContext->reportLog( aReport );
		}
	}
*/
/*
void cLoadReportCommit::vInternalReporter_iEvalReportCommit(
	JSContext* Context,
	iReportThreadState& ThreadState,
	cInternalReportInfo& Info ) 
{

	cJSInternalReport aReport( ThreadState, Info );

	iLEJSEmbedContext* EmbedContext = iLEJSEmbedContext::fsGet(Context);
	EmbedContext->reportLog( aReport ); // current time
	if(	CLoadGeneratorThreadInstanceScript* TSI = dynamic_cast<CLoadGeneratorInstanceScript*>(EmbedContext) ) {
		TSI->VerificationSetFailureReason("JavaScript Engine Error",NULL, TSI->fGetProcess().fGetCurrentTime(), true);
	}
	EmbedContext->reportApply( aReport );
}
*/


void cLoadReportCommit::fsCallbackErrorReporter(
	JSContext* Context,
	const char* Message,
	JSErrorReport* ErrorReport ) {

	cLoadReportCommit Commit( Context, Message, ErrorReport );

	Commit.fCommit(gShouldReportInternalCSJSErrors(Context));
	}

bool gShouldReportInternalCSJSErrors(JSContext* Cx){
  iLEJSEmbedContext* aEmbedContext = iLEJSEmbedContext::fsGet(Cx);
  WlAssert(aEmbedContext);
  iLEJSClientEmbedContext* aCSJSEmbedContext = dynamic_cast<iLEJSClientEmbedContext*>(aEmbedContext);
  bool ReportInternal =  (!aCSJSEmbedContext || (aCSJSEmbedContext && aCSJSEmbedContext->fGetThreadInstanceScript().GetJSScript().m_PropWorkSpace.m_ReportCSJSInternalErrors));
  return ReportInternal;
	}
	


/*
#ifdef XP_UNIX
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#endif

#ifdef XP_MAC
#define isatty(f) 1
#endif
*/


