/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "rvjavamachinethread.h"

#include "jsjavacore.h"

iRVJavaMachineThread::iRVJavaMachineThread()
:
	mJEnv(NULL),
	mJSJThreadState(NULL)
{}

iRVJavaMachineThread::~iRVJavaMachineThread()
{}

void iRVJavaMachineThread::fInit()
{}

void iRVJavaMachineThread::fFinal()
{

	if( mJEnv ) {

		if( mJSJThreadState ) {
			bool aStatus = fGetJVM().fJSJDetachCurrentThread( mJSJThreadState );
			//bool aStatus = fGetJVMManager().fGetJVM().fJSJDetachCurrentThread( mJSJThreadState );
			WlAssert(aStatus); //@@ add reporting
			mJSJThreadState = NULL;
		} else {
			bool aStatus = fGetJVM().fDetachCurrentThread();
			WlAssert(aStatus); //@@ add reporting
		}
		mJEnv = NULL; 

	} else {
		WlAssert(!mJSJThreadState); // JSJ is initialized but Java is not.
	}

}


bool iRVJavaMachineThread::fIsJEnv()
{
	return mJEnv ? true : false;
}

JNIEnv* iRVJavaMachineThread::fGetifJEnv()
{
	return mJEnv;
}
/*
void iRVJavaMachineThread::fSetJEnv(
	JNIEnv* r)
{
	mJEnv = r;
}

iRVJavaMachineThread::fSetJSJThreadState(
	JSJavaThreadState* r )
{
	mJSJThreadState = r;
}
*/
JNIEnv* iRVJavaMachineThread::fGetJEnv()
{
	JNIEnv* aJEnv = mJEnv;

	if( !aJEnv ) {

		if( fGetJVM().fAttachCurrentThread( aJEnv ) ) {
			mJEnv = aJEnv;
		} else {
			aJEnv = NULL;
		}
	}

	return aJEnv;
}

JSJavaThreadState* iRVJavaMachineThread::fGetJSJThreadState()
{
	JSJavaThreadState* aJSJThreadState = mJSJThreadState;

	if( !aJSJThreadState ) {

		JNIEnv* aJEnv = fGetJEnv();

		if( aJEnv ) {
			if( fGetJVM().fJSJAttachCurrentThread( aJSJThreadState, aJEnv ) ) {
				mJSJThreadState = aJSJThreadState;
			} else {
				aJSJThreadState = NULL;
			}
		} else {
			aJSJThreadState = NULL;
		}
		
	}
	
	return aJSJThreadState;
}

