/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <RVCString.h>
#include "platform.h"
#include "tvtables.h"
#include "tracedll.h"
#include "wlerrorlib.h"
#include "platform.h"
#include "wlerrorlib.h"
#include "loadjsshell.h"
#include "loadexceptions.h"
#include "loadengineglobals.h"
#include "loadthreadinstance.h"
#include "loadthreadsmanager.h"

static char buf[800] = "";

long getint(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
	return atol(buf);
}

char* getstr(const char* text)
{
  cout << text;
  cin.getline(buf,sizeof(buf));
  return buf;
}

static int count=1;

class TestThreadInstanceScript : public CLoadGeneralThreadInstanceScript  {
private:
  int id;
public:
  TestThreadInstanceScript(CLoadThreadInstance *threadInstance) :
    CLoadGeneralThreadInstanceScript (threadInstance)
  {
    id=count++;
  }
  ~TestThreadInstanceScript() {}
};

//
// HTTP Loaduar functions:
TestThreadInstanceScript* JSNewTestThread(CLoadThreadInstance *threadInstance)
{
  WlTraceMsg("JSNewWebThread: new instance()");
	TestThreadInstanceScript* hp = new TestThreadInstanceScript(threadInstance);
  WlTraceMsg("instance[%x] created", hp);
  return (CLoadGeneralThreadInstanceScript

bool WLInitTestGeneratorShell(CWLJSShell*)
{
  WlTraceMsg("INSIDE WLInitTestGeneratorShell");
  return true;
}

bool WLInitTestGeneratorScript(CWLJSScript*)
{
  WlTraceMsg("INSIDE WLInitTestGeneratorScript");
  return true;
}

bool WLInitTestGeneratorThread(CWLJSThread*)
{
  //WlTraceMsg("INSIDE WLInitTestGeneratorThread");
  return true;
}

int main(int argc, char *argv[])
{
	CTraceMsg::Init("SingleTest");
  WlTraceMsg("Starting LoadEngineTest:main(%s,%s,%s,%s)",argv[1], argv[2], argv[3], argv[4]);

  //RegisterWLENewThreadInstanceScriptFunc(JSNewTestThread);
  RegisterWLInitGeneratorShell(WLInitTestGeneratorShell);
  RegisterWLInitGeneratorScript(WLInitTestGeneratorScript);
  RegisterWLInitGeneratorThread(WLInitTestGeneratorThread);

  RVCString scriptName = argv[1];

  CLoadThreadsManager agen("sm");
  CLoadThreadInstance ins(&agen, 1);
  //setCurrentThreadInstance(&ins);

  CWLJSShell jsShell;
  jsShell.Init();
  CWLJSScript jsScript;
  jsScript.Init(&jsShell);
  if (!jsScript.LoadScript(scriptName)) {
    //throw WLErrorException(LoadExceptionFrmFile, 34, jsScript.GetError());
    cout << "Error " << jsScript.GetError() <<" while loading script";
    return 0;
  }
  CWLJSThread jsThread;
  jsThread.Init(&jsScript,1);

	int choice = 0;
	while (1) {
		switch (choice)
      {
      case 0:
				cout << endl
						 << "1. Run script" << endl
						 //<< "2. Load new script" << endl
						 << "2. Evaluate string" << endl
						 << "99. Exit" << endl;
				break;

			case 1: 
			{
        if (!jsThread.ExecScript()) {
          //throw WLErrorException(LoadExceptionFrmFile, 35, jsThread.GetError());
          cout << "Error " << jsThread.GetError() <<" while running script";
        }
			}
			break;

			case 2: 
			{
			}
			break;

			case 3: 
			{
			}
			break;

			case 99:
        TVSTerminate();
        WLERRTerminate();
        return 1;

      default:
        cout << "Illegal option" << endl << endl;
        break;
      } // end switch

		choice = getint("Please enter selection: [0]");
  } // end while
}

