/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __RV_HTML_DIET_TransactionsObject__
#define __RV_HTML_DIET_TransactionsObject__

#include "platform.h"
#include <RVCString.h>
#include <collectable.h>
#include <hashdict.h>
#include "rvhtmldietvirtualqueue.h"
#include "rvhtmlparseutils.h"

#define CHECKSUM_VAR unsigned long
class CRVHTMLDietAttributeObject;

class DllExport CRVHTMLDietTransactionsObject : public RVCollectable
{
  
public:
  CRVHTMLDietTransactionsObject();
  ~CRVHTMLDietTransactionsObject();
  
  const char* GetTagName();
  void SetTagName(const char* p_sTagName);
  static CHECKSUM_VAR CalcCheckSum(const void* p_pvBuff, int p_nLength);
  void InsertAttributeObject(CRVHTMLDietAttributeObject* p_pAttributeObject);
  CRVHTMLDietAttributeObject* GetAttributeObject(RVCString& p_sAttributeName);
  CRVHTMLDietAttributeObject* GetFirstAttributeObject();
  bool GetAttributeNames(RVOrdered& p_oAttributeNamesArray);
  void PrintAll();

private:
  RVCString m_sTag;
  RVHashDictionary m_oAttributeObjects;
  RVOrdered m_oAttributeOrdered;
};

#endif
