/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __RV_HTML_OFFSET_PARSER__
#define __RV_HTML_OFFSET_PARSER__
#include "platform.h"
#include "rvhtmlparseutils.h"
#include "rvhtmldietvirtualqueue.h"
#include "wlurlbase.h"
#include <RVCString.h>
#include <hashdict.h>

class DllExport CHTMLOffsetParser {
public:
  CHTMLOffsetParser(const char* p_sBaseUrl = NULL);
  virtual ~CHTMLOffsetParser();
  void ParseHTML(const char* p_sHTMLData, size_t p_nSize);
  void SetDietVirtualQueue(CRVHtmlDietVirtualQueue* p_pDietQueue);
  CRVHtmlDietVirtualQueue* GetDietVirtualQueue();
  void ParseCSS(const RVCString& p_sData);
  void InsertObjectToQueue(CRVHTMLDietTransactionsObject* p_pTransactionsObject);
  void PrintAll();
private:
  void parseHTMLElement(RVCString p_sTagName);
  RVCString findTagName();
  bool isWhiteSpace(char& c);
    
  RVCString m_sBuffer;
  size_t m_nBuffPos;
  readStateE m_eReadState;
  CRVHtmlDietVirtualQueue* m_pDietVirtualQueue;
  RVHashDictionary m_oElementAttributesHash;
  urlBase m_oUrlBase;
  RVOrdered m_oOrderedTrans;
};


#endif
