/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __RV_HTML_PARSE_UTILS__
#define __RV_HTML_PARSE_UTILS__

#include "platform.h"
#include <RVCString.h>



enum strVal{
    HTML_STRING_NOT_COMPLETE,
    HTML_STRING_COMPLETE
};


enum protclType {
	NO_protcl,
	FTP_protcl,
	FILE_protcl,
	HTTP_protcl,
	HTTPS_protcl,
	MAILTO_protcl,
	JAVASCRIPT_protcl,
	OTHER_protcl,
	CLSID_prop
};

DllExport protclType getProtocol(const RVCString &url, int& protcl);
DllExport void      stripUrl(RVCString& url, bool bUnEscapeURL = true);
DllExport bool			htmlIsWhiteSpace(char c);
DllExport strVal		htmlGetStringValue(RVCString& sBuff, RVCString& str, size_t beginIndex, size_t& startAttributsPtr, size_t& endAttributsPtr, size_t buffLength);
DllExport bool			htmlSkipWhiteSpaces(RVCString& sBuff, size_t buffLength, size_t& beginIndex);
DllExport bool      htmlSkipNonWhiteSpaces(RVCString& sBuff, size_t buffLength, size_t& beginIndex);
DllExport  void wlSkipTagBody(const RVCString& p_sTagname, RVCString& p_sString);
DllExport void wlOverwriteTagWithBlanks(RVCString& p_sString,RVCString openingTag,RVCString closingTag);
void wlOverwriteScriptWithBlanks(RVCString& p_sString);
bool isElementOfType(const char* elementStr, size_t elementLength, RVCString& pBuff, size_t buffPos, char nextChar);
DllExport  void wlSkipOnloadAttribute(RVCString& p_sString);

enum readStateE{
    START_APPEND,
    IN_BODY_TAG,
    IN_SCRIPT,
    IN_COMMENT,
    IN_COMMENT_TAG,
    IN_DEFAULT,
    IN_DIV,
    IN_TITLE,
    IN_TEXTAREA,
    IN_BASE,
    IN_META,
    IN_HREF,
    IN_FORM,
    IN_AREA,
    IN_FRAME,
    IN_IFRAME_TAG,
    IN_IFRAME_BODY,
    IN_INPUT,
    IN_MAP,
    IN_NOEMBED,
    IN_NOFRAME,
    IN_NOSCRIPT,
    IN_IMG,
    IN_BGSOUND,
    IN_EMBED,
    IN_OBJECT,
    IN_APPLET,
    IN_LINK,
    IN_SPAN,
    IN_STYLE,
    IN_TABLES,
    IN_XML,
    IN_UNKNOWN
};


#endif
