/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __URLCMP_H
#define __URLCMP_H

#include "platform.h"
#include <collectable.h>

#define WORST_GRADE   1000
#define MAX_DIFFS     4

//! holds the results of comparing two URLs
//! All data is public. No access methods. Actually it's only a container
//! for the results.
class DllExport CDOMBaseLinkCmp : public RVCollectable {

public:

	int   searchDiffs[MAX_DIFFS];  //! an array of all differences in the QueryString
	int   numDiffs;

	bool  exactMatch;
	bool exactPropMatch;
	bool  exactUrlMatch;
	bool  hostMatch;  //! hostname matching
	bool  uriMatch;   //! URI (without the last part) matching
	bool  extMatch;   //! file extension match
	bool  searchMatch;//! QueryString matching

	bool  nameMatch;  //! Object's NAME matching
	bool  idMatch;	  //! Object's ID matching
	bool  innerTextMatch;  //! Object's InnerText matching


public:
	CDOMBaseLinkCmp() : numDiffs(0) ,
	  exactMatch(true) , exactPropMatch(true), exactUrlMatch(true), 
	  hostMatch(true) , uriMatch(true) ,
	  searchMatch(true) , nameMatch(true) , idMatch(true) ,
	  extMatch(true) , innerTextMatch(true)
	  {}

	virtual ~CDOMBaseLinkCmp() {}

	int   rank();
	int   propRank();
};

/*
class DllExport CWLCompareInstructions {
public:
	bool allowDifferentHost;     // to support host farms?
	bool allowUriDifference;     // allows one different URI component
	int  maxAllowedQSDifferences;// actually the maximum number of "session IDs"

	public
};
*/

#endif



