/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "urlcmp.h"


/*! transform the results into a numerical grade.
//
//  Host     Path      Search&Ext    grade
//  ----     ----      ----------    -----
//   ==       ==         ==           1
//   !=       ==         ==           2
//   ==       !=         ==           3
//   !=       !=         ==           4
//   ==       ==         1 diffs      5
//   !=       ==         1 diffs      6
//   ==       ==         2 diffs      7
//   !=       ==         2 diffs      8
//   ==       ==         3 diffs      9
//   !=       ==         3 diffs      10
//   ==       ==         4 diffs      11
//   !=       ==         4 diffs      12
*/
int CDOMBaseLinkCmp::rank()
{
	if( exactMatch )
		return 1;
	else if( searchMatch && extMatch )
		if( uriMatch )
			return 2;
		else //! uri do not match
		{
			if( hostMatch )
				return 3;
			else
				return 4;
		}
	else //! search  || extenssion do not match
		if( hostMatch)
			return numDiffs * 2 + 3;  //! 5,7,9,11
		else
			return numDiffs * 2 + 4;  //! 6,8,10,12
}


int CDOMBaseLinkCmp::propRank()
{
	int grade = 0;
	if( nameMatch      ) ++grade;
	if( idMatch        ) ++grade;
	if( innerTextMatch ) ++grade;

	return grade;
}

