/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// CEASTestTalkServer.h: interface for the CEASTestTalkServer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CEASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_)
#define AFX_CEASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "udpsender.h"
#include "udpreceiver.h"
#include <RVCString.h>

class EASTestTalkServer;


class CEASTestTalkServer: public UDPReceiver  
{
public:
	CEASTestTalkServer();
	CEASTestTalkServer(EASTestTalkServer* owner);
	virtual ~CEASTestTalkServer();

	// Default serverPort is taken from webload.ini
	// Key = UDP_SERVER_PORT
	virtual int  Init(u_short serverPort = 0); 

	// Starts the receiving thread and loop
	virtual int  Start(void);

	// Stops the receiving loop and thread
	virtual void Stop(void);

	int  InitPing(const char* replyHost,
								long        replyPort,
								const char* toHost,
								long        duration);

	const char* GetServerName(void);

	virtual void MessageHandler(const char* buffer);
	virtual void OnPong(const char* hostName);

private:
	RVCString					 m_EASTTServerName;
	UDPSender					 m_Sender;
	u_short						 m_ServerPort;
	EASTestTalkServer* m_Owner;
};

#endif // !defined(AFX_CEASTESTTALKSERVER_H__7770B944_740B_11D4_8831_0004AC15A422__INCLUDED_)

