/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// rfsevent.h: interface for the RFSEvent class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RFSEVENT_H__4795C907_8CCF_4383_A7BD_0F4618D3FFEF__INCLUDED_)
#define AFX_RFSEVENT_H__4795C907_8CCF_4383_A7BD_0F4618D3FFEF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "tvpsync.h"


class DllExport RFSEvent : public TVPManualEvent  
{
public:
	RFSEvent()
	{
		mResult = NULL;
	}

	virtual ~RFSEvent()
	{
		ClearResult();
	}

	void SetResult(void* result)
	{
		ClearResult();
		mResult = result;
	}

	void SetResultAndSignal(void* result)
	{
		ClearResult();
		mResult = result;
		Set();
	}

	void* GetResult()
	{
		return mResult;
	}

	void ClearResult()
	{
		if( mResult )
		{
			delete mResult;
			mResult = NULL;
		}
	}

private:
	void* mResult;
};

#endif // !defined(AFX_RFSEVENT_H__4795C907_8CCF_4383_A7BD_0F4618D3FFEF__INCLUDED_)
