/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// TestTalkToolKit.h: interface for the TestTalkToolKit class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTTALKTOOLKIT_H__C3965441_3646_11D4_87EE_0004AC15A422__INCLUDED_)
#define AFX_TESTTALKTOOLKIT_H__C3965441_3646_11D4_87EE_0004AC15A422__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#ifdef __TV_WINDOWS__
#include <io.h>
#endif
#include "socketlib.h"

#include "netevent.h"


class DllExport TestTalkToolKit
{
public:
	enum CopyFileCompletionState{ CopyFileSucceed, OpenFileFailed,
														    CloseFileFailed, ReadFileFailed,
															  WriteFileFailed };
public:
	TestTalkToolKit();
	virtual ~TestTalkToolKit();

	static bool ReadFileToBuffer(/*[IN]*/FILE* file,
															 /*[OUT]*/char*& buffer,
															 /*[OUT]*/size_t& bufferLen);

	static bool SaveBufferToFile(/*[IN]*/FILE* file,
															 /*[IN]*/const char* buffer,
															 /*[IN]*/const size_t bufferLen);

	static bool CopyFile(/*[IN]*/char* srcFilePath,
											 /*[IN]*/char* dstFilePath,
											 /*[OUT]*/TestTalkToolKit::CopyFileCompletionState& state,
											 /*[OUT]*/char*& stateFileName);

	static bool DeleteFile(/*[IN]*/const char* fileName);

	static TestTalkHostEvent* CreateReturnHostEvent(TestTalkMessage* event,
																									void* buffer,
																									size_t bufferSize,
																									int newMessageType,
																									QType queueType = ControlQ);

	static TestTalkHostEvent* CreateSendHostEvent(TestTalkMessage* event,
																								void* buffer,
																								size_t bufferSize,
																								int newMessageType,
																								QType queueType = ControlQ);

	static TestTalkClientEvent* CreateReturnClientEvent(TestTalkMessage* event,
																											void* buffer,
																											size_t bufferSize,
																											int newMessageType,
																											QType queueType = ControlQ);

	static RVCString GetLocalHostOS();
	static RVCString GetErrorString(int getLastErrorCode);//Eyal: uc???
	static int       GetLastError();
};

#endif // !defined(AFX_TESTTALKTOOLKIT_H__C3965441_3646_11D4_87EE_0004AC15A422__INCLUDED_)

