/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// EASTestTalkServer.cpp: implementation of the EASTestTalkServer class.
//
//////////////////////////////////////////////////////////////////////

#include "eastesttalkserver.h"
#include "ceastesttalkserver.h"
#include "tracedll.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

EASTestTalkServer::EASTestTalkServer()
{
	m_Self = new CEASTestTalkServer(this);
}

EASTestTalkServer::~EASTestTalkServer()
{
	delete m_Self;
}


//////////////////////////////////////////////////////////////////////
// Methods
//////////////////////////////////////////////////////////////////////

int EASTestTalkServer::Init(u_short serverPort)
{
	return m_Self->Init(serverPort);
}

int EASTestTalkServer::Start(void)
{
	return m_Self->Start();
}

void EASTestTalkServer::Stop(void)
{
	m_Self->Stop();
}

int EASTestTalkServer::InitPing(const char* replyHost,
																long        replyPort,
																const char* toHost,
																long        duration)
{
	return m_Self->InitPing(replyHost, replyPort, toHost, duration);
}

inline const char* EASTestTalkServer::GetServerName(void)
{
	return m_Self->GetServerName();
}

void EASTestTalkServer::OnPong(const char* hostName) 
{
	cout<<hostName<<endl;
	WlTraceMsg("CEASTestTalkServer::OnPong - received: %s", hostName);
}
