/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// TestTalk.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"


#include "testtalkmain.h"
#include "tvtables.h"

#include "Winsock.h"

#include "tvver.h"

#include "TrayNot.h"

#define MAX_LOADSTRING 512
#define	WM_ICON_NOTIFY WM_APP+10

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// The title bar text
WSADATA m_wsaData;
OSVERSIONINFO m_OsInfo;

CTestTalkMain *m_TestTalkMain;
CTrayNot *m_pTray = NULL;

// identifiers for tray icons
static const int	ID_ICON_MAIN	= 0 ;
static const int	ID_ICON_IDLE	= 1 ;
static const int	ID_ICON_ACTIVE	= 2 ;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	LoadString(hInstance, IDS_TESTT, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDS_TESTT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		
		if(m_TestTalkMain)
		{
			
			m_TestTalkMain->Terminate();
			delete m_TestTalkMain;
			m_TestTalkMain = NULL;
		}
		WSACleanup();

		TVSTerminate();
		WLERRTerminate();
		ACE::fini();

		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDR_MAINFRAME);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance,  MAKEINTRESOURCE(IDR_MAINFRAME));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDR_MAINFRAME);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

	//
	// set the priority class to high.
	HANDLE hProcess = GetCurrentProcess();
	SetPriorityClass(hProcess, HIGH_PRIORITY_CLASS);


	m_OsInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&m_OsInfo);

	//
	// initialize the sockets and related data.

	int err;
	WORD wVersionRequested = MAKEWORD(1, 1);

	err = WSAStartup(wVersionRequested, &m_wsaData);

	if (err != 0)
		return 0;

	if (LOBYTE(m_wsaData.wVersion) != 1 || HIBYTE(m_wsaData.wVersion) != 1) {
		int err = GetLastError();
		WSACleanup();
		return FALSE;
	}


	ACE::init();

	m_TestTalkMain = new CTestTalkMain();

	if (!m_TestTalkMain->Init())
		return FALSE;



	HWND hWnd;
	hInst = hInstance; // Store instance handle in our global variable

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}


   	HICON		m_pIconList[3] ;	// hMain, hIdle, hActive
	m_pIconList[0] = LoadIcon ( hInstance, MAKEINTRESOURCE(IDR_MAINFRAME) ) ;
	m_pIconList[1] = LoadIcon ( hInstance, MAKEINTRESOURCE(IDI_IDLE) ) ;
	m_pIconList[2] = LoadIcon ( hInstance, MAKEINTRESOURCE(IDI_CONNECT) ) ;

   	//CString strres;
	//strres.LoadString(IDS_TESTT);
	m_pTray = new CTrayNot ( hWnd, WM_ICON_NOTIFY,
		szTitle, m_pIconList ) ;

	m_pTray->SetState ( ID_ICON_IDLE ) ;

	//ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	int wmId, wmEvent;

	switch (message)
	{
	case WM_ICON_NOTIFY:


		switch ( lParam )
		{

		case WM_RBUTTONDOWN:
			{
				//
				// Load the Tray Popuop Menu
				// when the user RightClick on the Tray icon
				HMENU hMenu = ::LoadMenu(hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
				if (!hMenu)
					return 0;

				HMENU hSubMenu = ::GetSubMenu(hMenu, 0);
				if (!hSubMenu)
				{
					::DestroyMenu(hMenu);        //Be sure to Destroy Menu Before Returning
					return 0;
				}

				POINT pos;

#ifdef _WIN32_WCE
				DWORD messagepos = ::GetMessagePos();
				pos.x = GET_X_LPARAM(messagepos);
				pos.y = GET_Y_LPARAM(messagepos);
#else
				GetCursorPos(&pos);
#endif

				::SetForegroundWindow(hWnd);
				::TrackPopupMenu(hSubMenu, 0, pos.x, pos.y, 0, hWnd, NULL);

				// BUGFIX: See "PRB: Menus for Notification Icons Don't Work Correctly"
				::PostMessage(hWnd, WM_NULL, 0, 0);

				DestroyMenu(hMenu);
				break;
			}
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}


		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			// Parse the menu selections:
			switch (wmId)
			{

			case ID_APP_NETCONFIG:
			{
				//
				// Display the NetConfig dialog
				char szOutput[512];

				TCHAR strRes[MAX_LOADSTRING];
				LoadString(hInst, IDS_NETCONF, strRes, MAX_LOADSTRING);


				sprintf(szOutput, strRes,
					m_TestTalkMain->m_LocalHostName, m_TestTalkMain->m_LocalHostAddress,
					HIBYTE(m_wsaData.wVersion),
					HIBYTE(m_wsaData.wHighVersion),
					m_wsaData.iMaxSockets,
					m_wsaData.szDescription,
					m_wsaData.szSystemStatus,
					m_OsInfo.szCSDVersion);
				MessageBox(hWnd, szOutput, szTitle, MB_OK);
			}
			break;
			case ID_APP_ABOUT:
				{
					//
					// Display the About TestTalk dialog
					TCHAR strRes[MAX_LOADSTRING];
					LoadString(hInst, IDS_TESTT, strRes, MAX_LOADSTRING);

					TVVAboutDlg(strRes,"STARTNET",hWnd);
				}

				break;
			case ID_APP_EXIT:
				//
				// Exit the application
				DestroyWindow(hWnd);
				break;

			default:
				return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

			case WM_DESTROY:
				
				if(m_TestTalkMain)
				{
					
					m_TestTalkMain->Terminate();
					delete m_TestTalkMain;
					m_TestTalkMain = NULL;
				}
				WSACleanup();
				
				TVSTerminate();
				WLERRTerminate();
				ACE::fini();

				if ( m_pTray )	// remove icon from taskbar tray
				{
					delete m_pTray ;
					m_pTray = NULL ;
				}
				PostQuitMessage(0);
				break;
			default:
				return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


