/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// tmlnet.cpp
//               TML's Interface With The Net Server
//
//   who          when          what
//  Iris      05-11-93      Created
// Yahali     21-Nov-93     Write the body of the empty stubs.
// Yahali      28-Dec-93      Add multi-message functionality.
//

#include "tracedll.h"

#include "testtalkclientobj.h"
#include "testtalkclientcommunicator.h"
#include "testtalkclientobjimp.h"

void TestTalkClientTerminate()
{
  TestTalkClearClientsTable();
}

int idTestTalkClientObject = 1;
TestTalkClientObject::TestTalkClientObject() :
  myself(NULL)
{
}

TestTalkClientObject::~TestTalkClientObject()
{
  try {
    if (myself) {
      delete myself;
			myself = NULL;
		}
  } catch (...) {
  	WlTraceMsg("Fatal error in: TestTalkClientObject::~TestTalkClientObject");
  }
}

bool TestTalkClientObject::NETInit(const char* tmlInstance, unsigned short port)
{
  if (myself) {
    myself->NETTerminate();
    delete myself;
		myself = NULL;
  }
  myself = new CTestTalkClientObject(tmlInstance, this);
  valid = myself->NETInit(tmlInstance, port);
  return valid;
}

bool TestTalkClientObject::NETTurnOn()
{
  if (myself) 
    return myself->NETTurnOn();

  return false;
}

bool TestTalkClientObject::NETTurnOff()
{
  if (myself) 
    return myself->NETTurnOff();

  return false;
}

void TestTalkClientObject::NETTerminate()
{
	//WlTraceMsg("TestTalkClientObject::NETTerminate - Started");
  if (myself) {
    myself->NETTerminate();
  //  delete myself;
  //  myself = NULL;
  }
	//WlTraceMsg("TestTalkClientObject::NETTerminate - Done");
}

bool TestTalkClientObject::NETCopyFile(long msgId, const char *data, size_t dataSize, const char *addr)
{
  if (myself) 
    return myself->NETCopyFile(msgId, data, dataSize, addr);
  else
    return false;
}

bool TestTalkClientObject::NETSendMultiMessage(const char *data, size_t dataSize, const char* clientsList)
{
  if (myself) 
    return myself->NETSendMultiMessage(data, dataSize, clientsList) ;
  else
    return false;
}

bool TestTalkClientObject::NETSendMessage(const char *data, size_t dataSize, const char *addr)
{
  if (myself) 
    return myself->NETSendMessage(data, dataSize, addr) ;
  else
    return false;
}

bool TestTalkClientObject::NETSendMessageNoresponse(const char *data, size_t dataSize, const char *addr)
{
  if (myself) 
    return myself->NETSendMessageNoresponse(data, dataSize, addr) ;
  else
    return false;
}

bool TestTalkClientObject::NETSendMessageNowait(long msgId, const char *data, size_t dataSize, const char *addr)
{
  if (myself) 
    return myself->NETSendMessageNowait(msgId, data, dataSize, addr) ;
  else
    return false;
}

const char* TestTalkClientObject::NETFetchMessage()
{
  if (myself) 
    return myself->NETFetchMessage() ;
  else
    return NULL;
}

const char* TestTalkClientObject::NETWaitMessage()
{
  if (myself) 
    return myself->NETWaitMessage() ;
  else
    return NULL;
}

const char* TestTalkClientObject::NETWhoAmI()
{
  if (myself) 
    return myself->NETWhoAmI();
  else
    return "";
}

const char* TestTalkClientObject::NETLocalHostName()
{
  if (myself) 
    return myself->NETLocalHostName() ;
  else
    return "";
}

int TestTalkClientObject::NETGetLastStatus()
{
  if (myself) 
    return myself->NETGetLastStatus() ;
  else
    return -1;
}

const char* TestTalkClientObject::NETGetLastErrorMessage()
{
  if (myself) 
    return myself->NETGetLastErrorMessage() ;
  else
    return NULL;
}

bool TestTalkClientObject::NewMessageEvent(TypedMessageObject* tmo, short qtype)
{
  switch (qtype)
  {
    case DataQ:
    case ControlQ:
      return true;

    case AckQ:
      return false;
    
    default:
      return false;
  }
  
  return false;
}

