/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// severr.cpp -- Server Error mechanism
//
//  who         when          what
//  Yahali      26-May-1996   Create
//
//
#include "stdafx.h"

#include <collstr.h>
#include <RVCTokenizer.h>
#include <assert.h>
//#include <stdio.h>
#include <stdarg.h>
//#include <fstream.h>
//#include <typeinfo>

//#include "tracedll.h"
//#include "tvpsync.h"
#include "wlerrorlib1.h"
#include "ErrorLibLoader.h"
//#include "wlerrorlibimp.h"
//#include "tvenv.h"

///////////////  iWLException Implementation ////////////////////////

iWLException::iWLException()
//: m_SymEngine(0), m_StackTrace("")
{
//	m_SymEngine.StackTrace(m_StackTrace);
}

iWLException::~iWLException()
{
}

const char* iWLException::what() const{

	return GetErrorMsg();
}

bool iWLException::StackTrace(RVCString& outBuf, unsigned skip, const char* fmt){
	// @@Chaim - note that skip and fmt are ignored
//	outBuf = m_StackTrace;
	return true;
}

////////////////  WLErrorException Implementation ////////////////////////

WLErrorException::WLErrorException(const char* msg, WLSeverity sev, ...)
  : severity(sev)
{
  char errBuf[1024];
  va_list ap;
  va_start(ap, sev);
  vsprintf(errBuf, msg, ap);
  va_end(ap);
  errorMsg = errBuf;
}

WLErrorException::WLErrorException(const char* errFileName, int fmtId, ...)
{
  const char* errFmt = dllLoader.WLERRGetErrorFormat(errFileName, fmtId);
  char errBuf[1024];
  va_list ap;
  va_start(ap, fmtId);
  vsprintf(errBuf, errFmt, ap);
  va_end(ap);
  errorMsg = errBuf;
  severity = ( WLSeverity )dllLoader.WLERRGetErrorSeverity(errFileName, fmtId);
}

  // @@ofer: the format of copy ctor should be X(const X&) but since WebRM 4.6 uses the same dlls we cannot modify the interface
  // in 6.0 we should use X(const X&) for ALL platforms
#ifdef __TV_UNIX__
WLErrorException::WLErrorException(const WLErrorException& errorException) :
#else
WLErrorException::WLErrorException(WLErrorException& errorException) :
#endif // __TV_UNIX__
  errorMsg(errorException.GetErrorMsg()), 
  severity(errorException.GetErrorSeverity())
{
}


WLErrorException::~WLErrorException()
{
}

const char* WLErrorException::GetErrorMsg() const
{
  return errorMsg.data();
}

WLSeverity WLErrorException::GetErrorSeverity() const
{
  return severity;
}

