/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// FilesAssociationArchive.h: interface for the CFilesAssociationArchive class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FILESASSOCIATIONARCHIVE_H__56D6DAD6_7DB9_4572_BD56_BB2D344C976C__INCLUDED_)
#define AFX_FILESASSOCIATIONARCHIVE_H__56D6DAD6_7DB9_4572_BD56_BB2D344C976C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "associativearray.h"



class DllExport FilesAssociationArchive : public CAssociativeArray  
{
public:
	FilesAssociationArchive();
	virtual ~FilesAssociationArchive();

	RVHashDictionaryIterator& GetIterator();

	void AddFileAssociation(const char* srcFile, const char* dstFile);
	const char* GetFileAssociate(const char* srcFile);

	void SetDefualtDestinationDirectory(const char* dirPath);
	const char* GetDefualtDestinationDirectory();

	static void SetDefualtGlobalDestinationDirectory(const char* dirPath);

protected:
	RVCString BuildDefDestPath(const char* srcFile, bool fileOnly);

protected:
	RVCString                 mDefualtDestinationDirectory;
	RVHashDictionaryIterator* mIterator;

	static RVCString          mGlobalDefualtDestinationDirectory;
};


#endif // !defined(AFX_FILESASSOCIATIONARCHIVE_H__56D6DAD6_7DB9_4572_BD56_BB2D344C976C__INCLUDED_)
