/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// **********************************************************************
// Name : navnames
// Purpose : treat the tml-names module to create and manipulate
//          tml-names.
//
// Description : 
//
// Creation: Yahali, 22-Nov-93
// Updates :  Who          When         What
//                          
// **********************************************************************/
#ifndef __NVSNAMES_H
#define __NVSNAMES_H

#include <RVCString.h>
#include "platform.h"

#ifdef _TestTalkUtilDll
#define TestTalkUtilDllExport DllExport
#else
#define TestTalkUtilDllExport DllImport
#endif

// **** Interface Functions **** //

class TestTalkUtilDllExport CTestTalkAddress {
private:
  RVCString m_ClientName;
  RVCString m_HostName;
  RVCString m_Address;
public:
  CTestTalkAddress(const char* client, const char* host);
  CTestTalkAddress(const char* address);
  virtual ~CTestTalkAddress() {}

  const char* ClientName() {return m_ClientName.data();}
  const char* HostName() {return m_HostName.data();}
  const char* Address() {return m_Address.data();}
};

#endif // __NVSNAMES_H

