/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//processgroupmanager.h @@avidan42
#ifndef __PROCESS_GROUP_MANAGER_H
#define __PROCESS_GROUP_MANAGER_H

#include "platform.h"
#include <hashdict.h>
#include <ordered.h>
#include <collstr.h>


static const int PG_VER_LG_50 = 0;
static const int PG_VER_LG_GENERAL = 1;
static const int PG_VER_DDOS_LG    = 2;
static const int PG_VER_GUI_LG     = 3;
static const int PG_VER_WEBFT      = 4;
static const int PG_VER_WEBLOAD    = 5;
static const int PG_VER_RPROXY_LG  = 6;



typedef int ProcessID;//@@avidan42


struct DllExport ProcessInfo : public RVCollectable 
{
	ProcessInfo(PROCESS_HANDLE phandle) { pHandle = phandle; }
	PROCESS_HANDLE pHandle;
};


class DllExport ProcessGroup: public RVOrdered
{
public:
  long processGroupVersion;

public:
	explicit ProcessGroup();
	~ProcessGroup();

	ProcessID AddProcess(PROCESS_HANDLE);
	PROCESS_HANDLE RemoveProcess(ProcessID);//@@avidan42 not checked this function.
	bool KillProcess(ProcessID);//@@avidan42 not checked this function.
	bool TerminateGroup(void);
};

class DllExport ProcessesGroupManager: public RVHashDictionary 
{
public:
	explicit ProcessesGroupManager() {}
	~ProcessesGroupManager() {}

	//
        // Return NULL if failed, ProcessGroup* else
	ProcessGroup* AddProcessToGroup(/*[IN]*/RVCString& groupID, /*[IN]*/PROCESS_HANDLE& pHandler);
	ProcessGroup* AddProcessToGroup(/*[IN]*/RVCString& groupID, /*[IN]*/PROCESS_HANDLE& pHandler, /*[IN]*/int processGroupVersion);
	ProcessGroup* GetProcessGroup(/*[IN]*/RVCString& groupID);

	bool TerminateGroup(/*[IN]*/RVCString& groupID);
};



#endif
