/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _SocketLib_h
#define _SocketLib_h

#ifdef __TV_WINDOWS__
#include <ace/OS.h>
#include <winsock2.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stropts.h>
#include <poll.h>
#ifndef __TV_linux__
#include <sys/filio.h>
#else
#include <sys/ioctl.h>
#endif

#define SOCKET int
#define INVALID_SOCKET -1
#define SOCKET_ERROR   -1
#endif
#include "platform.h"

#define WINSOCK_NOERROR ((int)0)
#define WINSOCK_ERROR   ((int)SOCKET_ERROR)
#define SOCKET_CLOSED   ((int)-3)

#define N_MAX_HOST_NAME 1024

class DllExport CSocketLib {
public:
  static bool GetHostByName(const char *host, struct in_addr& sin_addr);
  static bool GetAddress(const char *host, u_short port, struct sockaddr_in& address);
  static int  GetLastError();
  static bool GetLocalHostName(char* szName, int nNameLength);
	static bool GetLocalHostName(char* szName, int nNameLength, bool resolveHostName);
};

#endif _SocketLib_h

