/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _SOCKMGR_HPP
#define _SOCKMGR_HPP

#include "platform.h"
#include "socketlib.h"

class DllExport SocketInfo : public WSAData{
public:
   SocketInfo();
};

class DllExport SocketManager {
protected:
   int          nLastError;
   short        bAvailable;
   short        nStartupCount;
   SocketInfo   mySocketInfo;
   short        nVersionMajor;
   short        nVersionMinor;

public:
   SocketManager(short nVersionMajor=1, short nVersionMinor=1, short bAutoStartup=1);
   virtual ~SocketManager();
   ISocketManager(short nNewVersionMajor=1, short nNewVersionMinor=1);

   Startup();
   ShutDown();

   int Available()                        {return bAvailable;}
   int GetMajorVersion()                  {return nVersionMajor;}
   int GetMinorVersion()                  {return nVersionMinor;}
   char* GetDescription()                 {return mySocketInfo.szDescription;}
   char* GetSystemStatus()                {return mySocketInfo.szSystemStatus;}
   unsigned short GetMaxUdpDgAvailable()  {return mySocketInfo.iMaxUdpDg;}
   unsigned short GetMaxSocketsAvailable(){return mySocketInfo.iMaxSockets;}
   char* GetVendorInfo()                  {return mySocketInfo.lpVendorInfo;}
   int GetLastError()                     {return nLastError;}
   void Information(SocketInfo& socketInfo){socketInfo = mySocketInfo;}
};

#endif //_SOCKMGR_HPP

