/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _SOCK_SUB
#define _SOCK_SUB

#include "platform.h"
#include "basesocket.h"
#include "msghdr.h"

#define N_DEF_MAX_QUEUED_CONNECTIONS 5

class DllExport StreamSocket : public Socket {
public:
  enum ConnectStatus{nNotConnected, nConnectPending, nConnected, nListening} nConnectStatus;

  StreamSocket();
  StreamSocket(SOCKET& newS);
  StreamSocket& operator=(StreamSocket& newStreamSocket);

  int Listen(int nMaxQueuedConnections=N_DEF_MAX_QUEUED_CONNECTIONS);
  int Connect(u_short port);
  int Connect(const char* hostname, u_short port);
  int Accept(StreamSocket& socket);
  int Accept(SOCKET& socket, sockaddr_in& sAddress);

  int SendMessage(void* msg, int len);
  int SendTypedMessage(short type, short subtype, void* msg, int len);
  int WaitTypedMessage(short& type,short& subtype, void*& msg, int& len);
  void FreeMessage(void* msg);

private:
  int WriteData(void* data, int len);
  int ReadData(void* data, int len);
  int GetMessageHeader(MessageHeader *mh);
#ifdef __TV_UNIX__
  int SelectForRead();
#endif

};

#endif //_SOCK_SUB

