/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// Class TestTalkServiceConfig
const int MAX_SERVICE_NAME = 256;

#ifndef _TESTTALKSERVICECONFIG_H_
#define _TESTTALKSERVICECONFIG_H_


#define TESTALK_SERVICE_NAME    "wlttservice"
#define TESTALK_SERVICE_DISPLAY "WebLoad TestTalk Service"

#include "platform.h"


class DllExport TestTalkServiceConfig
{
public:
	TestTalkServiceConfig(const char* szServiceName, const char* szDisplay);
	TestTalkServiceConfig(void)  {}

	~TestTalkServiceConfig(void) {}

	// ResolveTestTalkServiceName() Must be the first method to be called 
	// after creating an instance of this class with no parameters given to
	// the constructor.
	bool ResolveTestTalkServiceName(void);

	const char* GetServiceName() {return m_service;}
	const char* GetDisplayName() {return m_display;}

	void Install(/*[IN]*/DWORD dwType = SERVICE_WIN32_OWN_PROCESS,
							 /*[IN]*/DWORD dwStart = SERVICE_DEMAND_START,
							 /*[IN]*/const char* lpDepends = NULL, 
							 /*[IN]*/const char* lpName = NULL,
							 /*[IN]*/const char* lpPassword = NULL);

	void Remove(/*[IN]*/BOOL bForce = FALSE);
	BOOL IsInstalled();

	void ChangeStartType(/*[IN]*/BOOL bAutostart);
	void GetConfig();
	
	void Status();
	void Dependencies();

	void Start();
	void Control(/*[IN]*/DWORD dwControl);

	SC_LOCK LockDatabase(/*[IN]*/SC_HANDLE hSCM);
	DWORD ErrorPrinter(/*[IN]*/const char* pszFcn, 
										 /*[IN]*/DWORD dwErr = GetLastError());

private:
	char m_service[257];
	char m_display[257];
};

#endif //_TESTTALKSERVICECONFIG_H_
