/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
//**********************************************************************
// Name : nvspackmsg.cpp
// Purpose : implement NetView messages to tml.
//
// Creation: Yahali, 16-Nov-93
// Updates :  Who          When         What
//                          
//**********************************************************************/
//#include "stdafx.h"

#include <string.h>
#include <stdlib.h>
#ifndef __TV_UNIX__
#include "tracedll.h"
#endif
#include "tvdebug.h"
#include "nvspackmsg.h"
#include "msghdr.h"

#ifndef __TV_UNIX__
HCLIENTDATA WINAPI NVSPackTM(TypedMessageObject& tmo)
{
	EnterProcedure("NVSPackTM");
	return NVSPackData(tmo.MsgBuf, tmo.len, tmo.type, tmo.subtype);
}

TypedMessageObject* WINAPI NVSUnPackTM(HCLIENTDATA hData)
{
	EnterProcedure("NVSUnPackTM");
	debugPrint(3,("NVSUnPackTM(hData=%d\n",hData));
	char* p = NVSGetData(hData);
	if (!p)
		return (TypedMessageObject*)NULL;
	MessageHeader *mh = (MessageHeader *)p;
  p+=sizeof(MessageHeader);
  TypedMessageObject* tmo =
      new TypedMessageObject((void*)p,
                             SSMGetMessageHeaderLen(*mh),
                             SSMGetMessageHeaderType(*mh),
                             SSMGetMessageHeaderSubtype(*mh));

  //NVSFreeData(hData);

  return tmo;
}

HCLIENTDATA WINAPI NVSPackMsg(TestTalkMessage& tnm)
{
	EnterProcedure("");
	HCLIENTDATA hData = NVSPackData(tnm.getPackedBuf(),
																	tnm.getPackedBufLen(),
																	tnm.getType(),
																	tnm.getSubtype());
	return hData;
}

TestTalkMessage* WINAPI NVSUnPackMsg(HCLIENTDATA hData)
{
	EnterProcedure("");
	char* p = NVSGetData(hData);
	MessageHeader *mh = (MessageHeader *)p;
	void* data = (void*)(p+sizeof(MessageHeader));
	TestTalkMessage *tnm = new TestTalkMessage(data,
                          SSMGetMessageHeaderLen(*mh),
                          SSMGetMessageHeaderType(*mh),
                          SSMGetMessageHeaderSubtype(*mh));
  //NVSFreeData(hData);

  return tnm;
}

void WINAPI NVSDeleteTM(TypedMessageObject* tm)
{
  delete tm;
}

#endif
void WINAPI NVSDeleteMsg(TestTalkMessage* msg)
{
  try {
    if (msg)
      delete msg;
  } catch (...) {
    //  	WlTraceMsg("NVSDeleteMsg(%d) - Fatal error", msg);
  }
}

TestTalkMessage* WINAPI NVSTmo2Ttm(TypedMessageObject* tmo)
{
 	return new TestTalkMessage(*tmo);
}

