/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"

#include <hashtab.h>
#include "traceappwnd.h"
#include "tracedll.h"
#include "mainfrm.h"
#include "traceapp.h"

BEGIN_MESSAGE_MAP(TraceAppWindow, CWnd)
  ON_MESSAGE(WM_COPYDATA, OnCopyData)
END_MESSAGE_MAP()

TraceAppWindow::TraceAppWindow()
{
	static CString myClass = AfxRegisterWndClass(0);
	CRect rect(0,0,0,0);

	CWnd* parentWnd = ((CTraceApp *)AfxGetApp())->mainWnd;
	Create(myClass,"Trace Application private window", 0, rect, parentWnd, 0);
  // write the TraceApp hwnd
  // in the global process port
  // for receiving messages
	//TVNSSetGlobalProcessPort(TVNS_TRACEAPP, m_hWnd);
	CString str;
	str.Format("%d", (int)m_hWnd);
  if (!::WriteProfileString( "WebLoad-TraceApp", "m_hWnd", str )) {
    DWORD err = GetLastError();
  }

}

TraceAppWindow::~TraceAppWindow()
{
		//TVNSRemoveGlobalProcessPort(TVNS_TRACEAPP);
  ::WriteProfileString( "WebLoad-TraceApp", "m_hWnd", "0" );
}

LONG TraceAppWindow::OnCopyData(WPARAM wParam, LPARAM lParam)
{
  void* data;
  long len;
  short type,s_t;
  HCLIENTDATA h = (HCLIENTDATA)lParam;

  NVSUnPackData(h, data, len, type, s_t);

  switch (type) 
		{
		case  TRACE_OUTPUT_MSG:
		 {
     // lParam contains the handle of the Global Memory
     char *buf = new char[len+1];
		 strncpy(buf, (char *)data, len);
		 buf[len] = '\0';
		 ((CTraceApp *)AfxGetApp())->mainWnd->AddLine(buf);
		 delete buf;
		 }
    break;
		default:
			break;
	  }
	return 1;
}
