/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/*
 * Nvsmsg.h  -- NetView-Server messages Module Definitions.
 *
 *   who          when          what
 * Yahali     17-Nov-93     Creation.
 *
 */

#ifndef __TV_NVSMSG_H
#define __TV_NVSMSG_H

//#include "typedmsg.h"
//#include "netmsg.h"
#include "bool.h"
#include "platform.h"

// **** windows interface definitions **** //
#ifdef __TV_WINDOWS__
#include <windows.h>
#define CLIENTQUEUE HWND
#define HCLIENTDATA COPYDATASTRUCT*
#define MSGTYPE  UINT
#endif
#ifdef __TV_UNIX__
#define CLIENTQUEUE SOCKET
#define HCLIENTDATA void*
#define MSGTYPE  short
#endif

// ****  Interface Functions **** //

#if (defined_cplusplus) || (defined __cplusplus)
extern "C" {
#endif

DllExport Bool WINAPI NVSSendMsg(HCLIENTDATA hMsg,
				        CLIENTQUEUE queue,
							  MSGTYPE msgType);

//Bool NVSPostMsg(HCLIENTDATA hMsg,
//                CLIENTQUEUE queue,
//                MSGTYPE msgType);

DllExport HCLIENTDATA WINAPI NVSWaitMsg(CLIENTQUEUE hWnd,UINT wMsg);
DllExport HCLIENTDATA WINAPI NVSFetchMsg(CLIENTQUEUE hWnd,UINT wMsg);
DllExport int WINAPI NVSPeekMsg(HWND hWnd,UINT wMsg);

DllExport HCLIENTDATA WINAPI NVSAlloc(unsigned int);
DllExport char* WINAPI NVSGetData(HCLIENTDATA hData);
DllExport Bool WINAPI NVSReleaseData(HCLIENTDATA hData);
DllExport Bool WINAPI NVSFreeData(HCLIENTDATA hData);

DllExport HCLIENTDATA WINAPI NVSPackData(void* data, long len, short type, short subtype);
DllExport void WINAPI NVSUnPackData(HCLIENTDATA hData, void*& data, long& len, short& type, short& subtype);

#if (defined_cplusplus) || (defined __cplusplus)
}
#endif


#endif // __TV_NVSMSG_H

