/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/* Copyright (c) 1993-1995, Radview Software LTD. All Rights Reserved. */
/*****************************************************************
 *
 * File: tvver.h
 * Purpose: header file for the tvver functions
 *
 * Who      When        What
 * Tal     mar-96    Creation
 *
 ****************************************************************/
#ifndef __TVVER_H
#define __TVVER_H


// The type values should always be bitwize exclusive.
#define TYPE_TEST            1  // Binary 00001
#define TYPE_WEB			 2  // Binary 00010
#define TYPE_OBJECTPRO		 4  // Binary 00100
#define TYPE_POWERBUILDER    8  // Binary 01000
#define TYPE_MINIMAL_SUPPORT 16 // Binary 10000

#ifdef __TV_WINDOWS__
#include <windows.h>
#endif

// define function macros for displaying an about dialog box for each application
#define TVV_ABOUT_AATWIN(parent)    TVVAboutDlg("Agenda Authoring Tool","AATWIN",parent)
#define TVV_ABOUT_MONITOR(parent)   TVVAboutDlg("CentralConsole","CENTRALCONSOLE",parent)
#define TVV_ABOUT_STARTNET(parent)  TVVAboutDlg("TestTalk","STARTNET",parent)
#define TVV_ABOUT_WEBFT(parent)     TVVAboutDlg("WebFT","WEBFTCONSOLE",parent)
#define TVV_ABOUT_VAAT(parent)     TVVAboutDlg("Visual AAT","VAAT",parent)
#define TVV_ABOUT_WLIDE(parent)     TVVAboutDlg("WebLOAD IDE","WLIDE",parent)

#if defined(_cplusplus) || defined(__cplusplus)
extern "C" {
#endif

const char*  WINAPI  TVVersionInfo(const char* key);
const char*  WINAPI  TVVProductName(void);
const char*  WINAPI  TVVProductNameDisplay();
const char*  WINAPI  TVVProductsList(void);
const char*  WINAPI  TVVProductFileName(void);
const char*  WINAPI  TVVProductVersion();
const char*  WINAPI  TVVProductVersionName();
const char*  WINAPI  TVVProductMessage();
const char*  WINAPI  TVVProductErrorMessage(void);
const char*  WINAPI  TVVProductQuery(void);
const char*  WINAPI  TVVEditorTitle(void);
const char*  WINAPI  TVVProductIniFile(void);
const char*  WINAPI  TVVProductIniBackup(void);
const char*  WINAPI  TVVProductHelpFile(void);
const char*  WINAPI  TVVProductFrmFile(void);
HBITMAP      WINAPI  TVVProductCover(void);
int          WINAPI  TVVProductCoverX();
int          WINAPI  TVVProductCoverY();
int          WINAPI  TVVProductIconNumber();

#ifdef __TV_WINDOWS__
HICON        WINAPI  TVVProductIcon();
#endif

HBITMAP  WINAPI  TVVProductIconBmp();
int      WINAPI  TVVAboutDlg(const char* appName, const char* appBmp, HWND parent);
int      WINAPI  TVVProductType();

#if defined(_cplusplus) || defined(__cplusplus)
}
#endif

#endif // __TVVER_H



