/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// errdef.h -- error mechanism definitions
//
//   who          when          what
//  Iris        28-11-93      Created
//
//
#ifndef __WLERRORLIBIMP_H
#define __WLERRORLIBIMP_H

#include <hashdict.h>
#include <RVCString.h>
#include <collint.h>
#include "platform.h"
#include "wlerrorlib.h"

#define VOID2DICT(p) ((RVHashDictionary*)p)
#define VOID2CSTRING(p) ((RVCString*)p)

class WLFileDictionary : public RVHashDictionary {
private:
  RVCString name;

public:
  WLFileDictionary(const char* name);
  virtual ~WLFileDictionary();

  int LoadErrorFile(const char* errFileName);
  int LoadErrorString(const char* data);

  const char* GetErrorFormat(int fmtId);
  WLLogMessage::Severity GetErrorSeverity(int fmtId);

private:
  void InsertErrorLine(const char* errLine);

}; 

class WLErrorFileEntry: public RVCollectableInt {
public:
  RVCString errorFmt;
  WLLogMessage::Severity severity;
public:
  WLErrorFileEntry(const char* fmt, WLLogMessage::Severity sev) :
      errorFmt(fmt), severity(sev) {}
  WLErrorFileEntry(const char* fmt, const char *sev);
  virtual ~WLErrorFileEntry() {}
}; 

#endif // __WLERRORLIBIMP_H

