/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __TVPEventQueue_H
#define __TVPEventQueue_H

#include <slistcolque.h>
#include "platform.h"
#include "tvpsync.h"

//class DllExport RVSlistCollectablesQueue;

class DllExport TVPEventQueue 
{
private:
  bool              m_Active;
  bool              m_Released;
	RVMutexLock       *m_Touch;
  RVCondition       *m_Condition;
  RVSlistCollectablesQueue *m_Q;

public:
  typedef enum {
    Success,
    TimedOut,
    Released,
    Failed
  } WaitReturnType;

public:
	TVPEventQueue();
	virtual ~TVPEventQueue();

  void Init();
  void Terminate();

	void putEvent(RVCollectable* event);
	void release();
	RVCollectable* waitEvent();
	WaitReturnType waitEvent(RVCollectable*& event, long waitTime);

	RVCollectable* get();
	bool isEmpty() const;
};


#endif

