/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#ifndef __INIPARSE_H
#define __INIPARSE_H

#include <strng.h>
#include <windows.h>

#define LINELEN 80
#define MSGLEN 500


#define ENV_TABLE_SIZE 101


class Entry : public String {
  	String val;
	public:
		short saveDone;
		Entry(const char* e, const char* v) : String(e),val(v),saveDone(0){}
		const char* GetKey()   { return (const char*) *this; }
		const char* GetValue() { return (const char*) val; }
		void AssignValue(const char *v) {val = v;}
		virtual ~Entry(){}
};

typedef enum { Save, Load } ParseMode;

void ErrorHandling(const char *msg);
BOOL far pascal IsConfigWord(const char *word);
#endif /* __INIPARSE_H   */



