/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
/****************************************************************
 *
 * File: tvtables.h
 * Purpose: header file for the sevenv program.
 *
 * Who      When        What
 * ????     ????        Create
 * Yahali   5-Dec-94    porting to UNIX.
 *
 ****************************************************************/
#ifndef  __TVTABLES_H
#define  __TVTABLES_H

#include <windows.h>
#include "platform.h"
#define MAX_ENTRY_LEN 100
#define MAX_VALUE_LEN 512
#define FIRST_ENTRY 1
#define NEXT_ENTRY 2

typedef int  TableHandle;

typedef const char*  (*filterfunction)(const char*, const char*);

#if (defined _cplusplus) || (defined __cplusplus)
extern "C" {
#endif

BOOL WINAPI TVSLinesRead();
DllExport TableHandle WINAPI TVSCreateTable(void);
DllExport BOOL WINAPI TVSAssignValue(TableHandle h, const char* entry, const char* value);
DllExport const char* WINAPI TVSGetValue(TableHandle h, const char* entry);

DllExport int WINAPI TVSGetError(void);
DllExport BOOL WINAPI TVSIsError(void);

DllExport BOOL WINAPI TVSLoad(const char* FileName,TableHandle h, filterfunction filterfunc);
#ifndef __TV_linux__
#define TVSLoadTable(file, handle) TVSLoad(file, handle, FALSE)
#else
#define TVSLoadTable(file, handle) TVSLoad(file, handle, (filterfunction)NULL)
#endif

DllExport void WINAPI TVSSave(const char* FileName, TableHandle h, filterfunction filterfunc);
#ifndef __TV_linux__
#define TVSSaveTable(file, handle) TVSSave(file, handle, FALSE)
#else
#define TVSSaveTable(file, handle) TVSSave(file, handle, (filterfunction)NULL)
#endif

DllExport void WINAPI TVSAppend(const char* FileName, TableHandle h, filterfunction filterfunc);
#ifndef __TV_linux__
#define TVSAppendTable(file, handle) TVSAppend(file, handle, FALSE)
#else
#define TVSAppendTable(file, handle) TVSAppend(file, handle, (filterfunction)NULL)
#endif

DllExport void WINAPI TVSDestroyTable(TableHandle h);

DllExport BOOL WINAPI TVSIsTableEmpty(TableHandle h);
DllExport BOOL WINAPI TVSGetNextEntry(int type,TableHandle h,char **e,char **k,int *saveDone);
DllExport BOOL WINAPI TVSDeleteEntry(TableHandle h, const char* e);

DllExport void WINAPI TVSTerminate();

#if (defined _cplusplus) || (defined __cplusplus)
}
#endif

#endif // __TVTABLES_H

