/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
///////////////////////////////////////////////////////////////////////////////
//
// (c) 2000 GalTech Soft. All rights reserved.
//
// gt_portable.h
// Provides 32 bit declarations of general 
// Unicode Library definitions. Will be extended for non Win32
// platforms
///////////////////////////////////////////////////////////////////////////////

#ifndef _PORTABLE_H
#define _PORTABLE_H

#ifdef __TV_UNIX__ 
#include  <locale.h>
#include  <iconv.h>
typedef unsigned short gt_wchar_t;
#else
typedef wchar_t gt_wchar_t;
#endif // __TV_UNIX__





#if defined(__TV_WINDOWS__) && !defined(_WIN32)
#define _WIN32
#endif

#ifdef __TV_UNIX__
//#ifndef NULL
//#define NULL 0
//#endif //NULL
	#include <wchar.h>
	// this is for _POSIX_PATH_MAX
	#include <limits.h> 
	// for memcpy
	#include <string.h> 
#endif //__TV_UNIX__

//microsoft 32 bit
#ifdef _WIN32  //MSVC 32bit
	#define ULAPI __declspec(dllexport) 
	#define ULAPIPTR(f) __declspec(dllexport) (__cdecl *f)
	#define IMPORT __declspec(dllimport)
	#define EXPORT_CLASS __declspec(dllexport)
	#define IMPORT_CLASS __declspec(dllimport)
	#define THIS_INSTANCE (HINSTANCE)NULL
	#ifndef WM_APP //if windows.h not included
		#define WM_APP 0x0800
	#endif
#else //__TV_UNIX__
	#define ULAPI
	#define ULAPIPTR(f) (*f)
	#define IMPORT
	#define EXPORT_CLASS
	#define IMPORT_CLASS
	#define CP_ACP 0
#endif //MSVC 32bit

#ifdef __TV_UNIX__
//#ifdef UNIX
        typedef char* LPSTR;
        typedef bool* LPBOOL;
	typedef const char*  LPCSTR;
	typedef gt_wchar_t WCHAR;
        #define _strnicmp strncasecmp 

#ifdef __TV_UNIX__
typedef gt_wchar_t WORD;
#ifndef HMODULE
#define HMODULE void*
#endif //HMODULE
#endif //TV_UNIX

	typedef unsigned char  BYTE;
	typedef unsigned int   UINT;
	typedef unsigned long  DWORD;
	#ifndef BOOL
		typedef int BOOL;
	#endif //BOOL
	#define WINAPI
	#ifndef TRUE
		#define FALSE 0
		#define TRUE 1
	#endif //TRUE
	#define _wtoi w_atoi
	//#define _ltow w_ltoa
	#define _MAX_PATH _POSIX_PATH_MAX 
	#ifndef max
		#define max(a,b)            (((a) > (b)) ? (a) : (b))
	#endif

	#ifndef min
		#define min(a,b)            (((a) < (b)) ? (a) : (b))
	#endif
#endif //__TV_UNIX__

#define LPTSTR LPSTR
#define LPCTSTR LPCSTR

/* The next section is designed specifically to support Big-endian (_BENDIAN)
   and Little-endian platforms.. (little-endian by default.) as well as both
   UCS-2 and UCS-4 formats, in the event that either one or the other is un-
   implemented on a specific platform. */

//sizeof(short) == 2
#define LWORD unsigned short 
//sizeof(long) == 4
#define LDWORD unsigned long 
//sizeof(char) == 1
#define LBYTE unsigned char 
//sizeof(long) == 4
#define LLONG unsigned long 

/*
#ifdef _BENDIAN
	#define MAKELWORD(b, a)      ((LWORD)(((LBYTE)(a)) | ((LWORD)((LBYTE)(b))) << 8))
	#define MAKELDWORD(b, a)     ((LDWORD)(((LWORD)(a)) | ((LDWORD)((LWORD)(b))) << 16))
	#define HILWORD(l)           ((LWORD)(l))
	#define LOLWORD(l)           ((LWORD)(((LDWORD)(l) >> 16) & 0xFFFF))
	#define HILBYTE(w)           ((LBYTE)(w))
	#define LOLBYTE(w)           ((LBYTE)(((LWORD)(w) >> 8) & 0xFF))

#else //LENDIAN
*/
	#define MAKELWORD(a, b)      ((LWORD)(((LBYTE)(a)) | ((LWORD)((LBYTE)(b))) << 8))
	#define MAKELDWORD(a, b)     ((LDWORD)(((LWORD)(a)) | ((LDWORD)((LWORD)(b))) << 16))
	#define LOLWORD(l)           ((LWORD)(l))
	#define HILWORD(l)           ((LWORD)(((LDWORD)(l) >> 16) & 0xFFFF))
	#define LOLBYTE(w)           ((LBYTE)(w))
	#define HILBYTE(w)           ((LBYTE)(((LWORD)(w) >> 8) & 0xFF))

//#endif //_BENDIAN

#ifdef _UCS_4
	#define UL_LOBYTE(w) LOLBYTE(LOLWORD(w))
	#define UL_HIBYTE(w) HILBYTE(LOLWORD(w))
	#define UL_MAKEWORD(a,b) MAKELDWORD((MAKELWORD(a,b)),((LWORD)0x0000))
#else //UCS_2
	#define UL_LOBYTE(w) LOLBYTE(w)
	#define UL_HIBYTE(w) HILBYTE(w)
	#define UL_MAKEWORD(a,b) MAKELWORD(a,b)
#endif //UCS_4

/* end of endian / UCS-2 UCS-4 support additions. */

#define CONST const
#define CHAR char
//WCHAR support
//typedef wchar_t wctype_t;
typedef gt_wchar_t  *LPWSTR;
typedef const gt_wchar_t  *LPCWSTR;
//////////////////////////////////////////////////////////////////////



#define XMAKEWORD(x, y) ((unsigned)(((x) & 0xFF) | ((((unsigned)(y))) << 8)))

//////////////////////////////////////////////////////////////////////////////////

#define XBYTE(x)    ((x) & 0xff)        /* truncates data */
#define XHIBYTE(x)  (((x) >>  8) & 0xff)    /* high byte of short */
#define XLOBYTE(x)  ((x) & 0xff)        /* low  byte of short */
#define XHIWORD(x)  ((WORD)(((x) >> 16) & 0xffffL)) /* upper half of long */
#define XLOWORD(x)  ((WORD)((x) & 0xffffL))     /* lower half of long */
#define XCHAR(x)    ((x) & 0x7f)        /* truncate to  7 bits */
#define XWORD(x)    ((x) & 0xffffL)     /* truncate to 16 bits */
#define XMAKEWORD(x, y) ((unsigned)(((x) & 0xFF) | ((((unsigned)(y))) << 8)))
#define DECODE(x)   ((int) ((x) - '0')) /* int value of a digit */

#ifndef MAXPATHLEN
#define MAXPATHLEN  _MAX_PATH
#endif
#define PATH_CHAR   '\\'    /* directory  separator */
#define PATH_STR    "\\"
#define MAX_RES_NAME    50
#define MAX_8_BITS  256 /* how much will fit into an 8-bit byte */
#define MAX_CODES 3
#define MAX_NO_OF_CODES  17046
#define MAX_NO_OF_RANGES 270
#define MAX_NO_OF_OUTCODES  17046
#define MAX_NO_OF_OUTRANGES 4124

/*
 * Character constants.
 */
/*
#define EOS     ((BYTE) '\0')
#define NUL     ((BYTE) '\0')
#define BEL     ((BYTE) '\007')
#define BS      ((BYTE) '\010')
#define TAB     ((BYTE) '\t')
#define NL      ((BYTE) '\n')
#define FF      ((BYTE) '\f')
#ifndef CR
#define CR      ((BYTE) '\r')
#endif
#define ESC     ((BYTE) '\033')
#define CTRLC       ((BYTE) '\003')
#define CTRLZ       ((BYTE) '\032')
#define SPACE       ((BYTE) ' ')
#define HYPHEN      ((BYTE) '-')
#define QUESTION    ((BYTE) '?')
#define UNDERSCORE  ((BYTE) '_')
#define VERTICALBAR ((BYTE) '|')
#define TILDE       ((BYTE) '~')
#define BACKSLASH   ((BYTE) '\\')
#define DEL     ((BYTE) 0x7F)
#define SHY     ((BYTE) 0xAD)
#define AHY     ((BYTE) 0x11)
#define NBSP    ((BYTE) 0xA0)
#define PERIOD  ((BYTE) '.')
#ifndef LF
#define LF      ((BYTE) 0x0A)
#endif
*/
#endif //_PORTABLE_H
