/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef _STRWRAPPER_H
#define _STRWRAPPER_H

#include "windows.h"
#include "gt_unicode.h"

class StrWrapper {
public:
	StrWrapper(char* str) {m_ptr = str;}

	StrWrapper(StrWrapper& str)
	{
		m_ptr = str.m_ptr;
		str.m_ptr = NULL;
	}

	~StrWrapper()
	{
		if (m_ptr)
			delete [] m_ptr;
	}

	operator char*() const {return m_ptr;}

private:
	StrWrapper() {};

private:
	char *m_ptr;
};  

StrWrapper ConvertWideNumbers(const char *str);
StrWrapper EscapeSlashes(const char *sIn);
StrWrapper ToUTF8(const char *strANSI, int nCharset = CP_ACP);
StrWrapper ToANSI(const char *strUTF, int nCharset = CP_ACP);

#endif //_STRWRAPPER_H
