/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// UniServePrep1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


/* Includes */
//#include <machdefs.h>
//#include <portable.h>
#include "xlat1.h"
#include "xlatbld.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#define max(a, b)   (((a) > (b)) ? (a) : (b))
#define MIN(a, b)   (((a) < (b)) ? (a) : (b))
#define BOOL int
#define TRUE 1

// Constants
#define END_COPYRIGHT           "2005"
#define START_COPYRIGHT         "1999"
#define LEGAL_COPYRIGHT_STRING  "Copyright \251 Galtech Software Ltd. " START_COPYRIGHT "-" END_COPYRIGHT ".\0"
#define MAX_CODE_PAGES      90  /* maximum number of code pages */
#define MAX_CODE_PAGE_DESC  50//40  /* length of longest CP description */
#define MAX_CODE_PAGE_NAME  50//30  /* code name (for C) length */
#define MAX_FILENAME    50//32  /* filename length */
#define MAX_LINE_BUF    120 /* length of longest supported contents line */
#define MIN_LINE_BUF    10  /* length of longest supported contents line */
#define COMMENT_CHAR    '#' /* contents file comment character */
#define EXTRA_CHAR      '+' /* contents file "Extra" character -- starts Extra definition*/
#define EXT_DAT     ".da"  /* .dat or .da~ : raw data (input) extension */
#define EXT_H       ".h"    /* include file (output) extension */
#define EXT_RC      ".rc"   /* resource file (output) extension */
#define SUBDIR_DAT  "dat\\" /* raw data (input) subdirectory */
#define SUBDIR_H    "h\\"   /* include file (output) subdirectory */
#define SUBDIR_RC   "rc\\"  /* resource file (output) subdirectory */
#define MASTER_INCLUDE  "xlat2.h" /* master include file (output) */
#define MASTER_RC   "xlatlib.rc"/* master RC file (output) */

typedef struct _CODEPAGEREC {
    char    szFileName[MAX_FILENAME];           /* supporting file name */
    char    szCodeDesc[MAX_CODE_PAGE_DESC];     /* descriptive text */
    char    szCodeName[MAX_CODE_PAGE_NAME];     /* "C" name of code page */
    char    szClosestWCp[MAX_CODE_PAGE_NAME];   /* Closest Window's code page */
    int     nBytes;                             /* number bytes -> UniCode */
} CODEPAGEREC, *PCODEPAGEREC;

typedef struct _EXTRA {
    char    szCodeDesc[MAX_CODE_PAGE_DESC];     /* descriptive text */
    char    szCodeName[MAX_CODE_PAGE_NAME];     /* "C" name of code page */
} EXTRA;

#if 0
/* Structures and Typedefs */
typedef struct _CODEPAGEREC {
    char    szFileName[MAX_FILENAME];   /* supporting file name */
    char    szCodeDesc[MAX_CODE_PAGE_DESC];   /* descriptive text */
    char    szCodeName[MAX_CODE_PAGE_NAME];   /* "C" name of code page */
    int     nBytes;                     /* number bytes -> UniCode */
} CODEPAGEREC, *PCODEPAGEREC;
#endif
/* Global variables */
int     nCodePageRecs = 0;      /* number of code pages */
CODEPAGEREC CodePageRecs[MAX_CODE_PAGES];   /* actual code page records */
unsigned int     uToUni[MAX_8_BITS][MAX_CODES];  /* code page to UniCode table */
/*untiny*/unsigned int      byFromUni[MAX_16_BITS];     /* UniCode to code page table */
// variables for multi-table transformations (like Shift-JIS)
int     nCodes          = 0;      // number of codes
int     nRanges         = 0;      // number of code ranges
int     iMaxNoOfCodes   = 0;      // max number of codes
int     iMaxNoOfRanges  = 0;      // max number of code ranges

int     nRCodes          = 0;      // number of reverse codes
int     nRRanges         = 0;      // number of reverse code ranges
int     iRMaxNoOfCodes   = 0;      // max number of reverse codes
int     iRMaxNoOfRanges  = 0;      // max number of reverse code ranges

#define MAP(x)  (x)

// variables for "extras", i.e., code pages for which we are only given the
// text of the name for the string table, but no data file
#define MAX_NO_OF_EXTRAS    15
int nExtras = 0;
EXTRA Extras[MAX_NO_OF_EXTRAS];

//CODEREC CodeRecs[MAX_NO_OF_CODES];   /* actual code page records */
//RANGE   Ranges[MAX_NO_OF_RANGES];

/* Global functions */
extern  int main(int argc,char **argv );
extern  void ParseContentsLine (char *szLine);
extern  void ParseExtrasLine (char *szLine);
extern  void ProcessOneDataFile (PCODEPAGEREC pCodePageRec);
extern  void ProcessOneMultiTableDataFile (PCODEPAGEREC pCodePageRec);
extern  void InvertMultiTableDataFile (PCODEPAGEREC pCodePageRec);
extern  void ReadInOneDataFile (FILE *fIn);
void ReadInOneMultiTableDataFile(FILE *fIn, FILE *fRanges,
                                 FILE *fCodes, bool bToUni);
/*
extern  void WriteOutOneIncludeFile (FILE *fOut, PCODEPAGEREC pCodePageRec,
    char *szFileName);
extern  void WriteOutOneMulitTableIncludeFile (FILE *fOut, PCODEPAGEREC pCodePageRec,
    char *szFileName);
*/
extern  void WriteOutOneRCFile (FILE *fOut, PCODEPAGEREC pCodePageRec,
    char *szFileName);
extern void WriteOutOneMultiTableRCFile (FILE *fOut, PCODEPAGEREC pCodePageRec,
    char *szFileName, bool bToUni);
extern  void WriteOutMasterIncludeFile (void);
extern  void WriteOutMasterRCFile (void);
extern  void Usage(void);
extern  void Fatal(char *s);
extern  void FatalD (char *s, WORD i);

/* -------------------------     */
//#define TESTING
#ifndef TESTING
#define TEST
#else
void test(void)
{
#include <conio.h>
    int i;
    for (i = 0; i < nExtras; i++) {
        printf("Extra: %-30s\t\"%s\"\n",Extras[i].szCodeName,Extras[i].szCodeDesc);
    }
    getch();
}
#define TEST test();
#endif


int main(int argc, char* argv[])
{
    FILE *fInContents;
    char szContentsLine[MAX_LINE_BUF];
    int i;
	char fileName[100];

    if (argc != 3)
        Usage ();

    if ((fInContents = fopen (argv[1], "rt")) == NULL) {
        perror (argv[1]);
        Fatal ("cannot open contents file");
    }

	strcpy(fileName, argv[1]);
	for (i = 0; fileName[i]; i++)
	{
		if (fileName[i] == '.')
		{
			fileName[i] = '\0';
			break;
		}
	}

    fprintf (stderr, "Reading %s\n", argv[1]);

    while (fgets (szContentsLine, MAX_LINE_BUF - 1, fInContents) != NULL) {
        if (szContentsLine[0] != COMMENT_CHAR ||
              strlen (szContentsLine) < MIN_LINE_BUF)
            break;
#if 0
        if  (szContentsLine[0] == EXTRA_CHAR)
            ParseExtrasLine(szContentsLine);
        else
            ParseContentsLine(szContentsLine);
#endif
    }

		ReadInOneDataFile(fInContents);

		strcat(fileName, ".tab");
		FILE *fOutRC = fopen(fileName, "wt");

		CODEPAGEREC CodePageRec;
		strcpy(CodePageRec.szFileName, fileName);
		strcpy(CodePageRec.szCodeDesc, fileName);
		strcpy(CodePageRec.szCodeName, argv[2]);
		strcpy(CodePageRec.szClosestWCp, fileName);
		CodePageRec.nBytes = 1; 

		WriteOutOneRCFile (fOutRC, &CodePageRec, CodePageRec.szFileName);


#if 0
    //fprintf (stderr, "Writing .H and .RC files\n");
    fprintf (stderr, "Writing .RC files\n");
    TEST
    for (i = 0; i < nCodePageRecs; i++) {
        fprintf (stderr, "  %s\n", CodePageRecs[i].szFileName);
        if  (CodePageRecs[i].nBytes == -1) {
            ProcessOneMultiTableDataFile (&CodePageRecs[i]);
            InvertMultiTableDataFile (&CodePageRecs[i]);
            ProcessOneMultiTableDataFile (&CodePageRecs[i]);
        }
        else
            ProcessOneDataFile (&CodePageRecs[i]);
    }

    WriteOutMasterIncludeFile ();
    WriteOutMasterRCFile ();
#endif
    return 0;
}


/*
 * ParseContentsLine -- read one line and add a global CODE_PAGE_REC record.
 */
void ParseContentsLine (char *szLine)
{
#define MAX_NUMBYTES     8  /* number of bytes */
    char szFileName[MAX_FILENAME];
    char szCodeDesc[MAX_CODE_PAGE_DESC];
    char szCodeName[MAX_CODE_PAGE_NAME];
    char szCloseWCp[MAX_CODE_PAGE_NAME];
    char szNumBytes[MAX_NUMBYTES];
	char *cp1, *cp2;

    /* field 1: file name */
    for (cp1 = szLine; isspace(*cp1); cp1++)
        ;
    for (cp2 = cp1; *cp2 != ',' && !isspace(*cp2); cp2++)
        ;
	strncpy (szFileName, cp1, MIN ((cp2 - cp1), MAX_FILENAME - 1));
    szFileName[MIN ((cp2 - cp1), MAX_FILENAME - 1)] = NULL;

    /* field 2: description */
    for (cp1 = cp2; *cp1 == ',' || isspace(*cp1); cp1++)
        ;
    if (*cp1 != '\"')
        Fatal ("Missing quote 1");
    cp1++;
    for (cp2 = cp1; *cp2 != '\"'; cp2++)
        ;
    strncpy (szCodeDesc, cp1, MIN ((cp2 - cp1), MAX_CODE_PAGE_DESC - 1));
    szCodeDesc[MIN ((cp2 - cp1), MAX_CODE_PAGE_DESC - 1)] = NULL;
    cp2++;
    if (*cp2 != ',') {
        char message[100];
        strcpy(message,"Missing comma 1: ");
        strcat(message,szLine);
        Fatal (message);
    }
    cp2++;

    /* field 3: number of bytes */
    for (cp1 = cp2; isspace(*cp1); cp1++)
        ;
    for (cp2 = cp1; *cp2 != ',' && !isspace(*cp2); cp2++)
        ;
    strncpy (szNumBytes, cp1, MIN ((cp2 - cp1), MAX_NUMBYTES - 1));
    szNumBytes[MIN ((cp2 - cp1), MAX_NUMBYTES)] = NULL;

    /* field 4: C code name */
    for (cp1 = cp2; *cp1 == ',' || isspace(*cp1); cp1++)
        ;
    for (cp2 = cp1; *cp2 && *cp2 != ',' && !isspace(*cp2); cp2++)
        ;
    strncpy (szCodeName, cp1, MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME - 1));
    if (szCodeName[0] != 'K' ||
         szCodeName[1] != 'C' ||
         szCodeName[2] != 'P' ||
         szCodeName[3] != '_') {
        char message[100];
        strcpy(message,"Code name must start with KCP_");
        strcat(message,szCodeName);
        Fatal (message);
        //Fatal ("Code name must start with KCP_");
    }

    szCodeName[MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME)] = NULL;

    /* field 5: Closest windows code page name */
    for (cp1 = cp2; *cp1 == ',' || isspace(*cp1); cp1++)
        ;
    for (cp2 = cp1; *cp2 && *cp2 != ',' && !isspace(*cp2); cp2++)
        ;
    strncpy (szCloseWCp, cp1, MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME - 1));
    if (szCloseWCp[0] != 'K' ||
         szCloseWCp[1] != 'C' ||
         szCloseWCp[2] != 'P' ||
         szCloseWCp[3] != '_')
        Fatal ("Closest windows code page name must start with KCP_");

    szCloseWCp[MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME)] = NULL;

    if (nCodePageRecs >= MAX_CODE_PAGES - 1)
        FatalD ("nCodePageRecs overflow", nCodePageRecs);
    strcpy (CodePageRecs[nCodePageRecs].szFileName, szFileName);
    strcpy (CodePageRecs[nCodePageRecs].szCodeDesc, szCodeDesc);
    strcpy (CodePageRecs[nCodePageRecs].szCodeName, szCodeName);
    strcpy (CodePageRecs[nCodePageRecs].szClosestWCp, szCloseWCp);

    CodePageRecs[nCodePageRecs].nBytes = atoi (szNumBytes);
    if ((CodePageRecs[nCodePageRecs].nBytes < 1) &&
        (CodePageRecs[nCodePageRecs].nBytes != -1))
        FatalD ("Impossible number of bytes",CodePageRecs[nCodePageRecs].nBytes);
    nCodePageRecs++;
}

/*
 * ParseExtrasLine -- read one line and add a global EXTRA record.
 */
void ParseExtrasLine (char *szLine)
{
#define MAX_NUMBYTES     8  /* number of bytes */
    char szCodeDesc[MAX_CODE_PAGE_DESC];
    char szCodeName[MAX_CODE_PAGE_NAME];
	char *cp1, *cp2;

    /* field 1: KCP code name */
    for (cp1 = szLine; *cp1 == '+' || isspace(*cp1); cp1++)
        ;
    for (cp2 = cp1; *cp2 != ',' && !isspace(*cp2); cp2++)
        ;
    strncpy (szCodeName, cp1, MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME - 1));
    if (szCodeName[0] != 'K' ||
         szCodeName[1] != 'C' ||
         szCodeName[2] != 'P' ||
         szCodeName[3] != '_') {
        char message[100];
        strcpy(message,"Code name must start with KCP_");
        strcat(message,szCodeName);
        Fatal (message);
        //Fatal ("Code name must start with KCP_");
    }

    szCodeName[MIN ((cp2 - cp1), MAX_CODE_PAGE_NAME)] = NULL;

    /* field 2: description */
    for (cp1 = cp2; *cp1 == ',' || isspace(*cp1); cp1++)
        ;
    if (*cp1 != '\"')
        Fatal ("Missing quote 1");
    cp1++;
    for (cp2 = cp1; *cp2 != '\"'; cp2++)
        if  ((cp2 - cp1) > MAX_CODE_PAGE_DESC)
            Fatal ("Extra's code page string too large");
    strncpy (szCodeDesc, cp1, MIN ((cp2 - cp1), MAX_CODE_PAGE_DESC - 1));
    szCodeDesc[MIN ((cp2 - cp1), MAX_CODE_PAGE_DESC - 1)] = NULL;
    if (nExtras >= MAX_NO_OF_EXTRAS - 1)
        FatalD ("nExtras overflow", nExtras);
    strcpy (Extras[nExtras].szCodeName, szCodeName);
    strcpy (Extras[nExtras].szCodeDesc, szCodeDesc);
    //printf("found extra: %s\t\"%s\"\n",Extras[nExtras].szCodeName,Extras[nExtras].szCodeDesc);
    nExtras++;
}

/* -------------------------     */


/*
 * ProcessOneDataFile -- read one file and write its .H and .RC files.
 */
void ProcessOneDataFile (PCODEPAGEREC pCodePageRec)
{
    FILE *fInDat = NULL;
    FILE *fOutRC = NULL;
    char szFileNameDat [MAX_FILENAME];
    char szFileNameRC   [MAX_FILENAME];
    char *cp;
    static const BOOL reading = TRUE;
    static const BOOL writing = TRUE;
    /* name and open the .DAT input data file */
    if  (strlen(pCodePageRec->szFileName) > 12)
        Fatal("Filename too long in ProcessOneDataFile");
    sprintf (szFileNameDat, "%s%s", SUBDIR_DAT, pCodePageRec->szFileName);
    //strcpy(szFileNameDat,SUBDIR_DAT);
    //strcat(
    if ((fInDat = fopen (szFileNameDat, "rt")) == NULL) {
        perror (szFileNameDat);
        Fatal ("data file read open failure");
    }
    /* name and open the .RC output resource file */
    sprintf (szFileNameRC, "%s%s", SUBDIR_RC, pCodePageRec->szFileName);
    if ((cp = strstr(szFileNameRC, EXT_DAT)) == NULL)
        Fatal ("missing extension error");
    *cp = NULL;
    strcat (szFileNameRC, EXT_RC);
    if ((fOutRC = fopen (szFileNameRC, "wt")) == NULL) {
        perror (szFileNameRC);
        Fatal ("resource file write open failure");
    }

    /* read and build input to-UniCode tables */
    if  (reading)
    ReadInOneDataFile (fInDat);
    /* write out include .RC file */
    if  (writing)
    WriteOutOneRCFile (fOutRC, pCodePageRec, szFileNameRC);

    /* close open files */
    if (fInDat != NULL)
        fclose (fInDat);
    if (fOutRC != NULL)
        fclose (fOutRC);

    TEST
}

/* -------------------------     */

/*
 * WriteOutOneMultiTableRCFile -- write out one data file's corresponding .RC file.
 */
void WriteOutOneMultiTableRCFile
        (FILE *fOut, PCODEPAGEREC pCodePageRec, char *szFileName, bool bToUni)
{
    char *cp;
    char szFile[MAX_FILENAME];
    /*DWORD*/ unsigned int dw;
    /* skip the directory separator '\' in the filename */
    if ((cp = strchr (szFileName, '\\')) == NULL)
        cp = szFileName;
    else
        cp = cp + 1;

    strcpy(szFile,cp);

    /* write out the file name and copyright message */
    fprintf (fOut, "%c%c\n", '/', '*');
    fprintf (fOut, " * %s -- %s %s.\n", cp, pCodePageRec->szCodeDesc,
        "rc file");
    fprintf (fOut, " * %s\n", LEGAL_COPYRIGHT_STRING);
    fprintf (fOut, " *\n *\n *\tNumber of Ranges (tables):\t\t%i\n"
                 " *\tNumber of Table entries (codes):\t%i\n"
                 " */\n\n",nRanges,nCodes);
    cp = strchr(szFile, '.');
    *++cp = '\0';

    /* first the code page to UniCode table */
    fprintf (fOut,
             bToUni
                ? "static gt_wchar_t %s_To_Uni_Data[] =\n{\n"
                : "static BYTE Uni_To_%s_Data[] =\n{\n",
             pCodePageRec->szCodeName);
    fprintf(fOut,"\t/* No. Of Bytes */\t%ul,\n",nRanges*sizeof(RANGE));
    fprintf(fOut,"#include \"%s.rn%c\"\n",szFile,bToUni?'g':'~');
    fprintf (fOut, "END\n\n");

    /* next the code page to UniCode multi-table */
    fprintf (fOut,
             bToUni
                ? "%s_To_Uni_Data RCDATA LOADONCALL DISCARDABLE\nBEGIN\n"
                : "Uni_To_%s_Data RCDATA  LOADONCALL DISCARDABLE\nBEGIN\n",
             pCodePageRec->szCodeName);
    dw = ((unsigned int)nCodes)*(unsigned int)sizeof(CODEREC);
    fprintf(fOut,"\t/* No. Of Bytes */\t%lul,\n",dw);
    fprintf(fOut,"#include \"%s.co%c\"\n",szFile,bToUni?'d':'~');
    fprintf (fOut, "}\n\n");
}



void RecordRange(FILE *fRanges, WORD Start, WORD End, WORD *pOffset)
{
    fprintf (fRanges, "\t0x%04X,\t0x%04X,\t0x%04X",
             Start, End, *pOffset);
    *pOffset = *pOffset + End - Start + 1; // set offset for next range
}

/*
 * ProcessOneMultiTableDataFile --
 *      read one file and write its .RC, .RNG, and .COD files.
 */
void ProcessOneMultiTableDataFile (PCODEPAGEREC pCodePageRec)
{
    FILE *fInDat    = NULL;
    FILE *fOutRange = NULL;
    FILE *fOutCode  = NULL;
    FILE *fOutRC    = NULL;
    char szFileName     [MAX_FILENAME];
    char szFileNameDat  [MAX_FILENAME];
    char szFileNameRC   [MAX_FILENAME];
    char *cp;
    bool bToUni   =
        (pCodePageRec->szFileName[strlen(pCodePageRec->szFileName)-1] != '~');
    /* name and open the .DAT input data file */
    sprintf (szFileNameDat, "%s%s", SUBDIR_DAT, pCodePageRec->szFileName);
    if  ((fInDat = fopen (szFileNameDat, "rt")) == NULL) {
        perror (szFileNameDat);
        Fatal ("data file read open failure");
    }

    /* name and open and write the .RC output resource file */
    sprintf (szFileNameRC, "%s%s", SUBDIR_RC, pCodePageRec->szFileName);
    if  ((cp = strstr(szFileNameRC, EXT_DAT)) == NULL)
        Fatal ("missing extension error");
    *cp = NULL;
    strcpy(szFileName, szFileNameRC);
    strcat (szFileNameRC, bToUni ? ".rc" : ".r~"); //EXT_RC);
    if  ((fOutRC = fopen (szFileNameRC, "wt")) == NULL) {
        perror (szFileNameRC);
        Fatal ("resource file write open failure");
    }

    /* name and open the RC include files */
    if  ((cp = strstr(szFileNameRC, ".r"/*EXT_RC*/)) == NULL)
        Fatal ("missing data file extension");
    *cp = NULL;
    strcat (szFileNameRC, bToUni ? ".rng" : ".rn~");
    if  ((fOutRange = fopen (szFileNameRC, "wt")) == NULL) {
        perror (szFileName);
        Fatal ("range file write open failure");
    }
    *cp = NULL;
    strcat (szFileNameRC, bToUni ? ".cod" : ".co~");
    if  ((fOutCode = fopen (szFileNameRC, "wt")) == NULL) {
        perror (szFileName);
        Fatal ("code file write open failure");
    }
    ReadInOneMultiTableDataFile(fInDat, fOutRange, fOutCode, bToUni);
    WriteOutOneMultiTableRCFile(fOutRC, pCodePageRec, szFileName, bToUni);
    /* close open files */
    if (fInDat != NULL)
        fclose (fInDat);
    if (fOutRange != NULL)
        fclose (fOutRange);
    if (fOutCode != NULL)
        fclose (fOutCode);
    if (fOutRC != NULL)
        fclose (fOutRC);
}

/*
 * ReadInOneMultiTableDataFile -- read and verify one data file's contents, building
 * a global code page to UniCode table.
 *
 *  For code-page-x to Unicode:
 *      bToUni == TRUE, incode == code from x, outcode == unicode
 *
 *  For Unicode to code-page-x:
 *      bToUni == FALSE, incode == unicode, outcode == code from x
 */
void ReadInOneMultiTableDataFile(FILE *fIn, FILE *fRanges,
                                 FILE *fCodes, bool bToUni)
{
    char szBuf[MAX_LINE_BUF];
    WORD last_code  = 0;
    WORD start      = 0;
    WORD offset     = 0;
    WORD incode;
    WORD outcode;
    int  iLine;
    /* initialize global tables */
    iLine = nRanges = nCodes = 0;
    while (fgets (szBuf, MAX_LINE_BUF - 1, fIn) != NULL) {
        iLine++;
        if (szBuf[0] == COMMENT_CHAR || strlen (szBuf) < MIN_LINE_BUF)
            continue;
        if  (2 != sscanf(szBuf,"%x  %x",&incode,&outcode)) {
            if  (!bToUni)
                fprintf(stderr,"Reversed file, ");
            fprintf(stderr,"Line %d: Unable to find 2 hex numbers\n",iLine);
            continue;
        }
        // check for repetitions: warn and skip
        if  (incode == last_code) {
            if  (!bToUni)
                fprintf(stderr,"Reversed file, ");
            fprintf(stderr,
                    "Repetition in line %d: code = 0x%X\tunicode = 0x%X\nszBuf: %s\n",
                    iLine,incode,outcode,szBuf);
            continue;
        }
        // record range and offset info if we ended a range
        if  (incode != last_code+1) {
            if  (nRanges > 0) {
                if  (nRanges > 1)
                    fprintf (fRanges,",\n");
                RecordRange(fRanges,start,last_code,&offset);
            }
            start = incode;
            nRanges++;
        }
        last_code = incode;

        // record code & unicode info
        if  (nCodes > 0)
            fprintf (fCodes,",\n");
        fprintf (fCodes, "\t/*0x%04X,*/\t0x%04X",incode,outcode);
        nCodes++;
    }
    if  (nRanges > 1)
        fprintf (fRanges,",\n");
    RecordRange(fRanges,start,last_code,&offset);
    fputc ('\n', fRanges);
    fputc ('\n', fCodes);
    if  (bToUni) {
        iMaxNoOfRanges = max(iMaxNoOfRanges,nRanges);
        iMaxNoOfCodes = max(iMaxNoOfCodes,nCodes);
    }
    else {
        iRMaxNoOfRanges = max(iRMaxNoOfRanges,nRanges);
        iRMaxNoOfCodes = max(iRMaxNoOfCodes,nCodes);
    }
}



/*
 * ReadInOneDataFile -- read and verify one data file's contents, building
 * a global code page to UniCode table.
 */
void ReadInOneDataFile (FILE *fIn)
{
    int nLines;
    char szInLine[MAX_LINE_BUF];
    WORD u, iCode[MAX_CODES];
    int i, iIndex;

    /* initialize global tables */
    memset (&uToUni, '\0', sizeof (uToUni));
    memset (&byFromUni, '\0', sizeof (byFromUni));

    /* for each input data line */
    nLines = 0;
    while (fgets (szInLine, MAX_LINE_BUF - 1, fIn) != NULL) {
        if  (szInLine[0] == COMMENT_CHAR || strlen(szInLine) < 4)
            continue;

        /* overflow check */
        if (nLines > MAX_8_BITS)
            FatalD ("over 256 records", nLines);

        /* parse input line into index and four codes */
        iIndex = iCode[0] = iCode[1] = iCode[2] = 0;
        sscanf (szInLine, "%x\t%x\t%x\t%x\n",
            &iIndex, &iCode[0], &iCode[1], &iCode[2]);
        if (iIndex != nLines || iIndex < 0 || iIndex >= MAX_8_BITS) {
            fprintf (stderr, "%s\n",szInLine);
            sprintf(szInLine,"record out of sequence: line: %d\tindex: ",nLines);
            FatalD (szInLine/*"record out of sequence"*/, iIndex);
        }

        /* check that input is legal in-range UniCode and set uToUni */
        for (i = 0; i < MAX_CODES; i++) {
            u = iCode[i];
            if ((u >= BEG_URANGE_1 && u < END_URANGE_1) ||
                (u >= BEG_URANGE_2 && u < END_URANGE_2) ||
                (u >= BEG_URANGE_3 && u < END_URANGE_3)) {
                uToUni[iIndex][i] = iCode[i];
                continue;
            }
            else {
                FatalD ("UniCode out of range", u);
            }
        }

        /* set reverse UniCode to code page table */
        for (i = 0; i < MAX_8_BITS; i++) {
            /* uses 1st non-ligatured code only */
            if (uToUni[i][0] != 0 &&
                uToUni[i][1] == 0 &&
                uToUni[i][2] == 0) {
                /* set the first instance only */
                if  ((uToUni[i][0])<0 || (uToUni[i][0]>=MAX_16_BITS)) {
                    fprintf (stderr, "uToUni[%d][0] = %x\n", i,uToUni[i][0]);
                    //Fatal("ReadInOneDataFile: bad value for uToUni[i][0]: ");
                }
                else {
                    if (byFromUni [MAP(uToUni[i][0])] == 0)
                        byFromUni [MAP(uToUni[i][0])] = iIndex;
                }
            }
        }

        /* bump line counter */
        nLines++;
    }
}

/* -------------------------     */


/*
 * WriteOutOneRCFile -- write out one data file's corresponding .RC file.
 */
void WriteOutOneRCFile (FILE *fOut, PCODEPAGEREC pCodePageRec,
    char *szFileName)
{
    char *cp;
    unsigned i;
    int j;

    /* skip the directory separator '\' in the filename */
    if ((cp = strchr (szFileName, '\\')) == NULL)
        cp = szFileName;
    else
        cp = cp + 1;

    /* write out the file name and copyright message */
    fprintf (fOut, "%c%c\n", '/', '*');
    fprintf (fOut, " %c %s -- %s %s.\n", '*', cp, pCodePageRec->szCodeDesc,
        "header file");
    fprintf (fOut, " %c %s\n", '*', LEGAL_COPYRIGHT_STRING);
    fprintf (fOut, " %c%c\n\n\n", '*', '/');

    if ((cp = strstr(szFileName, ".")) == NULL)
        Fatal ("missing extension error");
    *cp = NULL;
    //strcat (szFileNameRC, EXT_RC);
    /* first the code page to UniCode table */

    fprintf (fOut, "static gt_wchar_t %s_To_Uni_Data[] =\n{\n",
         pCodePageRec->szCodeName);

    // output size of table in BYTES
//    fprintf (fOut, "\t/* No. of Bytes */\t%ul,\n", MAX_8_BITS*MAX_CODES*2);

    for (i = 0; i < MAX_8_BITS; i++) {
        fprintf (fOut, "\t/* %2X */\t ", i);
        for (j = 0; j < MAX_CODES; j++) {
            fprintf (fOut, "0x%04X", uToUni[i][j]);
            if (j < MAX_CODES - 1)
                fputs (", ", fOut);
        }
        if (i < MAX_8_BITS - 1)
            fputc (',', fOut);
        fputc ('\n', fOut);

    }
    fprintf (fOut, "};\n\n");

    /* second the 1st part of the UniCode to code page table */
    fprintf (fOut, "static BYTE Uni_To_%s_1_Data[] =\n{\n",
         pCodePageRec->szCodeName);

    // output size of table in BYTES
    // fprintf (fOut, "\t/* No. of Bytes */\t%ul,\n", (END_URANGE_1 - BEG_URANGE_1));

    for (i = BEG_URANGE_1; i < END_URANGE_1; i++) {
        fprintf (fOut, "\t/* U+%04X */\t \'\\x%02X\'", i, byFromUni[MAP(i)]);
        //fprintf (fOut, "\t%c%c U+%04X", '/', '*', i);
        //fprintf (fOut, " %c%c\t\"\\%o\"", '*', '/', byFromUni[i]);
        if (i < END_URANGE_1 - 1)
            fputc (',', fOut);
        fputc ('\n', fOut);
    }
    fprintf (fOut, "};\n\n");

    /* third the 2nd part of the UniCode to code page table */
    fprintf (fOut, "static BYTE Uni_To_%s_2_Data[] =\n{\n",
         pCodePageRec->szCodeName);

    // output size of table in BYTES
    // fprintf (fOut, "\t/* No. of Bytes */\t%ul,\n", (END_URANGE_2 - BEG_URANGE_2));

    for (i = BEG_URANGE_2; i < END_URANGE_2; i++) {
        fprintf (fOut, "\t/* U+%04X */\t \'\\x%02X\'", i, byFromUni[MAP(i)]);
        //fprintf (fOut, "\t%c%c U+%04X", '/', '*', i);
        //fprintf (fOut, " %c%c\t\"\\%o\"", '*', '/', byFromUni[i]);
        if (i < END_URANGE_2 - 1)
            fputc (',', fOut);
        fputc ('\n', fOut);
    }
    fprintf (fOut, "};\n\n");


	fprintf (fOut, "memset(&ConvertTable[nConvertTableSize], 0, sizeof(CONVERT));\n");
	fprintf (fOut, "ConvertTable[nConvertTableSize].CodePage = %s;\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].ConvertType = eUnknownConvert;\n");
	fprintf (fOut, "ConvertTable[nConvertTableSize].bMultiTable = FALSE;\n");
	fprintf (fOut, "ConvertTable[nConvertTableSize].Uni_To_THIS_1 = Uni_To_%s_1_Data;\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].SizeOfUni_To_THIS_1 = sizeof(Uni_To_%s_1_Data);\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].Uni_To_THIS_2 = Uni_To_%s_2_Data;\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].SizeOfUni_To_THIS_2 = sizeof(Uni_To_%s_2_Data);\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].THIS_To_Uni = %s_To_Uni_Data;\n", pCodePageRec->szCodeName);
	fprintf (fOut, "ConvertTable[nConvertTableSize].SizeOfTHIS_To_Uni = sizeof(%s_To_Uni_Data);\n", pCodePageRec->szCodeName);

	fprintf (fOut, "nConvertTableSize++;\n");
	fprintf (fOut, "memset(&ConvertTable[nConvertTableSize], 0, sizeof(CONVERT));\n");
	fprintf (fOut, "ConvertTable[nConvertTableSize].CodePage = CP_LAST;\n");

}



/* -------------------------     */


/*
 * WriteOutMasterIncludeFile -- generate the include file for XLATLIB.C.
 */
void WriteOutMasterIncludeFile (void)
{
    int i;
    FILE *fOut;
    char szFileName[MAX_FILENAME];
    //char szFileNameH[MAX_FILENAME];
    //char *cp;

    strcpy (szFileName, MASTER_INCLUDE);
    if ((fOut = fopen (szFileName, "wt")) == NULL) {
        perror (szFileName);
        Fatal ("master include (XLAT2.H) write open failure");
    }

    fprintf (stderr, "Writing %s\n", szFileName);
    fprintf (fOut, "/*\n * %s -- automatically generated.\n", szFileName);
    fprintf (fOut, " * %s\n", LEGAL_COPYRIGHT_STRING);
    fprintf (fOut, " */\n\n");
    fprintf (fOut, "#define MAX_NO_OF_CODES  %i\n", iMaxNoOfCodes);
    fprintf (fOut, "#define MAX_NO_OF_RANGES %i\n", iMaxNoOfRanges);
    fprintf (fOut, "#define MAX_NO_OF_OUTCODES  %i\n", iRMaxNoOfCodes);
    fprintf (fOut, "#define MAX_NO_OF_OUTRANGES %i\n", iRMaxNoOfRanges);

    fputs ("#if (  XLATLIB  )\n\n" , fOut);
    fputs ("CPREC CPRecTable[] = {\n", fOut);
    for (i = 0; i < nCodePageRecs; i++) {
//      fprintf(fOut, "  {%s, IDS_%s, \"%s\", \"%s\", NULL, NULL, NULL}",
        fprintf(fOut, "  {%s, IDS_%s, %s, \"%s\", %1i, NULL, NULL, NULL}",
            CodePageRecs[i].szCodeName,
            CodePageRecs[i].szCodeName,
            CodePageRecs[i].szClosestWCp,
            ((char *) &CodePageRecs[i].szCodeName)+4 /* skip KCP_ ,*/,
            (CodePageRecs[i].nBytes == -1));
//          CodePageRecs[i].szCodeDesc);
        if (i < (nCodePageRecs - 1))
            fputc (',', fOut);
        fputc ('\n', fOut);
    }
    fputs ("};\n\n", fOut);
    fputs ("CPEXTRA CPExtraTable[] = {\n", fOut);
    for (i = 0; i < nExtras; i++) {
        fprintf(fOut, "  {%s, IDS_%s, \"%s\"}",
            Extras[i].szCodeName,
            Extras[i].szCodeName,
            Extras[i].szCodeDesc);
        if (i < (nExtras - 1))
            fputc (',', fOut);
        fputc ('\n', fOut);
    }
    fputs ("};\n\n", fOut);
    fputs ("#else   /* XLATLIB */\n\n" , fOut);
    fputs ("extern CPREC   CPRecTable[];\n\n", fOut);
    fputs ("extern CPEXTRA CPExtraTable[];\n\n", fOut);
    fputs ("#endif /* XLATLIB */\n\n" , fOut);

    fclose (fOut);
}

/* -------------------------     */

void InvertMultiTableDataFile (PCODEPAGEREC pCodePageRec)
{
#if 1
    FILE *fInDat    = NULL;
    FILE *fOutDat   = NULL;
    //char *cp;
    WORD c1, c2;
    char szBuf[MAX_LINE_BUF];
#endif
    char szFileNameDat  [MAX_FILENAME];
    char szNewFileName  [MAX_FILENAME];
    char szCmd[MAX_LINE_BUF];

    /* name and open the .DAT input data file */
    sprintf (szFileNameDat, "%s%s",  SUBDIR_DAT, pCodePageRec->szFileName);
    strcpy(szNewFileName,szFileNameDat);
    szNewFileName[strlen(szNewFileName)-1] = '~';
    //sprintf (szNewFileName, "%s~%s", SUBDIR_DAT, pCodePageRec->szFileName);
    //sprintf (szCmd, "flipdat.bat %s %s", szFileNameDat, szNewFileName);
    //system(szCmd);
#if 1
    if  ((fInDat = fopen (szFileNameDat, "rt")) == NULL) {
        perror (szFileNameDat);
        Fatal ("data file read open failure");
    }
    if  ((fOutDat = fopen ("foo.~~~", "wt")) == NULL) {
        perror (szNewFileName);
        Fatal ("new data file write open failure");
    }
    // for now just copy
    while (fgets (szBuf, MAX_LINE_BUF - 1, fInDat) != NULL) {
        if  (szBuf[0] == COMMENT_CHAR || strlen(szBuf) < MIN_LINE_BUF)
            continue; // skip comment lines
        sscanf(szBuf,"%x  %x",&c1,&c2);
        fprintf (fOutDat, "0x%04X 0x%04X\n",c2,c1);
        //fputs(szBuf,fOutDat);
        //fputc('\n',fOutDat);
    }
    if (fInDat != NULL)
        fclose (fInDat);
    if (fOutDat != NULL)
        fclose (fOutDat);
    sprintf (szCmd, "sort foo.~~~ > %s", szNewFileName);
    system(szCmd);
#endif
    //sprintf(szNewFileName, "~%s", pCodePageRec->szFileName);
    strcpy(szNewFileName,pCodePageRec->szFileName);
    szNewFileName[strlen(szNewFileName)-1] = '~';
    strcpy(pCodePageRec->szFileName,szNewFileName);
}
/*
 * WriteOutMasterRCFile -- generate the RC file for XLATLIB.C.
 */
void WriteOutMasterRCFile (void)
{
	int i;
    FILE *fOut;
    char szFileName[MAX_FILENAME];
    char szFileNameRC[MAX_FILENAME];
    char *cp;

    strcpy (szFileName, MASTER_RC);
    if ((fOut = fopen (szFileName, "wt")) == NULL) {
        perror (szFileName);
        Fatal ("master RC (XLAT.RC) write open failure");
    }

    fprintf (stderr, "Writing %s\n", szFileName);
    fprintf (fOut, "/*\n * %s -- automatically generated.\n", szFileName);
    fprintf (fOut, " * %s\n", LEGAL_COPYRIGHT_STRING);
    fprintf (fOut, " */\n\n");
    fprintf (fOut, "#include \"..\\xlat\\xlatid.h\"\n\n");
	fprintf (fOut,
            "#ifdef XLAT\n"
			"#include \"xlatbld.h\"\n"
            "#include \"..\\filters\\product.h\"\n"
			"#define PRODUCT_NAME \"XLAT.DLL -- translation module\\0\"\n"
            "#define FILE_DESCRIPTION_STRING \"Codepage/Character Translation Utility\\0\"\n"
			"#ifdef FILE_VERSION_NUMBER \n"
			"#undef FILE_VERSION_NUMBER \n"
			"#endif \n"
			"#ifdef BUILD \n"
			"#undef BUILD \n"
			"#endif \n"
			"#define FILE_VERSION_NUMBER " FILEVERNUM "\n"
			"#define BUILD \"" FILEVERSTRING "\"\n"
			"rcinclude \"..\\filters\\versinfo.rc\"\n"
            );
    for (i = 0; i < nCodePageRecs; i++) {
        BOOL bMulti = CodePageRecs[i].szFileName[strlen(CodePageRecs[i].szFileName)-1] == '~';
        sprintf (szFileNameRC, "%s%s", SUBDIR_RC, CodePageRecs[i].szFileName);
        if ((cp = strstr(szFileNameRC, EXT_DAT)) == NULL)
            Fatal ("missing extension error");
        *cp = NULL;
        strcat (szFileNameRC, EXT_RC);
        fprintf (fOut, "rcinclude %s\n", szFileNameRC);

        if  (bMulti) {
            szFileNameRC[strlen(szFileNameRC)-1] = '~';
            fprintf (fOut, "rcinclude %s\n", szFileNameRC);
        }
    }
    fprintf (fOut, "#endif\n");
    fputc ('\n', fOut);

    fprintf(fOut, "STRINGTABLE\n\tBEGIN\n");
    for (i = 0; i < nCodePageRecs; i++) {
        fprintf (fOut, "\tIDS_%s \"%s\"\n", CodePageRecs[i].szCodeName,
                                            CodePageRecs[i].szCodeDesc);
    }
    // now add any additional string that do NOT correspond to xlat tables
    // for example, string names for the unicode code pages
    for (i = 0; i < nExtras; i++) {
        //printf ("\tIDS_%s \"%s\"\n", Extras[i].szCodeName,Extras[i].szCodeDesc);
        fprintf (fOut, "\tIDS_%s \"%s\"\n", Extras[i].szCodeName,
                                            Extras[i].szCodeDesc);
    }

    fprintf(fOut, "\tEND\n");

    fclose (fOut);
}

/* -------------------------     */


/*
 * Usage -- print usage message and exit.
 */
void Usage (void)
{
    fprintf (stderr, "usage: UniServPrep [Unicode_conv] [Galtech_codepgae]");
    exit (1);
}

/* -------------------------     */


/*
 * Fatal -- print fatal error message and quit.
 */
void Fatal (char *s)
{
    fprintf (stderr, "Error: %s\n", s);
    exit (1);
}

/* -------------------------     */


/*
 * FatalD -- print fatal error message and quit (with decimal argument).
 */
void FatalD (char *s, WORD i)
{
    fprintf (stderr, "Error: %s: 0x%x\n", s, i);
    exit (1);
}

/* -------------------------     */

// ======== old stuff ============
#if 0
    fputs ("#else   /* SE_WINDOWS3 */\n\n" , fOut);

    for (i = 0; i < nCodePageRecs; i++) {
        sprintf (szFileNameH, "%s%s", SUBDIR_H, CodePageRecs[i].szFileName);
        if ((cp = strstr(szFileNameH, EXT_DAT)) == NULL)
            Fatal ("missing extension error");
        *cp = NULL;
        strcat (szFileNameH, EXT_H);
        fprintf (fOut, "#include \"%s\"\n", szFileNameH);
    }
    fputs ("\n", fOut);

    fputs ("CPREC CPRecTable [] = {\n", fOut);

    for (i = 0; i < nCodePageRecs; i++) {
        fprintf(fOut, "  {%s, IDS_%s, \"%s\", \"%s\", %s_To_Uni, Uni_To_%s_1, Uni_To_%s_2}",
            CodePageRecs[i].szCodeName,
            CodePageRecs[i].szCodeName,
            ((char *) &CodePageRecs[i].szCodeName)+4 /* skip KCP_ */,
            CodePageRecs[i].szCodeDesc,
            CodePageRecs[i].szCodeName,
            CodePageRecs[i].szCodeName,
            CodePageRecs[i].szCodeName);
        if (i < (nCodePageRecs - 1))
            fputc (',', fOut);
        fputc ('\n', fOut);
    }

    fputs ("};\n\n", fOut);

    fputs ("#endif /* SE_WINDOWS3 */\n\n" , fOut);
#endif

