/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifdef __TV_WINDOWS__
	#include "windows.h"
#endif //__TV_WINDOWS__

#ifdef __TV_UNIX__
	#include "string.h"
#endif //UNIX

#include "gt_portable.h"
#include "uniserv.h"
#include "gt_unidef.h"
#include "unios.h"

CONVERT ConvertTable[128];
int nConvertTableSize;

BOOL InitData()
{
// initialize ConvertTable[]
// code for each table is found in its file
#ifdef NON_WEB_CODEPAGES
#include "../tables/ados710.tab"
#include "../tables/al_arabi.tab"
#include "../tables/ameer.tab"
#include "../tables/arcii.tab"
#include "../tables/ascii7.tab"
#include "../tables/ascii7h.tab"
#include "../tables/asmo449.tab"
#include "../tables/asmo449p.tab"
#include "../tables/asmo708.tab"
#include "../tables/asmo708p.tab"
#include "../tables/beehive.tab"
#include "../tables/codarufd.tab"
#include "../tables/comtr341.tab"
#include "../tables/comtr541.tab"
#include "../tables/datagenr.tab"
#include "../tables/dec8asmo.tab"
#include "../tables/ebcdic37.tab"
#include "../tables/hp_arab8.tab"
#include "../tables/ibm437.tab"
#include "../tables/ibm855.tab"
#include "../tables/ibm857.tab"
#include "../tables/ibm860.tab"
#include "../tables/ibm863.tab"
#include "../tables/ibm864.tab"
#include "../tables/ncr96.tab"
#include "../tables/ncras708.tab"
#include "../tables/sakhr.tab"
#include "../tables/nafitha.tab"
#include "../tables/mssymbol.tab"
#include "../tables/ibm865.tab"
#include "../tables/kivunpi.tab"
#include "../tables/ibmnlsup.tab"
#include "../tables/ibmas400.tab"
#include "../tables/wingding.tab"
#include "../tables/zentec.tab"
#endif

#include "../tables/ibm866.tab"
#include "../tables/ibm869.tab"
#include "../tables/iso88591.tab"
#include "../tables/iso88592.tab"
#include "../tables/iso88593.tab"
#include "../tables/iso88594.tab"
#include "../tables/iso88595.tab"
#include "../tables/iso88596.tab"
#include "../tables/iso88597.tab"
#include "../tables/iso88598.tab"
#include "../tables/iso88599.tab"
#include "../tables/japeuc.tab"
#include "../tables/jis.tab"
#include "../tables/koi8.tab"
#include "../tables/ksc5601.tab"
#include "../tables/macheb.tab"
#include "../tables/macroman.tab"
#include "../tables/shiftjis.tab"
#include "../tables/winarab.tab"
#include "../tables/wincyr.tab"
#include "../tables/winee.tab"
#include "../tables/wingreek.tab"
#include "../tables/winheb.tab"
#include "../tables/winturk.tab"
#include "../tables/winusa.tab"
#include "../tables/big5.tab"
#include "../tables/gb2312.tab"
#include "../tables/ibm850.tab"
#include "../tables/ibm852.tab"
#include "../tables/ibm861.tab"
#include "../tables/ibm862.tab"

//@@peter
#include "../tables/iso885915.tab"
#include "../tables/cp1257.tab"

	for(CONVERT *pConvert = ConvertTable;
		pConvert->CodePage != CP_LAST; pConvert++)
	{
			switch(pConvert->CodePage)
			{
			case CP_EUCJP:
			case CP_EUCCN:
			case CP_JIS:
			case CP_UTF7:
			case CP_UTF8:
				pConvert->ConvertType = eUniConvert;
				break;
			default:
#if __TV_WINDOWS__
				if(IsValidCodePage(pConvert->CodePage))
					pConvert->ConvertType = eOSConvert;
				else
					pConvert->ConvertType = eUniConvert;
#else
				pConvert->ConvertType = eUniConvert;
#endif //__TV_WINDOWS__
			}

	}
	return TRUE;
};

class InitConversionTables
{
public:
	InitConversionTables()
	{
		InitData();
	}
} __Init;

#ifdef _SJIS
	gt_wchar_t sjis_CODES[] = {
		#include "rc/shiftjis.cod"
	};

	RANGE sjis_RANGES[] = {
		#include "rc/shiftjis.rng"
	};

	DWORD sjis_RANGESIZE = sizeof(sjis_RANGES);
	DWORD sjis_CODESIZE = sizeof(sjis_CODES);
#endif //_SJIS
