/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// certConvertWizardDlg.cpp : implementation file
//

#include "stdafx.h"
#include "certConvertWizard.h"
#include "certConvertWizardDlg.h"
#include "platform.h"
#include "WLErrorLib.h"
//#include "mainFrm.h"
#include "tvenv.h"
#include "ossl_pkcs12_to_pem.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCertConvertWizardDlg dialog

CCertConvertWizardDlg::CCertConvertWizardDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCertConvertWizardDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCertConvertWizardDlg)
	m_sInFileName = _T("");
	m_sInPasswd = _T("");
	m_sOutPasswd = _T("");
	m_sOutPasswd2 = _T("");
	m_sOutFilePath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCertConvertWizardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCertConvertWizardDlg)
	DDX_Text(pDX, IDC_EDITINFILE, m_sInFileName);
	DDX_Text(pDX, IDC_EDITINPASSWD, m_sInPasswd);
	DDX_Text(pDX, IDC_EDITOUTPASSWD, m_sOutPasswd);
	DDX_Text(pDX, IDC_EDITOUTPASSWD2, m_sOutPasswd2);
	DDX_Text(pDX, IDC_EDITOUTFILE, m_sOutFilePath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCertConvertWizardDlg, CDialog)
	//{{AFX_MSG_MAP(CCertConvertWizardDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONSELECT, OnButtonselect)
	ON_BN_CLICKED(IDC_BTNCONVERT, OnBtnconvert)
	ON_BN_CLICKED(IDCLOSE, OnClose)
	ON_BN_CLICKED(IDC_BUTTONSELECT2, OnButtonselect2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCertConvertWizardDlg message handlers

BOOL CCertConvertWizardDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCertConvertWizardDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCertConvertWizardDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CCertConvertWizardDlg::OnButtonselect() 
{
	// TODO: Add your control notification handler code here
  //CString strres = "Certificate file(.pfx;.p12)";
  	UpdateData( true );

  char strFilter[] = { "Certificate Files (*.pfx;*.p12)|*.pfx;*p12|All Files (*.*)|*.*||" };
  CFileDialog fileDlg(true, "pfx;p12", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST,strFilter);

	//int ret = fileDlg.DoModal();
   if( fileDlg.DoModal ()==IDOK )
   {
      m_sInFileName = fileDlg.GetPathName();
      UpdateData(false);
   }

}

void CCertConvertWizardDlg::OnBtnconvert() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);

	if (m_sInFileName.IsEmpty() || m_sOutFilePath.IsEmpty() || m_sInPasswd.IsEmpty() || m_sOutPasswd.IsEmpty() ||  m_sOutPasswd2.IsEmpty())
	{
		MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 2 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
		return;
	}

  if (m_sOutPasswd.Compare (m_sOutPasswd2))
  {
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 3 ), "Certificate Conversion Wizard"
      , MB_ICONEXCLAMATION | MB_OK );
    return;
  }


  int rc = _PKCS12_to_PEM_convert((char*)(LPCTSTR)m_sInFileName,(char*)(LPCTSTR)m_sInPasswd,(char*)(LPCTSTR)m_sOutFilePath,(char*)(LPCTSTR)m_sOutPasswd);

  //0 is OK anything else - not good
  switch(rc)
  {
  case 0:
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 4 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
    break;
  case PKCS12TOPEM_ERR_OPENINPUTFILE:
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 5 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
    break;
  case PKCS12TOPEM_ERR_OPENOUTPUTFILE:
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 11 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
    break;
  case PKCS12TOPEM_ERR_READINPUTFILE:
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 6 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
    break;
  case PKCS12TOPEM_ERR_WRITEOUTPUTFILE:
    MessageBox( "Error writing to output file", "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
    break;
  default:
    MessageBox( WLERRGetErrorFormat( "CertWiz.frm", 0 ), "Certificate Conversion Wizard"
			, MB_ICONEXCLAMATION | MB_OK );
  }

}

void CCertConvertWizardDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
  DestroyWindow();
}

void CCertConvertWizardDlg::OnButtonselect2() 
{
	// TODO: Add your control notification handler code here
  	// TODO: Add your control notification handler code here
  //CString strres = "Certificate file(.pfx;.p12)";
  	UpdateData( true );

  char strFilter[] = { "Certificate Files (*.pem)|*pem" };
  CFileDialog fileDlg(false, "pem",NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, strFilter);

	//int ret = fileDlg.DoModal();
   if( fileDlg.DoModal ()==IDOK )
   {
      m_sOutFilePath = fileDlg.GetPathName();
      UpdateData(false);
   }

	
}
