/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#ifndef __WebLoad_Cache_H
#define __WebLoad_Cache_H

enum CUSTOM_CACHE_INFO{
	CI_EMPTY = 0,	
	CI_INDEXED_PROPERTY = 1	
};

class CParamterInfo;

class CMethodInfo : public RVCollectable{

public:
  RVDECLARE_COLLECTABLE(CMethodInfo)


public:

  CMethodInfo();

  CMethodInfo(DISPID dispid_);

  CMethodInfo(DISPID dispid_,int InvokeType_,int type_return_);
  
  ~CMethodInfo();


  void InsertParam(CParamterInfo* param_);

  DISPID GetDISPID(){ return m_dispid;}
  int GetInvokeType(){return m2_InvokeType;}
  int GetTypeReturn(){return m_TypeReturn;}
  int GetParamNumber(){return m_ParamNumber;}
  int GetParamNumberMinimum(){return m_ParamNumberMinimum;}
  RVOrdered *GetParamList(){return m_pParamList;}
	CUSTOM_CACHE_INFO GetCustomInfo(){return m_CustomInfo;}


  void SetInvokeType(int m2_InvokeType);
  void SetTypeReturn(int type_return_);
  void SetParamNumber(int param_number_);
  void SetParamNumberMinimum(int param_number_minimum_);

  void SetCustomInfo(CUSTOM_CACHE_INFO CustomInfo_);


  void PrintParamTypes();




private:
  RVOrdered *m_pParamList;
//  RVOrdered m_ParamList;

  DISPID m_dispid;
//  bool m_IsMethod;
	int m2_InvokeType;
  int m_TypeReturn;
  int m_ParamNumber;
  int m_ParamNumberMinimum;
	CUSTOM_CACHE_INFO m_CustomInfo;
};


class CParamterInfo : public RVCollectable{

public:
  RVDECLARE_COLLECTABLE(CParamterInfo)

public:
  CParamterInfo(int type_,bool optional_);
  

  CParamterInfo(){}

  int GetType() {return m_Type;}
  bool GetOptional() {return m_Optional;}
  bool GetTypeIsPointer() {return m_TypeIsPointer;}

  void SetType(int type_); 
  void SetOptional(bool optional_);
  void SetTypeIsPointer(bool type_is_pointer_);






private:
  int m_Type;
  bool m_TypeIsPointer;
  bool m_Optional;


};

class CObjectGUID : public RVCollectable{


public:
   RVDECLARE_COLLECTABLE(CObjectGUID)
   CObjectGUID(GUID guid_);
   CObjectGUID(){}

   virtual bool isEqual(const RVCollectable* c)const;
	 virtual unsigned hash() const;
public:

   void PrintInterface();      

private:
  GUID m_guid;

};


class CVARIANTArrayPointer : public RVCollectable{


public:
   RVDECLARE_COLLECTABLE(CVARIANTArrayPointer)
   CVARIANTArrayPointer(VARIANT *pVARIANT,int VARIANT_length);
   CVARIANTArrayPointer(){}

   //virtual bool isEqual(const RVCollectable* c)const;
public:

   //void PrintInterface();      

//private:
public:
	VARIANT *m_pVARIANT;
  int m_VARIANT_length;

};


void printKeyAndValue( RVCollectable* ky, RVCollectable* val, void*); // prototype
void printKeyAndValue1( RVCollectable* ky, RVCollectable* val, void*); // prototype


#endif //__WebLoad_Cache_H
