/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// Convert2Variant.h: interface for the CConvert2Variant class.
//
//////////////////////////////////////////////////////////////////////
#include "ComObjectClass.h"

#if !defined(AFX_CONVERT2VARIANT_H__1AF4A1F3_2CB1_11D3_9519_0090271C2713__INCLUDED_)
#define AFX_CONVERT2VARIANT_H__1AF4A1F3_2CB1_11D3_9519_0090271C2713__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define VARIANT_TYPES_NUMBER 30
#define JAVASCRIPT_TYPES_NUMBER 7


class CStaticHelper{
public:

	static jsval ConvertVariant2JSVAL(const VARIANT& ConvertVariant,JSContext *cx,
														 iJSComPrivateData *ptrCJSCOMObject_father, 
														 Object_RDS_Status RDS_Status_of_Father_Object,
														 const char* name);

  static int ReverseVARIANTArray(VARIANT* Variant_array, const int length);

	static 	bool MakeDATE(DATE* pdtDest, WORD  wYear, WORD  wMonth, WORD  wDay, 
								WORD  wHour, WORD  wMinute,   WORD  wSecond);

	static BSTR JS_VALUE2BSTR(JSContext *cx,jsval jsvalue);
	static int VariantArrayClear_Destroy(VARIANT* Variant_array,int length);
	static int VariantArrayClear_DestroyEx(VARIANT* Variant_array,int length);
	static int JSVAL_TO_VARIANT(JSContext *cx,const jsval jsvalue,	
															int cache_vt_type,VARIANT &Variant_value,
															WLERRORINFO &ErrInfo,
															iJSComPrivateData *pJSCOMObject = NULL);
															//RVOrdered **pVARIANTArrayPointerList = NULL);

	static int JSString2Variant(JSContext *cx,const jsval jsvalue,
											 int cache_vt_type, VARIANT &Variant_value);

	static int JSDouble2Variant(JSContext *cx,const jsval jsvalue,
											 int cache_vt_type, VARIANT &Variant_value);

	static int JSBoolean2Variant(JSContext *cx,const jsval jsvalue,
  										 int cache_vt_type, VARIANT &Variant_value);

	static int JSInteger2Variant(JSContext *cx,const jsval jsvalue,
  										 int cache_vt_type, VARIANT &Variant_value);


	


	static void FormatErrorParameterMessage(int cache_vt_type,int jsval_type,WLERRORINFO &ErrInfo);
	static void FormatErrorArrayMessage(int array_type,WLERRORINFO &ErrInfo);
	static void FormatErrorArrayConstructionMessage(int error_index,WLERRORINFO &ErrInfo);

	static int IsArrayOfSameTypes(VARIANT* Variant_array,int length);
	static WL_JSType WL_JS_TypeOfValue(const jsval jsvalue);

	static int MakeDefaultPropertyCall(JSContext * cx,iJSComPrivateData *pCJSComObject,WLERRORINFO &m_ErrInfo,VARIANT *retval);

	static RVCString VARIANT_TYPES[VARIANT_TYPES_NUMBER + 1];
	static RVCString JAVASCRIPT_TYPES[JAVASCRIPT_TYPES_NUMBER + 1];

};



#endif // !defined(AFX_CONVERT2VARIANT_H__1AF4A1F3_2CB1_11D3_9519_0090271C2713__INCLUDED_)
