/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  

#include "ComObjectClass.h"


#include "stdafx.h"

//#include <iostream.h>
#include <hashdict.h>
#include "rvjsapi.h"

#include "Convert2Variant.h"
#include "HashDictionaries.h"
#include "cache.h"
#include "wlerrorlib.h"
#include "platform.h"
#include "loadengineglobals.h"
#include "wljsobjects.h"


#include "ComMethodClass.h"

#include "ComProtocol.h"

#include "managerscriptdata.h"

#include "tracedll.h"

// Chaim - XMLHttpRequest
//#include "xmlhttp.h"

//Galtech
#include "gt_jshelper.h"

#include "FlashObject.h"

#define ComScriptingFrmFile "comscripting.frm"

//^^^^^^^^^^^^^^^^ ComObjectClass object ^^^^^^^^^^^^^^^^^^^^^^^^^

//"standard" functions
static JSBool ComObjectCtor(JSContext *cx, JSObject *obj, uintN argc,
														jsval *argv, jsval *rval);

static void ComObjectFinalize(JSContext *cx, JSObject *obj);

static JSBool ComObject_PropertyGet(JSContext *cx, JSObject *obj,
																		jsval id, jsval *vp);

static JSBool ComObject_PropertySet(JSContext *cx, JSObject *obj,
																		jsval id, jsval *vp);

//"custom" functions
//static JSBool ActivateComMethod(JSContext *cx, JSObject *obj,
	//															uintN argc, jsval *argv, jsval *rval);

static JSBool ActivateDefaultProperty(JSContext *cx, JSObject *parentObj,
																			uintN argc, jsval *argv, jsval *rval);

static JSBool ComObject_ValueOf(JSContext*, JSObject*, uintN, jsval*, jsval*);
static JSBool ComObject_ToString(JSContext*, JSObject*, uintN, jsval*, jsval*);
static JSBool ComObject_GetSoapOperationsForService(JSContext*, JSObject*, uintN, jsval*, jsval*);
static JSBool ComObject_SetSoapConnectorProperty(JSContext*, JSObject*, uintN, jsval*, jsval*);


//^^^^^^^^^^^^^^^^ DataTypeWraper object ^^^^^^^^^^^^^^^^^^^^^^^^^

static void DataTypeWraperFinalize(JSContext *cx, JSObject *obj);


//^^^^^^^^^^^^^^^^^^^^ Global Functions ^^^^^^^^^^^^^^^^^^^^^^^^^

//External "JS-visible" functions

static JSBool
ComObject_ToString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoByte(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoShort(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoLong(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoDouble(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoFloat(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoIUnknown(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoIDispatch(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoVARIANT(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);

static JSBool
global_COMJStoBoolean(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval);


static bool g_bComExceptionsOn = false;

static JSBool
global_COMExceptionsOn(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  g_bComExceptionsOn = true;
  return JS_TRUE;
}

static JSBool
global_COMExceptionsOff(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  g_bComExceptionsOn = false;
  return JS_TRUE;
}

//Internal "non JS-visible" functions


//bool RegisterComObject(JSContext *cx, JSObject *obj);//obj IS THE GLOBAL OBJECT OF THE EXECUTING SCRIPT
static WLERRORINFO SetHresultErrorInfo(WLERRORINFO ErrInfo); //set the terms that are connected to the hr. (they are not update)

//bool WLCOMProcessInitialization();
//bool WLCOMProcessUninitialization();

//%%%%%%%%%%%%%%%% JS Objects & Functions Definition %%%%%%%%%%%%%%%%%%%%%%%%%%%

// JS OBJECT. STRUCT THAT HOLDS POINTERS TO FUNCTIONS.



//%%%%%%%%%%%%%%%% JS Objects & Functions Definition %%%%%%%%%%%%%%%%%%%%%%%%%%%

// JS OBJECT. STRUCT THAT HOLDS POINTERS TO FUNCTIONS.
JSClass ComObjectClass = {
  "ActiveXObject",//CONSTRUCTOR
  JSCLASS_HAS_PRIVATE,
  JS_PropertyStub,	// add Property
  JS_PropertyStub,	// del Property
  ComObject_PropertyGet,	// get Property //JS ENGINE WILL CALL THIS FUNCTION WHEN THERE IS '.' AFTER JS OBJECT
  ComObject_PropertySet,	// set Property  //JS ENGINE WILL CALL THIS FUNCTION WHEN THERE IS '=____.' AFTER JS OBJECT
  JS_EnumerateStub,
	JS_ResolveStub,//proto_resolve_stub,
	JS_ConvertStub,
	ComObjectFinalize,  //DESTRUCTOR
	0,0,
	ActivateDefaultProperty
};

static JSFunctionSpec ComObjectClass_methods[] = {
//	{"ActivateComMethod",          ActivateComMethod,	  10},
	{"valueOf", ComObject_ValueOf, 10},
	{"toString", ComObject_ToString, 10},
	{0}
};

static JSBool global_GetVersion(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {
		*rval = INT_TO_JSVAL(5);
		return JS_TRUE;
}


//this function is onlt for testing.
static JSBool global_ComTest(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {//temp avidan

//////demonstrate getting a data member from the class 'comProtocolAgendaInMix'/////
	if(piLEProtocolProcess->AmIInScriptLevel(cx)) {
		iLEProtocolAgendaInMix* piLEProtocolAgendaInMix = (iLEProtocolAgendaInMix*)&(piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx));
		assert(piLEProtocolAgendaInMix);
		comProtocolAgendaInMix* pcomProtocolAgendaInMix = dynamic_cast<comProtocolAgendaInMix*>(piLEProtocolAgendaInMix);
		RVCString& comTest = pcomProtocolAgendaInMix->GetTestString();
//		LoadReport( cx, WLLogMessage::Warning, "I am in function global_COMTest, the string data member of the protocol is in the next warning");//temp avidan
//		LoadReport( cx, WLLogMessage::Warning, comTest.data());//temp avidan
	}
	else {
		if(piLEProtocolProcess->AmIInThreadLevel(cx)) {
			iLEProtocolVCInMix* piLEProtocolVCInMix = (iLEProtocolVCInMix*)&(piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx));
			assert(piLEProtocolVCInMix);
			comProtocolAgendaInMix& pcomProtocolAgendaInMix = dynamic_cast<comProtocolAgendaInMix&>(piLEProtocolVCInMix->GetProtocolAgendaInMix());
			RVCString& comTest = pcomProtocolAgendaInMix.GetTestString();
//			LoadReport( cx, WLLogMessage::Warning, "I am in function global_COMTest, the string data member of the protocol is in the next warning");//temp avidan
//			LoadReport( cx, WLLogMessage::Warning, comTest.data());//temp avidan

		}
		else{}
	}

//////demonstrate getting a data member from the class 'comProtocolAgendaInMix'/////
		if(piLEProtocolProcess->AmIInThreadLevel(cx)) {//@@avida temp

			iLEProtocolAgendaMachineThread& piLEProtocolAgendaMachineThread =
        piLEProtocolProcess->GetProtocolAgendaMachineThread(cx);

			comProtocolAgendaMachineThread& pcomProtocolAgendaMachineThread = dynamic_cast<comProtocolAgendaMachineThread&>(piLEProtocolAgendaMachineThread);
//			int bTemp = pcomProtocolAgendaMachineThread.Getm_RuningBrowserPlayBack();
//			char* s;
//			s = (char*)&bTemp;
//			s="kkk";
//			long* l;
//			l = (long*)&bTemp;
//			LoadReport( cx, WLLogMessage::Warning, s);//temp avidan
		}
		else{}


  RVCString& scriptName = piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx).GetScriptName();
  LoadReport(cx, WLLogMessage::Warning, "The agenda name that was return after using the LE API is : (next warning)");
	LoadReport(cx, WLLogMessage::Warning, scriptName.data());

	return JS_TRUE;
}

//	THE FUNCTION FORCE THE VC THREAD TO ENTER MTA APARTMENT
static JSBool global_ComForceVcInMTA(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval) {

	if(piLEProtocolProcess->AmIInScriptLevel(cx)) {
		iLEProtocolAgendaInMix* piLEProtocolAgendaInMix = (iLEProtocolAgendaInMix*)&(piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx));
		assert(piLEProtocolAgendaInMix);
		iLEProtocolProcess* piLEProtocolProcess = &(piLEProtocolAgendaInMix->GetProtocolProcess());
		assert(piLEProtocolProcess);
		comProtocolProcess* pcomProtocolProcess = dynamic_cast<comProtocolProcess*>(piLEProtocolProcess);
		assert(pcomProtocolProcess);
		pcomProtocolProcess->ForceVcInMTA();
	}
	else {
		//not in InitAgenda() won't change the flag.
		// cause it is aloud to call the function ComForceVCinMTA only
		// from the InitAgenda()
		WLErrorException e(ComScriptingFrmFile, 230, "ComForceVcInMTA");
		return LoadReport( cx, e );
	}

	return JS_TRUE;
}




JSClass DataTypeWraperClass = {
  "DataTypeWraperClass",
  JSCLASS_HAS_PRIVATE,
  JS_PropertyStub,	// add Property
  JS_PropertyStub,	// del Property
  JS_PropertyStub,	// get Property
  JS_PropertyStub,	// set Property
	JS_EnumerateStub,
	JS_ResolveStub,
	JS_ConvertStub,
  DataTypeWraperFinalize
 };

static JSFunctionSpec global_methods[] = {
  {"CByte",				                    global_COMJStoByte,		                1},
  {"CInt",				                    global_COMJStoShort,	                1},
  {"CLng",				                    global_COMJStoLong,								    1},
  {"CDbl",				                    global_COMJStoDouble,	                1},
  {"CFlt",				                    global_COMJStoFloat,	                1},
  {"CVARIANT",		                    global_COMJStoVARIANT,                1},
  {"CBool",				                    global_COMJStoBoolean,						    1},
  {"COMExceptionsOn",				          global_COMExceptionsOn,						    1},
  {"COMExceptionsOff",			          global_COMExceptionsOff,						  1},
//{"CIUnknown",			                  global_COMJStoIUnknown,               1},
//{"CIDispatch",	                    global_COMJStoIDispatch,              1},
	{"UNDOC_GetCOMVersion", global_GetVersion, 1},
	{"ComForceVcInMTA", global_ComForceVcInMTA, 1},//THE USER CAN CALL THIS FUNCTION
						// IN THE InitAgenda() IN ORDER TO IMPROVE PERFORMENCE . IF THE USER CALL
						// THIS FUNCTION, HE IS NOT ALLOWED TO CREATE ActiveXObject
							// IN THE InitAgenda().
	{"ComTest",global_ComTest,0},//temp avidan
	{0}
};


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@  End of Declaration @@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%% ComObjectClass object %%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

//CONSTRUCTOR OF A JS OBJECT.
static JSBool
ComObjectCtor(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
	if(piLEProtocolProcess->AmIInScriptLevel(cx)) {

		//the call 'new ActiveXObject' was called from the InitAgenda function in the agenda.
		HRESULT hr = CoInitializeEx(NULL,COINIT_MULTITHREADED);
		if (hr != S_OK && hr != S_FALSE) {
			// maybe an Error. coInitialize is called on the same thread with another threading module.
			// In BrowserPlayback/WebFT the main thread call coInitializeEx with threading module STA.
			// and if there is creation of activeXObject in the InitAgenda, the same thread called again the CoInitializeEx 
			// with threading module MTA.
			WlTraceMsg("maybe an Error in function 'ComObjectCtor' of jscomobject module. coInitialize is called on the same thread with another threading module.");
			//
//			return JS_FALSE;//@@avidan47 
		}

		iLEProtocolAgendaInMix* piLEProtocolAgendaInMix = (iLEProtocolAgendaInMix*)&(piLEProtocolProcess->GetProtocolAgendaJSEmbedContext(cx));
		assert(piLEProtocolAgendaInMix);
		iLEProtocolProcess* piLEProtocolProcess = &(piLEProtocolAgendaInMix->GetProtocolProcess());
		comProtocolProcess* pcomProtocolProcess = dynamic_cast<comProtocolProcess*>(piLEProtocolProcess);
		//The com object is being created in the initagenda function, in order
		//that the virtual client will be able to activate the object, all the
		//virtual client threads should be in MTA as well.
		pcomProtocolProcess->ForceVcInMTA();
	}

  WLERRORINFO m_ErrInfo;

  bool bol_result;
	RVCString Message;

	if ((argc < 1) || (argc >2 )) {
    WLErrorException e(ComScriptingFrmFile, 1);
		return LoadReport( cx, e );
  }

  if (!JSVAL_IS_STRING(argv[0])) {
    Message = "ComObjectCtor : ComObject name must be a string.";
		return LoadReport( cx, WLLogMessage::Fatal, Message );
  }

  if (!JSVAL_IS_STRING(argv[1]) && (argc == 2) ) {
    Message = "ComObjectCtor : Remote Computer Name must be a string.";
		return LoadReport( cx, WLLogMessage::Fatal, Message );
  }

  const char* ObjectName = JS_GetStringBytes(JSVAL_TO_STRING(argv[0]));

  CJSGCRequestSuspendResume gc(cx);

  // Flash Support
/*  if (IsFlashActiveX(ObjectName)){
    JSClass* pClass;
    GetFlashClass(&pClass);
    JSObject* pObj;

    pObj = JS_NewObject(cx, pClass, NULL, NULL);
    if (!pObj){
      return JS_FALSE;
    }

//    return XMLHttpRequestCtor(cx, pObj, argc, argv, rval);
    *rval = OBJECT_TO_JSVAL(obj);
    return JS_TRUE;
  }

  if (IsXMLHttpRequestActiveX(ObjectName)){
    JSClass* pClass;
    GetXMLHttpRequestClass(&pClass);
    JSObject* pObj;

    // @@Chaim - XMLHttpRequest does this need to be guarded? I think not...
    pObj = JS_NewObject(cx, pClass, NULL, NULL);
    if (!pObj){
      return JS_FALSE;
    }
    return XMLHttpRequestCtor(cx, pObj, argc, argv, rval);
  }
  */

  iJSComPrivateData *pCJSComObject = new ComObject();
	// int result;  //    //Debug Needs

  if (argc == 2){
    char* RemoteComputer = JS_GetStringBytes(JSVAL_TO_STRING(argv[1]));
    bol_result = pCJSComObject->Init(ObjectName,m_ErrInfo,RemoteComputer);
		//result = pCJSComObject->InitXMLObject(RemoteComputer);   //Debug Needs
  }

  else {
    bol_result = pCJSComObject->Init(ObjectName,m_ErrInfo);
			//bol_result = true;
    //result = pCJSComObject->InitXMLObject();      //Debug Needs
  }

  //if (result != 0){  //    //Debug Needs
  if (bol_result != true){
    Message = "ComObjectCtor : Failed to create COM Object (";
    Message += ObjectName;
    Message += ")";
		return LoadReport( cx, WLLogMessage::Fatal, Message.data() );
  }


//QWERTY
	pCJSComObject->m_pObjectsCache->GetTypeInfo(pCJSComObject);//WRITE THE Type Info IF EXISTS.
//	pCJSComObject->SetLoadGeneratorThreadData(getCurrentThreadData(cx));//???ASK ITAJ TO REPOT ERROR

	#ifdef _DEBUG
		pCJSComObject->PrintObjectCreate(cx);
	#endif

  JS_SetPrivate(cx, obj, pCJSComObject);
  return JS_TRUE;
}

static void
ComObjectFinalize(JSContext *cx, JSObject *obj)
{
  iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);
	if (pCJSComObject != NULL)
	{
		delete(pCJSComObject);//WILL CALL THE DESTRUCTOR ~JSCOMObject()
		pCJSComObject = NULL;
	}
}

static JSBool
ComObject_PropertyGet(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
{
  return GlobalComObject_PropertyGet(cx, obj, id, vp);
}

JSBool
GlobalComObject_PropertyGet(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
{
	WLERRORINFO m_ErrInfo;
	jsval				vpKeep = *vp;

	iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);


	if(!pCJSComObject) { //Itaj
		return JS_TRUE;
	}


	if( JSVAL_IS_INT(id) ) {
		// integer property name
		int index = JSVAL_TO_INT(id);
		int ret = pCJSComObject->CallMethodItemDispatcher(cx, index, m_ErrInfo, vp);
		if (ret != 0)
		{
			*vp = vpKeep;
			if (!ThrowComError(cx,m_ErrInfo))
				return JS_FALSE;
			else
				return JS_TRUE;
		}

		return JS_TRUE;

	} else if( JSVAL_IS_STRING(id) ) {

	if( RVJS_IsFunction( cx, *vp ) ) {
		return JS_TRUE;
	}
/*
	if( JSVAL_IS_OBJECT( *vp ) ) {
		if( &js_FunctionClass == JS_GetClass( cx, JSVAL_TO_OBJECT( *vp ) ) ) {
			return JS_TRUE;
		}
	}
*/
		const char* name = (const char*)JS_GetStringBytes(JSVAL_TO_STRING(id));

	//  if (strcmp(name, "ActivateComMethod") == 0)
		//  return JS_TRUE;
	/*
		if (strcmp(name, "valueOf") == 0)
			return JS_TRUE;

		if (strcmp(name, "toString") == 0)
			return JS_TRUE;

		if (strcmp(name, "constructor") == 0)
			return JS_TRUE;
	*/
//@gil
		bool exitMethod = false;
		pCJSComObject->BeforeGetProperty(cx, obj, id, vp, exitMethod);    //@@ for FTPlayBack
		if(exitMethod) {
			return JS_TRUE;
		}

		int ReturnStatus = 0;
		VARIANTARG ReturnValue;
		VariantInit(&ReturnValue);
		ReturnValue.vt = VT_EMPTY;

	//#define TI_SIMPLE_PROPERTY 1
	//#define NOTI_SIMPLE_PROPERTY 2
	//#define TI_NON_SIMPLE_PROPERTY 4
	//#define NOTI_NON_SIMPLE_PROPERTY 8


		int ret = pCJSComObject->GetPropertyDispatcher(cx,name,&ReturnStatus,m_ErrInfo,vp);
		if	(ret != 0) {
			*vp = vpKeep;
		}

	  pCJSComObject->AfterGetProperty(cx, obj, id, vp, exitMethod, ret,m_ErrInfo);    //@@ for FTPlayBack
		if(exitMethod) {
			return JS_TRUE;
		}


		if (ret != 0) {
			if (!ThrowComError(cx,m_ErrInfo))
				return JS_FALSE;
			else
				return JS_TRUE;
		}


		//there was no error, but we want to be sure that it was really
		//a property
		if ((ReturnStatus == TI_SIMPLE_PROPERTY) ||
				(ReturnStatus == NOTI_SIMPLE_PROPERTY)){

		}

		//checks weather we really tried to call a propery, or we were
		//returned as "non-property"
		else  {
			/*
			jsval funcval;

			if (!JS_GetProperty(cx, obj, "ActivateComMethod", &funcval))
				return JS_FALSE;

			*vp = funcval;
	*/



      *vp = OBJECT_TO_JSVAL( NewComMethodObject( cx, name, obj ) );


		}

		return JS_TRUE;
	} else {
		WlTraceMsg("Error : In the function ComObject_PropertyGet");
		assert(0); // property name must be either integer or string
	}
	return JS_TRUE;
}

static JSBool
ComObject_PropertySet(JSContext *cx, JSObject *obj, jsval id, jsval *vp)
{

  WLERRORINFO m_ErrInfo;
  jsval				vpKeep = *vp;

  iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);

//@gil
  bool exitMethod = false;

	pCJSComObject->BeforeSetProperty(cx, obj, id, vp, exitMethod);    //@@ for FTPlayBack
	if(exitMethod) {
		return JS_TRUE;
	}


	if(!pCJSComObject) { //Itaj
    char* Message = "ActiveXObject : Not an instance os ActiveXObject - Failed to set a property";
		return LoadReport( cx, WLLogMessage::Error, Message );
	}

  const char* name = (const char*)JS_GetStringBytes(JSVAL_TO_STRING(id));

  if (strcmp(name, "IgnoreTypeInfo") == 0)
	{
		int int_value = JSVAL_TO_INT(*vp);
		if (int_value)
		{
			pCJSComObject->SetTypeInfoExists(0);
		}
    return JS_TRUE;
	}
	int ret = pCJSComObject->SetPropertyDispatcher(name, cx, vp, m_ErrInfo);
	if	(ret != 0) {
		*vp = vpKeep;
	}

  pCJSComObject->AfterSetProperty(cx, obj, id, vp, exitMethod, ret,m_ErrInfo);    //@@ for FTPlayBack
  if(exitMethod) {
    return JS_TRUE;
	}


	if (ret != 0)
	{
		if (!ThrowComError(cx,m_ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
	return JS_TRUE;
}

/*
static JSBool
ActivateComMethod(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  WLERRORINFO m_ErrInfo;
  int ret;

  iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);
	ret = pCJSComObject->CallMethodDispatcher(cx,argv,argc,m_ErrInfo,rval);

  if (ret != 0) {
		if (!ThrowComError(cx,m_ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}

  return JS_TRUE;
}

*/
static JSBool
ActivateDefaultProperty(JSContext *cx, JSObject *parentObj, uintN argc, jsval *argv, jsval *rval)
{
  WLERRORINFO m_ErrInfo;
  int ret;

	#ifdef _DEBUG
	//	cout<<"ActivateDefaultProperty was called !!!!"<<endl;
	#	endif

	//We don't use the "parent" object, but rather the "son" object (arv[-2]);

	JSObject *thisObj = JSVAL_TO_OBJECT(argv[-2]);
  iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, thisObj);

  //@gil
  if (pCJSComObject->GetptrIDispatch() == NULL)
    return JS_TRUE;

	ret = pCJSComObject->CallDefaultPropertyDispatcher(cx,argv,argc,m_ErrInfo,rval);

  if (ret != 0) {
		if (!ThrowComError(cx,m_ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}

  return JS_TRUE;
}

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%% DataTypeWraper object %%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

static void
DataTypeWraperFinalize(JSContext *cx, JSObject *obj)
{

  VARIANT *WraperVariant_value = (VARIANT*)JS_GetPrivate(cx, obj);
	if (WraperVariant_value != NULL)
	{
		if ((WraperVariant_value->vt) == (VT_BYREF|VT_VARIANT))
		{
			VariantClear(WraperVariant_value->pvarVal);
			delete WraperVariant_value->pvarVal;
		} else if ((WraperVariant_value->vt) == (VT_BYREF|VT_BSTR))
		{
			//@@Sergei
      delete WraperVariant_value->pbstrVal;
		}
		VariantClear(WraperVariant_value);
		delete WraperVariant_value;
	}

}


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%% Global Functions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


static JSBool
ComObject_ValueOf(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;
  WLERRORINFO m_ErrInfo;

	if (argc == 1){
		char* TypeName = (char*)JS_GetStringBytes( JS_ValueToString(cx,argv[0]));
		if (strcmp(TypeName,"function") == 0){
			*rval = OBJECT_TO_JSVAL(obj);
			return JS_TRUE;
		}
	}

  iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);

	if(!pCJSComObject) { //Itaj
    char* Message = "ActiveXObject : Not an instance os ActiveXObject - Failed to call valueOf";
		return LoadReport( cx, WLLogMessage::Error, Message );
	}

  //@gil
  if (pCJSComObject->GetptrIDispatch() == NULL)
  {
    
    return JS_TRUE;
  }

	ret = pCJSComObject->CallDefaultPropertyDispatcher(cx,argv,0,m_ErrInfo,rval);

  if (ret != 0)
	{
		RVCString sClassName = "[object ComObject (";
		sClassName.append(pCJSComObject->GetObjectClassName_RW());
		sClassName.append(")]");
		*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, sClassName.data()));
	}
  return JS_TRUE;
}

//IF A FUNCTION IN JAVA SCRIPT WANTS TO GET STRING IT CONVERT THE PARAMETER
//TO STRING WITHOUT CARRING WHICH TYPE IT'S GETS. EVERY OBJECT NEEDS TO HAVE A FUNCTION THAT
//CONVERT ITSELF TO STRING.
static JSBool
ComObject_ToString(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval){

	WLERRORINFO m_ErrInfo;
	iJSComPrivateData *pCJSComObject = (iJSComPrivateData*)JS_GetPrivate(cx, obj);

	if(!pCJSComObject) { //Itaj
    char* Message = "ActiveXObject : Not an instance os ActiveXObject - Failed to call toString";
		return LoadReport( cx, WLLogMessage::Error, Message );
	}


  //@gil
  if (pCJSComObject->GetptrIDispatch() == NULL)
    return JS_TRUE;

	int ret = pCJSComObject->CallDefaultPropertyDispatcher(cx,argv,0,m_ErrInfo,rval);

  if (ret != 0)
	{
		RVCString sClassName = "[object ComObject (";
		sClassName.append(pCJSComObject->GetObjectClassName_RW());
		sClassName.append(")]");
		*rval = STRING_TO_JSVAL(ANSINewStringCopyZ(cx, sClassName.data()));
	}
  return JS_TRUE;
}


//THIS FUNCTION WILL BE CALLED WHEN CALLING IN THE AGENDA TO THE FUNCTION CByte()
//A JS OBJECT :'DataTypeWraperClass' IS CREATED AND SET A VARIANT AS IT PROPERTY.
//THE VARIANT WILL BE TFOM TYPE Byte AND WITH THE ARGV VALUE.
static JSBool
global_COMJStoByte(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	JSBool bool_res = JS_InstanceOf(cx,obj,&DataTypeWraperClass,NULL);

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CByte");

	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_UI1,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
		*rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}

static JSBool
global_COMJStoShort(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CInt");

	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_I2,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
		*rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}

static JSBool
global_COMJStoLong(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CLng");

	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_I4,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
		*rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}


static JSBool
global_COMJStoDouble(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CDbl");
	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_R8,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
		*rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}


static JSBool
global_COMJStoFloat(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CFlt");
	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_R4,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
	  *rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}

static JSBool
global_COMJStoBoolean(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
//	LoadReport( cx, WLLogMessage::Warning, "I am in function global_COMJStoBoolean");//temp avidan
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CBool");
	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_BOOL,*Variant_Value,ErrInfo);

	if (ret == 0){
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
	  *rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}

	else {

		VariantClear(Variant_Value);
		delete Variant_Value;

		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}



static JSBool
global_COMJStoVARIANT(JSContext *cx, JSObject *obj, uintN argc, jsval *argv, jsval *rval)
{
  int ret;

	VARIANT *Variant_Value = new VARIANT;
	VariantInit(Variant_Value);

	WLERRORINFO ErrInfo(WL_CONVERSION_FUNCTION,"CVARIANT");
	ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,argv[0],VT_BYREF|VT_VARIANT,*Variant_Value,ErrInfo);
	if (ret == 0)
	{
		JSObject *JSConversionObject = JS_NewObject(cx,&DataTypeWraperClass,NULL,NULL);
	  JS_SetPrivate(cx, JSConversionObject, Variant_Value);
		*rval = OBJECT_TO_JSVAL(JSConversionObject);
		return JS_TRUE;
	}	else
	{
		VariantClear(Variant_Value);
		delete Variant_Value;
		if (!ThrowComError(cx,ErrInfo))
			return JS_FALSE;
		else
			return JS_TRUE;
	}
}

bool RegisterComObject(JSContext *cx, JSObject *obj)
{
	//
	// Load the error-formats file.
	WLERRGetErrorFormat(ComScriptingFrmFile, 0);

  //ComObjectClass.call = ActivateDefaultProperty;

  //DEFINE CERTAIN NAMES, THAT WILL BE KNOWN IN THE JS, AND WILL INVOKE FUNCTION IN C++.
  if (!JS_InitClass(cx, obj, NULL, &ComObjectClass, ComObjectCtor, 1, NULL, ComObjectClass_methods, NULL, NULL))
    return false;

  if (!JS_InitClass(cx, obj, NULL, &DataTypeWraperClass, NULL, 0, NULL, NULL, NULL, NULL))
    return false;
//avidan
	if (!JS_InitClass( cx, obj,NULL, GetComMethodJSClass(), NULL , 0 ,NULL, NULL, NULL, NULL ) )
		return false;

	for (int i = 0; global_methods[i].name; i++)
		if (!JS_DefineFunction(cx, obj, global_methods[i].name, global_methods[i].call,
									global_methods[i].nargs, global_methods[i].flags))
			return false;

	  return true;
}

bool ThrowComError(JSContext *cx,WLERRORINFO &ErrInfo)
{
  if (piLEProtocolProcess->AmIInScriptLevel(cx))
	{
			WLErrorException e(ComScriptingFrmFile, ErrInfo.m_ErrorIndex, ErrInfo.m_ErrorDescription);
			return LoadReport( cx, e );
	}


	WLErrorException e(ComScriptingFrmFile, ErrInfo.m_ErrorIndex, ErrInfo.m_ErrorDescription);
  //
  // Changed by Yahali - 15-3-2004
  // Added to enable exceptions when COM errors occur
  if (g_bComExceptionsOn) {
    return LoadReport(cx, WLLogMessage::Error, e.GetErrorMsg());
  } else {
	  return LoadReport( piLEProtocolProcess->GetProtocolJSEmbedContext(cx).GetInternalLEJSEmbedContext(), cx, e);
  }
}

