/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
// Convert2Variant.cpp: implementation of the CConvert2Variant class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <atlbase.h>
#include <hashdict.h>
#include "cache.h"
#include "HashDictionaries.h"
#include "jsdate.h"
//#include <iostream.h>
#include "jsnum.h"
#include "tvenv.h"



TVEnvContainerClass tvpc;
bool g_bJavaRecordingSupported = false;

void C2V_Init()
{
  tvpc.reset();
  RVCString sTmp = tvpc.TVEGetEnv( "JRP_MODE" );
  sTmp.strip();

  if ( sTmp.isNull() )
		g_bJavaRecordingSupported = false;

  else if ( sTmp.compareTo( "on", RVCString::ignoreCase ) == 0 )
		g_bJavaRecordingSupported = true;
}

extern JSClass ComObjectClass;
extern JSClass DataTypeWraperClass;

RVCString CStaticHelper :: JAVASCRIPT_TYPES[JAVASCRIPT_TYPES_NUMBER + 1] ={
	"void", //0
	"object",  //1
	"integer", //2
	"double",  //3
	"string", //4
	"boolean",//5
	"error", //6
	"Unknown Type" //7 //My type for some unknown type
};

RVCString CStaticHelper :: VARIANT_TYPES[VARIANT_TYPES_NUMBER + 1] ={
	"empty", //0
	"NULL",  //1
	"short", //2
	"long",  //3
	"float", //4
	"double",//5
	"currency", //6
	"date", //7
	"string",//8
	"IDispatch",//9
	"Error",//10
	"boolean",//11
	"Variant",//12
	"IUnknown",//13
	"decimal",//14
	"",//15
	"char",//16
	"unsigned char",//17
	"unsigned short",//18
	"unsigned long",//19
	"VT_I8",//20
	"VT_UI8",//21
	"integer",//22
	"unsigned interger",//23
	"void",//24
	"HRESULT",//25
	"VT_PTR",//26
	"SafeArray",//27
	"carray",//28
	"user defined",//29
	"Unknown Type" //30 //My type for some unknown type
};

jsval CStaticHelper :: ConvertVariant2JSVAL(const VARIANT& ConvertVariant,JSContext *cx,
																						 iJSComPrivateData *ptrCJSCOMObject_father,
																						 Object_RDS_Status RDS_Status_of_Father_Object,
																						 const char *name)
{
	long retVal = 0;
	switch(ConvertVariant.vt){
//@@Sergei
	case VT_DECIMAL :
		struct tagDEC nDecimal = ConvertVariant.decVal;
		VarI4FromDec(&nDecimal, &retVal);
		return(INT_TO_JSVAL(retVal));
//
	case VT_UI1 :
		return(INT_TO_JSVAL(ConvertVariant.bVal));

	case VT_I2 :
		return(INT_TO_JSVAL(ConvertVariant.iVal));

	case VT_INT :
		return(INT_TO_JSVAL(ConvertVariant.intVal));

	case VT_I4 :
		return(INT_TO_JSVAL(ConvertVariant.lVal));

  case VT_R4 :  {
    jsval rval;
    JS_NewDoubleValue(cx, ConvertVariant.fltVal, &rval);
    return(rval);
  }

  case VT_R8 :  {
    jsval rval;
    JS_NewDoubleValue(cx, ConvertVariant.dblVal, &rval);
    return(rval);
  }
//@@Sergei
	case VT_BYREF|VT_BSTR :
	{
		USES_CONVERSION;
		char *temp_str = OLE2A(*ConvertVariant.pbstrVal);
		JSString* str = JS_NewStringCopyZ(cx,temp_str);
    return(STRING_TO_JSVAL(str));
	}
	case VT_BSTR :
  {
    LPOLESTR temp_str_w = (LPOLESTR)ConvertVariant.bstrVal;
		USES_CONVERSION;
		JSString* str = JS_NewUCStringCopyZ(cx, temp_str_w);
    return(STRING_TO_JSVAL(str));
   }

	case VT_BOOL :


		return(BOOLEAN_TO_JSVAL(ConvertVariant.boolVal));

	case VT_DATE : {

		SYSTEMTIME  SystemTime;

		VariantTimeToSystemTime(ConvertVariant.date,&SystemTime);

		JSObject *date_obj = js_NewDateObject(cx,SystemTime.wYear,SystemTime.wMonth,
																						SystemTime.wDay,SystemTime.wHour,
																						SystemTime.wMinute,SystemTime.wSecond);

		return (OBJECT_TO_JSVAL(date_obj));

 }
//@@Sergei
	case VT_BYREF|VT_VARIANT:
	{
		IDispatchPtr spIDispatch = ConvertVariant.pvarVal->pdispVal;
		JSObject *js_Object = JS_NewObject(cx, &ComObjectClass, NULL, NULL);
		iJSComPrivateData *p_newCJSComObject = ptrCJSCOMObject_father->CreateNewObject();//@@ for FTPlayBack
		p_newCJSComObject->SetptrIDispatch(spIDispatch);
		if (RDS_Status_of_Father_Object == RDS_OBJECT)
			p_newCJSComObject->SetRDS_Status(CREATED_VIA_RDS);
		else {
			p_newCJSComObject->m_pObjectsCache->GetTypeInfo(p_newCJSComObject);
			p_newCJSComObject->SetRDS_Status(STANDARD_OBJECT);
		}
		
		p_newCJSComObject->ConcatImplicitObjectMethod(
		ptrCJSCOMObject_father->GetObjectClassName_RW(),name);
#ifdef _DEBUG
				p_newCJSComObject->PrintObjectCreate(cx);
#endif
				JS_SetPrivate(cx, js_Object, p_newCJSComObject);
				p_newCJSComObject->OnCreationOfJSComObject(cx, js_Object);//@@ for FTPlayBack
				//		VariantClear(ConvertVariant);
				return(OBJECT_TO_JSVAL(js_Object));
	}
//
	case VT_DISPATCH :	{
		if(ConvertVariant.pdispVal) {
			JSObject *js_Object = JS_NewObject(cx, &ComObjectClass, NULL, NULL);
			iJSComPrivateData *p_newCJSComObject = ptrCJSCOMObject_father->CreateNewObject();//@@ for FTPlayBack
			IDispatchPtr spIDispatch;
			spIDispatch = ConvertVariant.pdispVal;
			p_newCJSComObject->SetptrIDispatch(spIDispatch);

//		p_newCJSComObject->SetLoadGeneratorThreadData(getCurrentThreadData(cx));

			if (RDS_Status_of_Father_Object == RDS_OBJECT)
				p_newCJSComObject->SetRDS_Status(CREATED_VIA_RDS);

			else {
//QWERTY
				p_newCJSComObject->m_pObjectsCache->GetTypeInfo(p_newCJSComObject);
				p_newCJSComObject->SetRDS_Status(STANDARD_OBJECT);
			}

			p_newCJSComObject->ConcatImplicitObjectMethod(
										ptrCJSCOMObject_father->GetObjectClassName_RW(),name);


			#ifdef _DEBUG
				p_newCJSComObject->PrintObjectCreate(cx);
			#endif

			JS_SetPrivate(cx, js_Object, p_newCJSComObject);

			p_newCJSComObject->OnCreationOfJSComObject(cx, js_Object);//@@ for FTPlayBack

//		VariantClear(ConvertVariant);
			return(OBJECT_TO_JSVAL(js_Object));
		}
		return OBJECT_TO_JSVAL(ConvertVariant.pdispVal);
	}

	case VT_UNKNOWN :	{
				if(ConvertVariant.punkVal) {
					JSObject *js_Object = JS_NewObject(cx, &ComObjectClass, NULL, NULL);

					iJSComPrivateData *p_newCJSComObject = ptrCJSCOMObject_father->CreateNewObject();

					IDispatch *temp_IDispatch;
					p_newCJSComObject->PtrIUnknown2PtrIDispatch(ConvertVariant.punkVal,&temp_IDispatch);
					IDispatchPtr temp_sp_IDispatch;
					temp_sp_IDispatch = temp_IDispatch;

					p_newCJSComObject->SetptrIDispatch(temp_sp_IDispatch);

					p_newCJSComObject->m_pObjectsCache->GetTypeInfo(p_newCJSComObject);
					p_newCJSComObject->SetRDS_Status(STANDARD_OBJECT);

					#ifdef _DEBUG
						p_newCJSComObject->PrintObjectCreate(cx);
					#endif


					JS_SetPrivate(cx, js_Object, p_newCJSComObject);

					p_newCJSComObject->OnCreationOfJSComObject(cx , js_Object);//@@ for FTPlayBack

					return(OBJECT_TO_JSVAL(js_Object));
				}
				return OBJECT_TO_JSVAL(ConvertVariant.punkVal);
	}

	 default:

		return 0;

	}
}

int CStaticHelper :: ReverseVARIANTArray(VARIANT* Variant_array, const int length){

  int middle,counter;

	if (length % 2 == 0)
		middle = length / 2;
	else
		middle = (length - 1) / 2;

  VARIANT temp_variant;
	VariantInit(&temp_variant);


	for (counter = 0; counter <= middle - 1; counter++){

		VariantCopy(&temp_variant,&Variant_array[counter]);

		VariantClear(&Variant_array[counter]);
		VariantCopy(&Variant_array[counter],&Variant_array[length - counter - 1]);

		VariantClear(&Variant_array[length - counter - 1]);
		VariantCopy(&Variant_array[length - counter - 1],&temp_variant);

		VariantClear(&temp_variant);
	}

return 0;
}


bool CStaticHelper :: MakeDATE(DATE* pdtDest, WORD  wYear,
																 WORD  wMonth, WORD  wDay,
																 WORD  wHour, WORD  wMinute,
																 WORD  wSecond)

{
    SYSTEMTIME st = { 0 };
    st.wYear = wYear;
    st.wMonth = wMonth;
    st.wDay = wDay;
    st.wHour = wHour;
    st.wMinute = wMinute;
    st.wSecond = wSecond;

    return SystemTimeToVariantTime(&st, pdtDest) ? true : false;
}


BSTR CStaticHelper :: JS_VALUE2BSTR(JSContext *cx,jsval jsvalue){

	BSTR str_bstr;
	JSString* str = NULL;

	USES_CONVERSION;
	str = JS_ValueToString(cx, jsvalue);
	//Galtech
	str_bstr = ::SysAllocString(JS_GetStringChars(str));

	return str_bstr;
}

int CStaticHelper :: VariantArrayClear_Destroy(VARIANT* Variant_array,int length){

	for (int counter = 0; counter < length; counter++){

		// if it was SafeArray element, we must not call
		//VariantClear on it, because it was already been
		//called by SafeArrayDestroy function !!!
		//As as result of this we get "Fatal Error :Can't
		//make a load
		if ((Variant_array[counter].vt & VT_ARRAY) == 0){
			HRESULT hr = VariantClear(&Variant_array[counter]);
			//if (hr != 0){
			//	int a = 6;
			//}
		}
	}

	delete [] Variant_array;
//	cout<<"After delete[]"<<endl;

return 0;

}

int CStaticHelper :: VariantArrayClear_DestroyEx(VARIANT* Variant_array,int length)
{
	HRESULT hr = S_OK;
	for (int counter = 0; counter < length; counter++)
	{
    //@@Sergei
		if (Variant_array[counter].vt == (VT_BYREF|VT_BSTR))
		{
			BSTR* pBSTRString = Variant_array[counter].pbstrVal;
			::SysFreeString(*pBSTRString);
			delete pBSTRString;
		} else if (Variant_array[counter].vt == (VT_BYREF|VT_VARIANT))
		{
			//Variant_array[counter].pvarVal->pdispVal->Release();
			hr = VariantClear(Variant_array[counter].pvarVal);			
			delete Variant_array[counter].pvarVal;
		}
    //
		hr = VariantClear(&Variant_array[counter]);
	}

	delete [] Variant_array;
//	cout<<"After delete[]"<<endl;

return 0;

}

/*
typedef enum WL_CONVERSION_SOURCE {
  		WL_EMPTY,
			WL_CONVERSION_FUNCTION,
			WL_GET_PROPERTY,
			WL_SET_PROPERTY,
			WL_METHOD
} WL_CONVERSION_SOURCE;

*/
void CStaticHelper :: FormatErrorParameterMessage(int cache_vt_type,int jsval_type,
																									WLERRORINFO &m_ErrInfo){

	char error_message[1024];

	switch (m_ErrInfo.m_ConversionSource){

		case WL_CONVERSION_FUNCTION:
			strcpy(error_message,"Conversion function ");
			break;

		case WL_GET_PROPERTY:
		case WL_SET_PROPERTY:
			strcpy(error_message,"Property ");
			break;

		case WL_METHOD:
			strcpy(error_message,"Method ");
			break;

		default :
			break;
	}

	strcat(error_message,m_ErrInfo.m_MethodName);

	if (m_ErrInfo.m_ParamNumber > 0){
		char str[4];
		_itoa(m_ErrInfo.m_ParamNumber, str, 10 );
		strcat(str,"\0");

		strcat(error_message,", Paramter number : ");
		strcat(error_message,str);
	}

	strcat(error_message,". ");
	m_ErrInfo.m_ErrorIndex = 70;


	if (m_ErrInfo.m_IsArray)
		strcat(error_message,"Description : Error occured wahile passing an array. Invalid Data Type - Can't convert ");
	else
		strcat(error_message,"Description : Invalid Data Type - Can't convert ");

	if (jsval_type == 0)
		strcat(error_message,"JavaScript Value");

	else {

		if (jsval_type > JAVASCRIPT_TYPES_NUMBER)
			strcat(error_message,JAVASCRIPT_TYPES[JAVASCRIPT_TYPES_NUMBER]);
		else
			strcat(error_message,JAVASCRIPT_TYPES[jsval_type]);

		strcat(error_message," to ");

		if (cache_vt_type > VARIANT_TYPES_NUMBER)

			if (cache_vt_type & VT_ARRAY){
				int array_type = cache_vt_type & VT_TYPEMASK;
				strcat(error_message,"Array of type ");
				strcat(error_message,VARIANT_TYPES[array_type]);
			}

			else
				strcat(error_message,VARIANT_TYPES[VARIANT_TYPES_NUMBER]);

		else
			strcat(error_message,VARIANT_TYPES[cache_vt_type]);

	}
	strcat(error_message,"\0");
	m_ErrInfo.m_ErrorDescription = error_message;

}

void CStaticHelper :: FormatErrorArrayMessage(int array_type,
																							WLERRORINFO &m_ErrInfo){



	char error_message[1024];

	switch (m_ErrInfo.m_ConversionSource){

		case WL_GET_PROPERTY:
		case WL_SET_PROPERTY:
			strcpy(error_message,"Property ");
			break;

		case WL_METHOD:
			strcpy(error_message,"Method ");
			break;

		default :
			break;
	}

	strcat(error_message,m_ErrInfo.m_MethodName);
	strcat(error_message,". ");
	m_ErrInfo.m_ErrorIndex = 70;

	strcat(error_message,"Description : Failed to create SafeArray of ");
	strcat(error_message,VARIANT_TYPES[array_type]);
	strcat(error_message,"\0");
	m_ErrInfo.m_ErrorDescription = error_message;

/*
	m_ErrInfo.m_ErrorIndex = ErrorIndex;

	char str[2];
	_itoa( counter+1, str, 10 );
	m_ErrInfo.m_ErrorDescription = str;
*/

}


void CStaticHelper :: FormatErrorArrayConstructionMessage(int error_index,
																													WLERRORINFO &m_ErrInfo){



	char error_message[1024];

	switch (m_ErrInfo.m_ConversionSource){

		case WL_GET_PROPERTY:
		case WL_SET_PROPERTY:
			strcpy(error_message,"Property ");
			break;

		case WL_METHOD:
			strcpy(error_message,"Method ");
			break;

		default :
			break;
	}

	strcat(error_message,m_ErrInfo.m_MethodName);
	m_ErrInfo.m_ErrorIndex = error_index;

	strcat(error_message,"\0");
	m_ErrInfo.m_ErrorDescription = error_message;
}


int CStaticHelper ::  IsArrayOfSameTypes(VARIANT* Variant_array,int length){

	BOOL Variant_BYREF_exist = false;
	for (int counter = 0; counter < length; counter++)
	{
		if (Variant_array[counter].vt == (VT_BYREF|VT_VARIANT))
		{
			Variant_BYREF_exist = true;
			break;
		}
	}
	int first_vt_type = Variant_array[0].vt;

	for (counter = 1; counter < length; counter++){

		if (Variant_array[counter].vt != first_vt_type){

			if (Variant_BYREF_exist)
				//pizdets - ne vezde bili ispol'zovani conversion functions
				return VT_ERROR;
			else
				return VT_VARIANT;
		}
	}

	return first_vt_type;
/*
	if (first_vt_type == (VT_BYREF | VT_VARIANT))
		return VT_VARIANT;
	else
		return first_vt_type;
*/
}

WL_JSType CStaticHelper :: WL_JS_TypeOfValue(const jsval jsvalue){

	if JSVAL_IS_INT(jsvalue)
		return WL_JSTYPE_INT;

	else if JSVAL_IS_DOUBLE(jsvalue)
		return WL_JSTYPE_DOUBLE;

	else if JSVAL_IS_STRING(jsvalue)
		return WL_JSTYPE_STRING;

	else if JSVAL_IS_BOOLEAN(jsvalue)
		return WL_JSTYPE_BOOLEAN;

	else if JSVAL_IS_VOID(jsvalue)
		return WL_JSTYPE_VOID;

	else if JSVAL_IS_OBJECT(jsvalue)
		return WL_JSTYPE_OBJECT;

// ON IPOTETIC SITUATION
	else
		return WL_JSTYPE_ERROR;
}

/*
typedef enum WL_JSType {
  		WL_JSTYPE_VOID,
			WL_JSTYPE_OBJECT,
			WL_JSTYPE_INT,
			WL_JSTYPE_DOUBLE,
			WL_JSTYPE_STRING,
			WL_JSTYPE_BOOLEAN,
} WL_JSType;
*/

int CStaticHelper :: JSInteger2Variant(JSContext *cx,const jsval jsvalue,
																			int cache_vt_type, VARIANT &Variant_value){

	int int_value = JSVAL_TO_INT(jsvalue);

	switch(cache_vt_type){

		case VT_UI1://BYTE
			Variant_value.vt = VT_UI1;
			Variant_value.bVal = int_value;
			return 0;

		case VT_I2://SHORT
		case VT_VARIANT:
			Variant_value.vt = VT_I2;//????????cast to (short)?
			Variant_value.iVal = (short)int_value;
			return 0;



		case VT_I4://LONG
		case VT_EMPTY:	//?????????????????????? why convert to long
		case VT_USERDEFINED://?????????
			Variant_value.vt = VT_I4;
			Variant_value.lVal = (long)int_value;
			return 0;

		case VT_INT://INT
			Variant_value.vt = VT_INT;
			Variant_value.intVal = int_value;
			return 0;

		case VT_R4://FLOAT
			Variant_value.vt = VT_R4;
			Variant_value.fltVal = (float)int_value;
			return 0;

		case VT_R8://DOUBLE
			Variant_value.vt = VT_R8;
			Variant_value.dblVal = int_value;
			return 0;

		case VT_BOOL://VARIANT_BOOL
			Variant_value.vt = VT_BOOL;
			Variant_value.boolVal = int_value;
			return 0;

		case VT_BSTR:{//BSTR
			//Galtech
			wchar_t* str_value = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
//  		_bstr_t bstr_temp(str_value);
			Variant_value.vt = VT_BSTR;
			Variant_value.bstrVal = ::SysAllocString(str_value);
			return 0;
		}

		case VT_BYREF|VT_VARIANT :{
			Variant_value.vt = VT_BYREF|VT_VARIANT;
			Variant_value.pvarVal = new VARIANT;
			VariantInit(Variant_value.pvarVal);
			Variant_value.pvarVal->vt = VT_I4;
			Variant_value.pvarVal->lVal = int_value;
			return 0;
		}
//avidan
		case VT_UINT://UINT
			Variant_value.vt = VT_UINT;
			Variant_value.uintVal = (unsigned int)int_value;
			return 0;

		case VT_UI4://ULONG
			Variant_value.vt = VT_UI4;
			Variant_value.ulVal = (unsigned long)int_value;
			return 0;

		case VT_UI2://USHORT
			Variant_value.vt = VT_UI2;
			Variant_value.uiVal = (unsigned short)int_value;
			return 0;

		case VT_DECIMAL://DECIMAL
			Variant_value.vt = VT_DECIMAL;
			HRESULT hr;
			DECIMAL Decimal;
			hr=VarDecFromI4((long)int_value,&Decimal);
			if(SUCCEEDED(hr))
				Variant_value.decVal = Decimal;
			else
				return 1;
			return 0;

		case VT_CY://CY (currency)
			Variant_value.vt = VT_CY;
			HRESULT hr2;
			CY currency;
			hr2=VarCyFromI4((long)int_value,&currency);
			if(SUCCEEDED(hr2))
				Variant_value.cyVal = currency;
			else
				return 1;
			return 0;
//end avidan
		default :
			return 1;
	}//switch cache_vt_type
}


int CStaticHelper :: JSDouble2Variant(JSContext *cx,const jsval jsvalue,
																			int cache_vt_type, VARIANT &Variant_value){

	jsdouble dbl_value;

	JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
	if (res != JS_TRUE){
		return 1;
	}


	switch(cache_vt_type){

		case VT_UI1:
			Variant_value.vt = VT_UI1;
			Variant_value.bVal =(byte)dbl_value;
			return 0;

		case VT_I2:
			Variant_value.vt = VT_I2;
			Variant_value.iVal =(short) dbl_value;
			return 0;

		case VT_I4:
			Variant_value.vt = VT_I4;
			Variant_value.lVal =(long) dbl_value;
			return 0;

		case VT_INT:
			Variant_value.vt = VT_INT;
			Variant_value.intVal =(int) dbl_value;
			return 0;


		case VT_R4:
			Variant_value.vt = VT_R4;
			Variant_value.fltVal =(float) dbl_value;
			return 0;

		case VT_R8:
		case VT_VARIANT:
		case VT_EMPTY:
		case VT_USERDEFINED:
			Variant_value.vt = VT_R8;
			Variant_value.dblVal = dbl_value;
			return 0;

		case VT_BSTR:{
			//Galtech
			wchar_t* str_value = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
  		//_bstr_t bstr_temp(str_value);
			Variant_value.vt = VT_BSTR;
			Variant_value.bstrVal = ::SysAllocString(str_value);
			return 0;
		}

		case VT_BOOL:
			Variant_value.vt = VT_BOOL;
			Variant_value.boolVal =(BOOL) dbl_value;
			return 0;


		case VT_BYREF|VT_VARIANT :{
			Variant_value.vt = VT_BYREF|VT_VARIANT;
			Variant_value.pvarVal = new VARIANT;
			VariantInit(Variant_value.pvarVal);
			Variant_value.pvarVal->vt = VT_R8;
			Variant_value.pvarVal->dblVal = dbl_value;

			return 0;
		}


//avidan
		case VT_UINT://UINT
			Variant_value.vt = VT_UINT;
			Variant_value.uintVal = (unsigned int)dbl_value;
			return 0;

		case VT_UI4://ULONG
			Variant_value.vt = VT_UI4;
			Variant_value.ulVal = (unsigned long)dbl_value;
			return 0;

		case VT_UI2://USHORT
			Variant_value.vt = VT_UI2;
			Variant_value.uiVal = (unsigned short)dbl_value;
			return 0;

		case VT_DECIMAL://DECIMAL
			Variant_value.vt = VT_DECIMAL;
			HRESULT hr;
			DECIMAL Decimal;
			hr=VarDecFromI4((long)dbl_value,&Decimal);
			if(SUCCEEDED(hr))
				Variant_value.decVal = Decimal;
			else
				return 1;
			return 0;

		case VT_CY://CY (currency)
			Variant_value.vt = VT_CY;
			HRESULT hr2;
			CY currency;
			hr2=VarCyFromI4((long)dbl_value,&currency);
			if(SUCCEEDED(hr2))
				Variant_value.cyVal = currency;
			else
				return 1;
			return 0;

//end avidan


		default :
			return 1;
	}//switch cache_vt_type


}



int CStaticHelper :: JSBoolean2Variant(JSContext *cx,const jsval jsvalue,
																			int cache_vt_type, VARIANT &Variant_value){

	jsval DefaultValue;
	JSBool bool_value;

	if(JSVAL_IS_OBJECT(jsvalue))
		{

			JSBool res1 = JS_CallFunctionName( cx, JSVAL_TO_OBJECT(jsvalue), "valueOf", 0, 0, &DefaultValue );
			if ( res1 != JS_TRUE)
					return 1;

			JSBool res = JS_ValueToBoolean(cx,DefaultValue,&bool_value);
			if (res != JS_TRUE)
				return 1;
		}
	else
		{
	JSBool res = JS_ValueToBoolean(cx,jsvalue,&bool_value);
	if (res != JS_TRUE)
		return 1;
		}

	switch(cache_vt_type){

			case VT_UI1:
			  Variant_value.vt = VT_UI1;
			  Variant_value.bVal = bool_value;
				return 0;

			case VT_I2:
			  Variant_value.vt = VT_I2;
			  Variant_value.iVal = bool_value;
				return 0;

			case VT_I4:
			  Variant_value.vt = VT_I4;
			  Variant_value.lVal = bool_value;
				return 0;

			case VT_INT:
			  Variant_value.vt = VT_INT;
			  Variant_value.intVal = bool_value;
				return 0;


			case VT_R4:
				Variant_value.vt = VT_R4;
				Variant_value.fltVal =(float) bool_value;
				return 0;

			case VT_R8:
			  Variant_value.vt = VT_R8;
			  Variant_value.dblVal = bool_value;
				return 0;


			case VT_BOOL:
			case VT_VARIANT:
			case VT_EMPTY:
			case VT_USERDEFINED:
			  Variant_value.vt = VT_BOOL;
			  Variant_value.boolVal = bool_value;
				return 0;

			case VT_BSTR:{
				//Galtech
				wchar_t* str_value = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
  			//_bstr_t bstr_temp(str_value);
				Variant_value.vt = VT_BSTR;
				Variant_value.bstrVal = ::SysAllocString(str_value);
				return 0;
			}

			case VT_BYREF|VT_VARIANT :{
			//case VT_VARIANT :{
			  Variant_value.vt = VT_BYREF|VT_VARIANT;

				Variant_value.pvarVal = new VARIANT;
				VariantInit(Variant_value.pvarVal);
				Variant_value.pvarVal->vt = VT_BOOL;
				Variant_value.pvarVal->boolVal = bool_value;
				return 0;
			}

//avidan
		case VT_UINT://UINT
			Variant_value.vt = VT_UINT;
			Variant_value.uintVal = (unsigned int)bool_value;
			return 0;

		case VT_UI4://ULONG
			Variant_value.vt = VT_UI4;
			Variant_value.ulVal = (unsigned long)bool_value;
			return 0;

		case VT_UI2://USHORT
			Variant_value.vt = VT_UI2;
			Variant_value.uiVal = (unsigned short)bool_value;
			return 0;

		case VT_DECIMAL://DECIMAL
			Variant_value.vt = VT_DECIMAL;
			HRESULT hr;
			DECIMAL Decimal;
			hr=VarDecFromI4((long)bool_value,&Decimal);
			if(SUCCEEDED(hr))
				Variant_value.decVal = Decimal;
			else
				return 1;
			return 0;

		case VT_CY://CY (currency)
			Variant_value.vt = VT_CY;
			HRESULT hr2;
			CY currency;
			hr2=VarCyFromI4((long)bool_value,&currency);
			if(SUCCEEDED(hr2))
				Variant_value.cyVal = currency;
			else
				return 1;
			return 0;
//end avidan


			default :
				return 1;
		}//switch cache_vt_type
}


int CStaticHelper :: JSString2Variant(JSContext *cx,const jsval jsvalue,
																			int cache_vt_type,
																			VARIANT &Variant_value){

	jsdouble dbl_value;

	if ((cache_vt_type == VT_I1)  || (cache_vt_type == VT_UI1) ||
		  (cache_vt_type == VT_I2)  || (cache_vt_type == VT_I4) ||
		  (cache_vt_type == VT_INT) || (cache_vt_type == VT_R4) ||
		  (cache_vt_type == VT_R8)  || (cache_vt_type == VT_I1) ||
			(cache_vt_type == VT_UINT)|| (cache_vt_type == VT_UI4)|| //avidan
			(cache_vt_type == VT_UI2) || (cache_vt_type == VT_DECIMAL)||
			(cache_vt_type == VT_CY)) {

		 JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);

		 if (res != JS_TRUE){
			return 1;
		 }

		 else{
 			if (JSDOUBLE_IS_NaN(dbl_value))
				return 1;
		 }
	}


	switch(cache_vt_type){

		case VT_I1://why no two cases for each case
		case VT_UI1:{

			Variant_value.vt = VT_UI1;
			Variant_value.bVal =(byte) dbl_value;
			return 0;
		}

		case VT_I2:{

			Variant_value.vt = VT_I2;
			Variant_value.iVal =(short) dbl_value;
			return 0;
		}

		case VT_I4:{

			Variant_value.vt = VT_I4;
			Variant_value.lVal =(long)dbl_value;
			return 0;
		}

		case VT_INT:{

			Variant_value.vt = VT_INT;
			Variant_value.intVal =(int) dbl_value;
			return 0;
		}


		case VT_R4:{

			Variant_value.vt = VT_R4;
			Variant_value.fltVal =(float) dbl_value;
			return 0;
		}

		case VT_R8:{

			Variant_value.vt = VT_R8;
			Variant_value.dblVal = dbl_value;
			return 0;
		}
//@@Sergei
		case VT_BYREF|VT_BSTR:
		{
				wchar_t* str_value = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
				USES_CONVERSION;
				V_VT(&Variant_value)  = VT_BSTR | VT_BYREF;
				BSTR* bstrOut = new BSTR(::SysAllocString(str_value));
				V_BSTRREF(&Variant_value) = bstrOut;
			return 0;
		}
//
		case VT_BSTR:
		case VT_USERDEFINED:
		case VT_VARIANT:
		case VT_EMPTY:
    {
			//Galtech
			wchar_t* str_value = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
			USES_CONVERSION;
			Variant_value.bstrVal = ::SysAllocString(str_value);
			Variant_value.vt = VT_BSTR;
			return 0;
		}

		case VT_BYREF|VT_VARIANT :{
			wchar_t *wstr_temp = JS_GetStringChars(JS_ValueToString(cx,jsvalue));
			Variant_value.vt = VT_BYREF|VT_VARIANT;
			Variant_value.pvarVal = new VARIANT;
			VariantInit(Variant_value.pvarVal);
			Variant_value.pvarVal->vt = VT_BSTR;
			Variant_value.pvarVal->bstrVal = ::SysAllocString(wstr_temp);

			return 0;
		}

//avidan
		case VT_UINT://UINT
			Variant_value.vt = VT_UINT;
			Variant_value.uintVal = (unsigned int)dbl_value;
			return 0;

		case VT_UI4://ULONG
			Variant_value.vt = VT_UI4;
			Variant_value.ulVal = (unsigned long)dbl_value;
			return 0;

		case VT_UI2://USHORT
			Variant_value.vt = VT_UI2;
			Variant_value.uiVal = (unsigned short)dbl_value;
			return 0;

		case VT_DECIMAL://DECIMAL
			Variant_value.vt = VT_DECIMAL;
			HRESULT hr;
			DECIMAL Decimal;
			hr=VarDecFromI4((long)dbl_value,&Decimal);
			if(SUCCEEDED(hr))
				Variant_value.decVal = Decimal;
			else
				return 1;
			return 0;

		case VT_CY://CY (currency)
			Variant_value.vt = VT_CY;
			HRESULT hr2;
			CY currency;
			hr2=VarCyFromI4((long)dbl_value,&currency);
			if(SUCCEEDED(hr2))
				Variant_value.cyVal = currency;
			else
				return 1;
			return 0;

//end avidan

		default :
			return 1;
	}//switch cache_vt_type



}

int CStaticHelper :: MakeDefaultPropertyCall(JSContext *cx,iJSComPrivateData *pCJSComObject,WLERRORINFO &m_ErrInfo,
																						 VARIANT *retval){

	JSCOM_INVOKE_PARAMS Invoke_Params;
	int ret;


	ret = pCJSComObject->CallDefaultProperty_FillParams(NULL,0,&Invoke_Params);

	if (ret !=0)
		return 1;

	ret = pCJSComObject->CallInvoke(cx,&Invoke_Params,m_ErrInfo,"Default Property");

	if (ret != 0){
		Invoke_Params.invoke_type = DISPATCH_METHOD;

		ret = pCJSComObject->CallInvoke(cx,&Invoke_Params,m_ErrInfo,"Default Method");

		if (ret !=0)
			return 1;
	}

	*retval = Invoke_Params.return_value;

return 0;
}

int CStaticHelper :: JSVAL_TO_VARIANT(JSContext *cx,const jsval jsvalue,
																		int cache_vt_type,VARIANT &Variant_value,
																		WLERRORINFO &m_ErrInfo,
																		iJSComPrivateData *pJSCOMObject){

	WL_JSType wl_jsvalue_type  = WL_JS_TypeOfValue(jsvalue);

	switch(wl_jsvalue_type){

		case WL_JSTYPE_INT:{

			int res= JSInteger2Variant(cx,jsvalue,cache_vt_type,Variant_value);

			if (res != 0){
				FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
				return 1;
			}
			return 0;
		}//case WL_JSTYPE_INT

		case WL_JSTYPE_DOUBLE:{

			//double *dbl_value = JSVAL_TO_DOUBLE(jsvalue);

			int res= JSDouble2Variant(cx,jsvalue,cache_vt_type,Variant_value);

			if (res != 0){
				FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
				return 1;
			}
			return 0;
		}

		case WL_JSTYPE_BOOLEAN:	{

			int res= JSBoolean2Variant(cx,jsvalue,cache_vt_type,Variant_value);

			if (res != 0){
				FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
				return 1;
			}
			return 0;

		}//JSTYPE_BOOLEAN


		case WL_JSTYPE_STRING:	{
//@@Sergei
			if (pJSCOMObject->GetObjectClassName_RW().compareTo("MSSOAP.SoapClient30") == 0 && cache_vt_type == 0)
			{
					cache_vt_type = VT_BSTR | VT_BYREF;
			}
//
			int res= JSString2Variant(cx,jsvalue,cache_vt_type,Variant_value);

			if (res != 0){
				FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
				return 1;
			}
			return 0;
		}

//		case JSTYPE_FUNCTION:
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%% OBJECT BEGIN %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		case WL_JSTYPE_OBJECT:{


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@ JSVAL_IS_NULL(jsvalue) @@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

			if JSVAL_IS_NULL(jsvalue){

				switch(cache_vt_type){

					case VT_EMPTY:
						//used to be bool. changed for 7.5 in 10/10/05 to help JRP (Java)
						if ( g_bJavaRecordingSupported )
						{
							Variant_value.vt = VT_EMPTY;
							return 0;
						}
					case VT_BOOL:
					case VT_VARIANT:
					case VT_USERDEFINED:
						Variant_value.vt = VT_BOOL;
						Variant_value.boolVal = 0;
						return 0;

					case VT_I1:
					case VT_UI1:
						Variant_value.vt = VT_UI1;
						Variant_value.bVal =0;
						return 0;

					case VT_I2:
						Variant_value.vt = VT_I2;
						Variant_value.iVal =0;
						return 0;

					case VT_I4:
						Variant_value.vt = VT_I4;
						Variant_value.lVal =0;
						return 0;

					case VT_INT:
						Variant_value.vt = VT_INT;
						Variant_value.intVal =0;
						return 0;

					case VT_R4:
						Variant_value.vt = VT_R4;
						Variant_value.fltVal =0;
						return 0;

					case VT_R8:
						Variant_value.vt = VT_R8;
						Variant_value.dblVal = 0;
						return 0;


					case VT_BSTR:	{
	 					_bstr_t bstr_temp("null");
						Variant_value.vt = VT_BSTR;
						Variant_value.bstrVal = bstr_temp.copy();
						return 0;
					}

					default :
						FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
						return 1;
				}//switch cache_vt_type
			}//JSVAL_IS_NULL(jsvalue)

			JSString* str = NULL;
			JSObject *js_Object = JSVAL_TO_OBJECT(jsvalue);
			JSClass* pClassOfObj = JS_GetClass(cx, js_Object);


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@ DataTypeWraperClass @@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

			if (JS_InstanceOf(cx,js_Object,&DataTypeWraperClass,NULL)){

				VARIANT *WraperVariant_value = (VARIANT*)JS_GetPrivate(cx, js_Object);
				VariantCopy(&Variant_value,WraperVariant_value);

				return 0;
			}//if "DataTypeWraperClass"


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ ComObjectClass @@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


			else if (JS_InstanceOf(cx,js_Object,&ComObjectClass,NULL)){

//		else if (strcmp(pClassOfObj->name,"ActiveXObject") == 0){

				switch(cache_vt_type){

					case VT_USERDEFINED:
					case VT_DISPATCH:
					case VT_VARIANT:
          //@@Sergei uncomment the following
					//case VT_EMPTY:
					{

						iJSComPrivateData *pCJSComObject_par = (iJSComPrivateData*)JS_GetPrivate(cx, js_Object);
						Variant_value.vt = VT_DISPATCH;
						Variant_value.pdispVal = pCJSComObject_par->GetptrIDispatch().GetInterfacePtr();
						Variant_value.pdispVal->AddRef();
						return 0;
					}

					case VT_UNKNOWN:
					{
						iJSComPrivateData *pCJSComObject_par = (iJSComPrivateData*)JS_GetPrivate(cx, js_Object);
						Variant_value.vt = VT_DISPATCH;
						Variant_value.pdispVal = pCJSComObject_par->GetptrIDispatch().GetInterfacePtr();
						Variant_value.pdispVal->AddRef();

						//should make QueryInterface to IUnknown - currently isn't supported
						return 1;
					}
					//@@Sergei commect the following
          case VT_EMPTY:
					case VT_BYREF|VT_VARIANT :
          {
						iJSComPrivateData *pCJSComObject_par = (iJSComPrivateData*)JS_GetPrivate(cx, js_Object);
			      Variant_value.vt = VT_BYREF|VT_VARIANT;

						Variant_value.pvarVal = new VARIANT;
						VariantInit(Variant_value.pvarVal);
						Variant_value.pvarVal->vt = VT_DISPATCH;
						Variant_value.pvarVal->pdispVal = pCJSComObject_par->GetptrIDispatch().GetInterfacePtr();
						Variant_value.pvarVal->pdispVal->AddRef();
						return 0;
					}

					case VT_I4:
					case VT_I2:
					case VT_UI1:
					case VT_R4:
					case VT_R8:
					case VT_BOOL:
					case VT_BSTR:{

						iJSComPrivateData *pCJSComObject_par = (iJSComPrivateData*)JS_GetPrivate(cx, js_Object);

						VARIANT ret_value;
						int ret;
						VariantInit(&ret_value);

						do {
							 ret = CStaticHelper :: MakeDefaultPropertyCall(cx,pCJSComObject_par,m_ErrInfo,&Variant_value);

							if (ret != 0){
								FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
								return 1;
							}
						}
						while (Variant_value.vt == VT_DISPATCH);
						return 0;

						/*

						switch(ret_value.vt){

							case VT_BSTR:


						}
						*/



					}


					//all the error cases
					default:
						FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
						return 1;
				}	//switch cache_vt_type
			}//Object - ActiveXObject

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Date  @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


			else if (strcmp(pClassOfObj->name,"Date") == 0){

				DATE My_date;

				WORD Year = js_DateGetYear(cx,js_Object);
				WORD Month = js_DateGetMonth(cx,js_Object);///Avidan
				WORD Day = js_DateGetDate(cx,js_Object);

				WORD Hours = js_DateGetHours(cx,js_Object);
				WORD Minutes = js_DateGetMinutes(cx,js_Object);
				WORD Seconds = js_DateGetSeconds(cx,js_Object);

				bool res = CStaticHelper :: MakeDATE(&My_date,Year,Month,Day,Hours,Minutes,Seconds);

				if (!res){
					FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
					return 1;
				}

				switch(cache_vt_type){

					case VT_DATE:
					case VT_EMPTY:
					case VT_VARIANT:{

						Variant_value.vt = VT_DATE;
						Variant_value.date = My_date;
						return 0;
					}

					case VT_BYREF|VT_VARIANT :{
					//case VT_VARIANT :{
			      Variant_value.vt = VT_BYREF|VT_VARIANT;
						VARIANT *Inner_Variant = new VARIANT;
						VariantInit(Inner_Variant);
						Inner_Variant->vt = VT_DATE;
						Inner_Variant->date = My_date;
			      Variant_value.pvarVal = Inner_Variant;
						return 0;
					}

					//all the error cases
					default:
						FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
						return 1;
				}	//switch cache_vt_type
			} //Object - DATE


//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Array @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

//			else if (JS_InstanceOf(cx,js_Object,&js_ArrayClass,NULL)){
			else if (strcmp(pClassOfObj->name,"Array") == 0){

				int type_element_array_we_pass;

//				if ((cache_vt_type == VT_VARIANT) || (cache_vt_type == VT_EMPTY))
				if (cache_vt_type == VT_EMPTY)
					type_element_array_we_pass = VT_EMPTY;

				else {
					if (cache_vt_type & VT_ARRAY)
							type_element_array_we_pass = cache_vt_type & VT_TYPEMASK;

					else {
						FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
						return 1;
					}
				}

				jsuint length;
				if (JS_GetArrayLength(cx, js_Object, &length)){


					VARIANT Variant_array_members_stack[256];

					for (int counter = 0; counter < 256; counter++)
	 					VariantInit(&Variant_array_members_stack[counter]);

					jsint js_counter;
					jsval v;
				//	JSType jsvalue_type;
					int ret;

					m_ErrInfo.m_IsArray = 1;

					for (js_counter = 0; js_counter < (jsint)length; js_counter++) {

						if (JS_GetElement(cx, js_Object, js_counter, &v)) {

							ret = CStaticHelper :: JSVAL_TO_VARIANT(cx,v, type_element_array_we_pass,
																		 Variant_array_members_stack[js_counter],
																		 m_ErrInfo,pJSCOMObject);
							if (ret !=0){
								return 1;
							}
						}
					}//for

					int type_of_created_variant_array =
							CStaticHelper ::IsArrayOfSameTypes(Variant_array_members_stack,length);

					if (type_of_created_variant_array == VT_ERROR){
						CStaticHelper ::FormatErrorArrayConstructionMessage(76,m_ErrInfo);
						//m_ErrInfo.m_ErrorIndex = 76;
						return 1;
					}

					int SafeArray_Type;
					long variant_by_ref = VT_BYREF|VT_VARIANT;

					//can't create a SafeArray of VT_VARIANT|VT_BYREF
					if (type_of_created_variant_array == variant_by_ref)
						SafeArray_Type = VT_VARIANT;
					else
						SafeArray_Type = type_of_created_variant_array;


					if ((SafeArray_Type != type_element_array_we_pass) &&
							(type_element_array_we_pass != VT_EMPTY)){

						CStaticHelper ::FormatErrorArrayConstructionMessage(75,m_ErrInfo);
						//m_ErrInfo.m_ErrorIndex = 75;
						return 1;
					}

					jsint i;
					long sfarray_counter = 0;
					HRESULT hr;

					SAFEARRAYBOUND rgb[]= {length, 0};

					Variant_value.parray = SafeArrayCreate(SafeArray_Type, 1, rgb);

					for (i = 0; i < (jsint)length; i++) {

						switch(type_of_created_variant_array){

							case VT_BYREF|VT_VARIANT:

								hr = SafeArrayPutElement(Variant_value.parray, &i,Variant_array_members_stack[i].pvarVal);

								if (hr != 0){
									CStaticHelper ::FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;

							case VT_VARIANT:
								hr = SafeArrayPutElement(Variant_value.parray, &i,&Variant_array_members_stack[i]);
								//hr = SafeArrayPutElement(Variant_value.parray, &i,Variant_array_members_stack[i].pvarVal);

								if (hr != 0){
									CStaticHelper ::FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;

							case VT_BSTR:

								hr = SafeArrayPutElement(Variant_value.parray, &i,Variant_array_members_stack[i].bstrVal);
								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;

							case VT_UI1:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].bVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}

							case VT_I2:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].iVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;

							}

							case VT_I4:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].lVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}

								break;
							}

							case VT_R4:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].fltVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}

							case VT_R8:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].dblVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}

							case VT_BOOL:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].boolVal);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}


							case VT_DATE:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, &Variant_array_members_stack[i].date);

								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}

							case VT_DISPATCH:{

								hr = SafeArrayPutElement(Variant_value.parray, &i, Variant_array_members_stack[i].pdispVal);
								if (hr != 0){
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
								}
								break;
							}

							default:
									FormatErrorArrayMessage(SafeArray_Type,m_ErrInfo);
									return 1;
						}//switch(array_type)
					}

					Variant_value.vt = VT_ARRAY | SafeArray_Type;
					for (counter = 0; counter < 256; counter++)
					{
						if ((Variant_array_members_stack[counter].vt) == (VT_BYREF|VT_VARIANT))
						{
							VariantClear(Variant_array_members_stack[counter].pvarVal);
						}
 						VariantClear(&Variant_array_members_stack[counter]);
					}
					return 0;
				}//JS_GetArrayLength

			}//Object - Array

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Number @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


			else if (strcmp(pClassOfObj->name,"Number") == 0){

				int res= JSDouble2Variant(cx,jsvalue,cache_vt_type,Variant_value);

				if (res != 0){
					FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
					return 1;
				}
				return 0;
			}



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@ String @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

			else if (strcmp(pClassOfObj->name,"String") == 0){

				int res= JSString2Variant(cx,jsvalue,cache_vt_type,Variant_value);

				if (res != 0){
					FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
					return 1;
				}
				return 0;
			}

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Boolean @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

			else if (strcmp(pClassOfObj->name,"Boolean") == 0){

				int res= JSBoolean2Variant(cx,jsvalue,cache_vt_type,Variant_value);

				if (res != 0){
					FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
					return 1;
				}
				return 0;
			}

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Some Other Object @@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

			else{

				switch(cache_vt_type){

					case VT_I1:
					case VT_UI1:{

						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_UI1;
						Variant_value.bVal =(byte) dbl_value;
						return 0;
					}

					case VT_I2:{
						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_I2;
						Variant_value.iVal =(short) dbl_value;
						return 0;
					}

					case VT_I4:{
						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_I4;
						Variant_value.lVal =(long)dbl_value;
						return 0;
					}

					case VT_INT:{
						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_INT;
						Variant_value.intVal =(int) dbl_value;
						return 0;
					}


					case VT_R4:{
						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_R4;
						Variant_value.fltVal =(float) dbl_value;
						return 0;
					}

					case VT_R8:{
						jsdouble dbl_value;
						JSBool res = JS_ValueToNumber(cx,jsvalue,&dbl_value);
						if (res != JS_TRUE){
							FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
							return 1;
						}
						Variant_value.vt = VT_R8;
						Variant_value.dblVal = dbl_value;
						return 0;
					}

					case VT_BSTR:
					case VT_VARIANT:
					{
						Variant_value.vt = VT_BSTR;
						Variant_value.bstrVal = CStaticHelper :: JS_VALUE2BSTR(cx,jsvalue);
						return 0;
					}

					case VT_BYREF|VT_VARIANT :
					{
						Variant_value.vt = VT_BYREF|VT_VARIANT;
						VARIANT *Inner_Variant = new VARIANT;
						VariantInit(Inner_Variant);
						Inner_Variant->vt = VT_BSTR;
						Inner_Variant->bstrVal = CStaticHelper :: JS_VALUE2BSTR(cx,jsvalue);
						Variant_value.pvarVal = Inner_Variant;
						return 0;
					}

					default :
						FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
						return 1;
				}//switch cache_vt_type
			}//Some Other Object
		} //JSTYPE_OBJECT

		case WL_JSTYPE_VOID:{
			switch(cache_vt_type){

				case VT_EMPTY:
			    //used to be bool. changed for 7.5 in 10/10/05 to help JRP (Java)
					if ( g_bJavaRecordingSupported )
					{
					Variant_value.vt = VT_EMPTY;
			    	return 0;
					}
				case VT_BOOL:
				case VT_VARIANT:
			    Variant_value.vt = VT_BOOL;
			    Variant_value.boolVal = 0;
					return 0;

				case VT_I1:
				case VT_UI1:
			    Variant_value.vt = VT_UI1;
			    Variant_value.bVal =0;
					return 0;

				case VT_I2:
					Variant_value.vt = VT_I2;
			    Variant_value.iVal =0;
					return 0;

				case VT_I4:
			    Variant_value.vt = VT_I4;
			    Variant_value.lVal =0;
					return 0;

				case VT_INT:
			    Variant_value.vt = VT_INT;
			    Variant_value.intVal =0;
					return 0;

				case VT_R4:
					Variant_value.vt = VT_R4;
					Variant_value.fltVal =0;
					return 0;

				case VT_R8:
			    Variant_value.vt = VT_R8;
			    Variant_value.dblVal = 0;
					return 0;


				case VT_BSTR:	{
	 				_bstr_t bstr_temp("undefined");
					Variant_value.vt = VT_BSTR;
					Variant_value.bstrVal = bstr_temp.copy();
					return 0;
				}

				default :
					FormatErrorParameterMessage(cache_vt_type,wl_jsvalue_type,m_ErrInfo);
					return 1;
			}//switch cache_vt_type
		}//WL_JSTYPE_VOID



		case WL_JSTYPE_ERROR:
			m_ErrInfo.m_ErrorIndex = 90;
			m_ErrInfo.m_ErrorDescription = "Illegal Data Type of Parameter";
		//default :
			return 1;
	} //switch wl_jsvalue_type (global)

return 0;
}





