/* WebLOAD Open Source is an automated quality assurance testing tool for internet applications.
 * Copyright (C) 1996 Radview Software, Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it 
 * only under the terms of Version 2 of the GNU General Public License as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; Without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along 
 * with this program; If not, you can download it from 
 * http://www.gnu.org/licenses/
 *
 */
  
#include "stdafx.h"
//#include <iostream.h>
#include "HashDictionaries.h" 
#include "tracedll.h"

#pragma warning(disable: 4244)//???


int iJSComPrivateData :: FindGuid(WLERRORINFO &m_ErrInfo){


  LONG ret;
  HKEY keyHandle;
  HKEY hKey;

  unsigned char valueName[500]="";
  DWORD Type;
  DWORD valueNameSize;
  char key_name_to_open[500] = "SOFTWARE\\Classes\\";

	  // builds the "full" regestry key name to open
	  strcat(key_name_to_open,m_ClassName_RW.data());
	  strcat(key_name_to_open,"\\CLSID");

      if (m_RemoteConnection){
        char tmp[250] = "\\\\";
        strcat(tmp,m_RemoteComputerName_RW.data());
        ret = RegConnectRegistry(tmp,HKEY_LOCAL_MACHINE,&hKey);
      }

      else
        ret = RegConnectRegistry(NULL,HKEY_LOCAL_MACHINE,&hKey);

	      if (ret != ERROR_SUCCESS) {
					m_ErrInfo.m_ErrorIndex = 5;
		      //cerr << "Unable to connect local / remote HKEY_LOCAL_MACHINE " << endl;
		      return 1;
        }


	  ret=RegOpenKeyEx(hKey, key_name_to_open, 0,
					  KEY_QUERY_VALUE, &keyHandle);

	  if (ret != ERROR_SUCCESS) {
		  //cerr << "Unable to open " <<key_name_to_open <<" key"<< endl;
			m_ErrInfo.m_ErrorIndex = 6;
			m_ErrInfo.m_ErrorDescription = key_name_to_open;
		  return 1;
	  }

  valueNameSize = sizeof(valueName);


  ret = RegQueryValueEx(keyHandle,NULL,NULL,&Type,
                        valueName,&valueNameSize);

  if (ret != ERROR_SUCCESS) {
		m_ErrInfo.m_ErrorIndex = 7;
		//cerr << "Unable to query value from a key "<< endl;
		return 1;
  }

  strcpy(m_ObjectGUID_string,(char*) valueName);

	//cout<<"GUID is : " <<m_ObjectGUID_string<<endl;


	return 0;

}
/*
int  iJSComPrivateData :: ConvertGUID(){//NOT IN USE


	char buf1[2];
	char *stopstring;
	char guid_buffer[50];


	strcpy(guid_buffer,m_ObjectGUID_string);
	const char *ptr_guid  = &guid_buffer[0];


	ptr_guid++;

    m_ObjectGUID_UUID.Data1 =  strtoul(ptr_guid,&stopstring,16);

	ptr_guid+=9;

    m_ObjectGUID_UUID.Data2 = strtoul(ptr_guid,&stopstring,16);

	ptr_guid+=5;

    m_ObjectGUID_UUID.Data3 = strtoul(ptr_guid,&stopstring,16);

	ptr_guid+=5;

	strncpy(buf1,ptr_guid,2);

	 m_ObjectGUID_UUID.Data4[0] = strtoul((const char*)buf1,&stopstring,16);
	 strcpy(buf1,"  ");
	
	ptr_guid+=2;
	strncpy(buf1,ptr_guid,2);
	//cout<<"Buf1 :"<<buf1<<endl;

	m_ObjectGUID_UUID.Data4[1] = strtoul((const char*)buf1,&stopstring,16);
	strcpy(buf1,"  ");

	ptr_guid+=3;

	for (int i = 2; i < 8; i++){

		strncpy(buf1,ptr_guid,2);
		m_ObjectGUID_UUID.Data4[i] = strtoul((const char*)buf1,&stopstring,16);
		strcpy(buf1,"  ");
		ptr_guid+=2;

	}

	//cout<<"Data1 :"<<m_ObjectGUID_UUID.Data1<<endl;
	//cout<<"Data2 :"<<m_ObjectGUID_UUID.Data2<<endl;
	//cout<<"Data3 :"<<m_ObjectGUID_UUID.Data3<<endl;

	//for (int j = 0; j < 8; j++)
	//		cout<<"Data4-"<<j<<" = "<<m_ObjectGUID_UUID.Data4[j]<<endl;

	return 0;
}
*/
//{CADF6B2E-C20D-11D3-9572-0090271C2713}

int iJSComPrivateData :: CreateObject(){

	HRESULT hr;
//	CComPtr<IDispatch> ptrIDispatch;// MSDN : ATL uses CComPtr and CComQIPtr to manage COM interface pointers. 
																	// Both classes perform automatic reference counting through calls to AddRef and Release
	USES_CONVERSION;
	

//	m_ptrIDispatch = IDispatch(IID_IDispatch);
	
  if (!m_RemoteConnection){
//	  hr = CoCreateInstance(m_ObjectGUID_UUID,NULL,CLSCTX_SERVER,
	//	  IID_IDispatch, (void**)&m_ptrIDispatch);
	  hr = m_ptrIDispatch.CreateInstance(m_ObjectGUID_UUID,NULL,CLSCTX_SERVER);//@@CComPtr


   	if (FAILED(hr))
    {
      WlTraceMsg("iJSComPrivateData :: CreateObject - CreateInstance() failed for %s", m_ClassName_RW.data());
  		return 1;
    }
  }

  else {

    COSERVERINFO serverinfo;
    COSERVERINFO* pServerInfo;

    serverinfo.dwReserved1 = 0;
    serverinfo.dwReserved2 = 0;

    USES_CONVERSION;
    serverinfo.pwszName = A2OLE(m_RemoteComputerName_RW.data());
    serverinfo.pAuthInfo = NULL;

    pServerInfo = &serverinfo;

    MULTI_QI qi = {&IID_IUnknown, NULL, 0};

    hr = CoCreateInstanceEx(m_ObjectGUID_UUID, NULL,  CLSCTX_SERVER,
							    pServerInfo, 1, &qi);

    if (FAILED(hr))
    {
      WlTraceMsg("iJSComPrivateData :: CreateObject - CoCreateInstanceEx() failed for %s", m_ClassName_RW.data());
	    return 1;
    }

		//hr = qi.pItf->QueryInterface(IID_IDispatch,(void**)&m_ptrIDispatch);//@@CComPtr
		try {
			m_ptrIDispatch = qi.pItf;//@@CComPtr
		}
		catch(_com_error & e) {
			WlTraceMsg ( "Error : exception occured in the function iJSComPrivateData :: CreateObject" + e.Description() );//@@avidan add error		
			return 1;
		}

		//if (FAILED(hr))
			//return 1;
  }

	LPOLESTR GUID_String_OLE;
	hr = StringFromCLSID(m_ObjectGUID_UUID,&GUID_String_OLE);
	strcpy(m_ObjectGUID_string,OLE2A(GUID_String_OLE));
	CoTaskMemFree(GUID_String_OLE);

	if (strcmp("{BD96C556-65A3-11D0-983A-00C04FC29E36}",m_ObjectGUID_string) == 0)
		m_RDS_Status = RDS_OBJECT; //This is a RDS Object
	else
		m_RDS_Status = STANDARD_OBJECT; //This is a Standard Object

	return 0;
}



/*
int iJSComPrivateData :: CreateObject(){

	HRESULT hr;
  CComPtr<IUnknown> ptrIUnknown;

	//hr = CoInitialize(NULL);

  if (!m_RemoteConnection){
	  hr = CoCreateInstance(m_ObjectGUID_UUID,NULL,CLSCTX_SERVER,
		  IID_IUnknown, (void**)&ptrIUnknown);


   	if (FAILED(hr))
  		return 1;
  }

  else {

    COSERVERINFO serverinfo;
    COSERVERINFO* pServerInfo;

    //CoInitialize (NULL);

    serverinfo.dwReserved1 = 0;
    serverinfo.dwReserved2 = 0;

    USES_CONVERSION;
    serverinfo.pwszName = A2OLE(m_RemoteComputerName_RW.data());
    serverinfo.pAuthInfo = NULL;

    pServerInfo = &serverinfo;

    MULTI_QI qi = {&IID_IUnknown, NULL, 0};

    hr = CoCreateInstanceEx(m_ObjectGUID_UUID, NULL,  CLSCTX_SERVER,
							    pServerInfo, 1, &qi);

    if (FAILED(hr))
	    return 1;

    ptrIUnknown.Attach(qi.pItf);

    if (ptrIUnknown == 0)
      return 1;

  }


	hr = ptrIUnknown->QueryInterface(IID_IDispatch,(void**)&m_ptrIDispatch);

	if (FAILED(hr))
		return 1;

	ptrIUnknown.Release();

	if (strcmp("{BD96C556-65A3-11D0-983A-00C04FC29E36}",m_ObjectGUID_string) == 0)
		m_RDS_Status = RDS_OBJECT; //This is a RDS Object
	else
		m_RDS_Status = STANDARD_OBJECT; //This is a Standard Object

	return 0;
}
*/


/*
HRESULT iJSComPrivateData :: hrGetLastError(){
	return(m_hrLastError);
}
*/
void iJSComPrivateData :: SetptrIDispatch(IDispatchPtr& spIDispatch_){
	m_ptrIDispatch = spIDispatch_;//??? is there a problem with mulyui threding?
//	m_ptrIDispatch->AddRef();//@@CComPtr
	if( m_ptrIDispatch != NULL ) {
		m_pObjectsCache->GetTypeInfo(this);//@@ for FTPlayBack
	}
}

//The one that call the function GetPtrIDispatch is responsible for the reference counter.
IDispatchPtr iJSComPrivateData :: GetptrIDispatch(){
	return m_ptrIDispatch;
}
/*
IDispatch* iJSComPrivateData :: GetptrIDispatch_WithoutAddref(){//???ASK VADIM
	return(m_ptrIDispatch);
}
*/
void iJSComPrivateData :: Set_ptr_methods_cache(CMethodsHashDictionary *ptr_methods_cache_){//???
  m_pMethodsCache = ptr_methods_cache_;
}

HRESULT iJSComPrivateData :: PtrIUnknown2PtrIDispatch(IUnknown *ptrIUnknown,
								 IDispatch **ptrIDispatch){


HRESULT hr = ptrIUnknown->QueryInterface(IID_IDispatch,(void**)ptrIDispatch);

return hr;
}


void iJSComPrivateData :: SetTypeInfoExists(BOOL TypeInfoExists){
	m_TypeInfoExists = TypeInfoExists;
}

BOOL iJSComPrivateData :: GetTypeInfoExists(){
	return m_TypeInfoExists;
}

void iJSComPrivateData :: SetRDS_Status(Object_RDS_Status status){
	m_RDS_Status = status;
}

Object_RDS_Status iJSComPrivateData :: GetRDS_Status(){
	return m_RDS_Status;
}


void iJSComPrivateData :: SetObjectClassName_RW(const char* ClassName_RW){
	m_ClassName_RW = ClassName_RW;
}

RVCString iJSComPrivateData :: GetObjectClassName_RW(){
	return(m_ClassName_RW);

}
/*

EXCEPINFO *iJSComPrivateData :: GetExceptionInfo(){
	return (m_pExcepInfo);
}

void iJSComPrivateData :: SetExceptionInfo(EXCEPINFO *pexcepinfo){
	m_pExcepInfo = pexcepinfo;
}
*/

//WHILE A COM OBJECT WAS CREATED OUT OF THE AGENDA WE DON'T KNOW IT'S NAME.
//THIS FUNCTION CREATE A STRING THAT DESCRIBE A METHOD THAT WAS CALL ON THESE 
//KIND OF OBJECTS.
void iJSComPrivateData :: ConcatImplicitObjectMethod(const char* father_obejctName,
																								const char* MethodName){

	char NewClassName[1024];
	sprintf(NewClassName,"%s.%s",father_obejctName,MethodName);
	m_ClassName_RW = NewClassName;
}

